// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/ORG/opengroup/adl/jbcfile/ClassFileException.java,v $
// $Revision: 1.3 $
// $Date: 1998/02/27 12:34:14 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   symboltable
// NAME:        ClassFileException.java
//
// HISTORY:
//      Cyril Inard d'Argence, TOG - Oct 29,  1997: Created
//      See Log at end of file
//
// ***********************************************************************


package ORG.opengroup.adl.jbcfile;

/**
 *  Exception that should be thrown when trying to read bytecode that is
 *  not that of the expected java class. The inconsistency is discovered
 *  by comparing the expected scoped name of the class with the 
 *  class scoped name found in the bytecode.
 */

public class ClassFileException extends Exception
{
   /**
    * Constructs the exception. 
    */
   public ClassFileException() 
   {
      super();
   }

   /**
    * Constructs the exception. 
    * @param s the detailed message.
    */
   public ClassFileException(String s) 
   {
      super(s);
   }
}

// ***********************************************************************
// History Log:
// $Log: ClassFileException.java,v $
// Revision 1.3  1998/02/27 12:34:14  cinard
// Cleaned up the API for jbcfile components by introducing a user friendly
// representation for bytecode types (BCType class).
// Updated copyright notice.
//
// Revision 1.2  1998/02/12 16:01:53  mallet
// Fixed copyright notice: TOG RI -> TOG, year extended to 1998 for TOG
// and IPA.
//
// Revision 1.1  1998/01/28 18:11:28  cinard
// Added a check when importing java class bytecode (qualified name of java class
// must be equals to the qualified name in the bytecode).
//
// ***********************************************************************
