// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/ORG/opengroup/adl/jbcfile/RuntimeConstants.java,v $
// $Revision: 1.3 $
// $Datei$
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   jbcfile
// NAME:        RuntimeConstants.java
//
// HISTORY:
//      Cyril Inard d'Argence, TOG - Jan 27,  1998: Created
//      See Log at end of file
//
// ***********************************************************************

package ORG.opengroup.adl.jbcfile;

/**
 * Runtime constants are constants used to tag entries in the
 * bytecode constant pool.
 */

public interface RuntimeConstants
{
  static final int CONSTANT_CLASS            =  7;
  static final int CONSTANT_FIELD            =  9;
  static final int CONSTANT_METHOD           = 10;
  static final int CONSTANT_INTERFACEMETHOD  = 11;
  static final int CONSTANT_STRING           =  8;
  static final int CONSTANT_INTEGER          =  3;
  static final int CONSTANT_FLOAT            =  4;
  static final int CONSTANT_LONG             =  5;
  static final int CONSTANT_DOUBLE           =  6;
  static final int CONSTANT_NAMEANDTYPE      = 12;
  static final int CONSTANT_UTF8             =  1;
  static final int CONSTANT_UNICODE          =  2;
}

// ***********************************************************************
// History Log:
// $Log: RuntimeConstants.java,v $
// Revision 1.3  1998/02/27 12:34:15  cinard
// Cleaned up the API for jbcfile components by introducing a user friendly
// representation for bytecode types (BCType class).
// Updated copyright notice.
//
// Revision 1.2  1998/02/12 16:01:54  mallet
// Fixed copyright notice: TOG RI -> TOG, year extended to 1998 for TOG
// and IPA.
//
// Revision 1.1  1998/01/27 13:28:17  cinard
// Runtime constants (used to read bytecode).
//
// ***********************************************************************
