// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/ORG/opengroup/adl/jbcfile/attributeInfo.java,v $
// $Revision: 1.7 $
// $Date: 1998/02/27 12:34:15 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   jbcfile
// NAME:        attributeInfo.java
//
// HISTORY:
//      Christian Fabre,      
//      Cyril Inard d'Argence, TOG - Nov 06,  1997: Created
//      See Log at end of file
//
// ***********************************************************************

package ORG.opengroup.adl.jbcfile;

import java.io.DataInputStream;

/**
 * Java bytecode attributeInfo.
 */

public class attributeInfo implements RuntimeConstants
{
  private static utf8 code = new utf8("Code");
  private static utf8 excp = new utf8("Exceptions");

  public int   number_of_exceptions  =  0;
  public int[] exception_index_table = null;

  public static attributeInfo[] newAttributes(DataInputStream classFile, 
                                              int attributeCount,
                                              cpInfo CP[])
     throws java.io.IOException
  {

     attributeInfo[] ret = null;

    if ( ClassFile.debug )
       System.out.println
       ("newAttributes(<file>,"+attributeCount+", CP (len="+CP.length+"))");

    for ( int i = 0 ; i < attributeCount ; i++ )
    {
       int index = classFile.readUnsignedShort();
       int attribute_length = classFile.readInt();
       
       if ( index >= CP.length )
          throw new Error("i="+i+"  CP.length="+CP.length+"  index="+index);
       
       if ( CP[index] instanceof utf8 && ((utf8)CP[index]).equals(code) )
       {
          // We are in a Code_Attribute structure, read the length
          // of the code and print it out.
          classFile.skip(4);
          int codeLen = classFile.readInt();  // Read an unsigned int.
          classFile.skip(codeLen);
          if ( ClassFile.debug )
             System.out.println("Code is "+codeLen);
          int exctableLen = classFile.readUnsignedShort();
          classFile.skip(8*exctableLen);
          if ( ClassFile.debug )
             System.out.println("ExcpTable is "+(8*exctableLen));
          int attrCount = classFile.readUnsignedShort();
          attributeInfo.newAttributes(classFile,attrCount,CP);
       }
       else if ( CP[index] instanceof utf8 && ((utf8)CP[index]).equals(excp) )
       {
          // We are in a Exception_Attribute
          // collect the exceptions
          ret = new attributeInfo[1];
          ret[0] = new attributeInfo();
          ret[0].number_of_exceptions = classFile.readUnsignedShort();
          ret[0].exception_index_table = new int[ret[0].number_of_exceptions];
          for ( int j = 0; j < ret[0].number_of_exceptions; j++ )
          {
             ret[0].exception_index_table[j] = classFile.readUnsignedShort();
          }
       }
       else
       {
          // We are in another sort of attribute, so skip it.
          classFile.skipBytes(attribute_length);
       }
    }
    
    return ret;
  }
  
  public String toString(String indent)
  {
     return indent + toString();
  }
}

// ***********************************************************************
// History Log:
// $Log: attributeInfo.java,v $
// Revision 1.7  1998/02/27 12:34:15  cinard
// Cleaned up the API for jbcfile components by introducing a user friendly
// representation for bytecode types (BCType class).
// Updated copyright notice.
//
// Revision 1.6  1998/02/12 16:01:55  mallet
// Fixed copyright notice: TOG RI -> TOG, year extended to 1998 for TOG
// and IPA.
//
// Revision 1.5  1998/01/27 13:07:20  cinard
// The jbcfile package no longer make use of the sun.tools.java package.
// An interface RuntimeConstants defines the bytecode constants now.
//
// Revision 1.4  1998/01/12 13:18:25  cinard
// Updated and fixed javadoc comments.
//
// Revision 1.3  1997/12/19 21:14:45  cinard
// Added extraction of thrown clause in bytecode.
//
// Revision 1.2  1997/11/26 15:49:10  cinard
// Improved Makefile. Changed package name.
//
// Revision 1.1  1997/11/12 12:14:39  cinard
// Tool classes  enabling to read java bytecode.
//
// ***********************************************************************
