// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/ORG/opengroup/adl/jbcfile/utf8.java,v $
// $Revision: 1.5 $
// $Date: 1998/02/27 12:34:17 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   jbcfile
// NAME:        utf8.java
//
// HISTORY:
//      Christian Fabre,      TOG - Nov 06,  1997: Created
//      See Log at end of file
//
// ***********************************************************************

package ORG.opengroup.adl.jbcfile;

/**
 * Useful for utf8 entries in the constant pool.
 */

public class utf8 extends cpInfo
{
  private byte[] val;

  public utf8(byte Val[])
  {
    val = new byte[Val.length];

    System.arraycopy(Val,0,val,0,val.length);
  }

  public utf8(String str)
  {
    // Warning, this is not unicode->utf8 translation...

    val = new byte[str.length()];

    for( int i = 0 ; i < val.length ; i++ )
      val[i] = (byte)str.charAt(i);
  }
  
  public boolean equals(utf8 other)
  {
    if ( other == null )
      return false;

    if ( other.val.length != val.length )
      return false;

    for( int i = 0 ; i < val.length ; i++ )
      if ( other.val[i] != val[i] )
	return false;

    return true;
  }

  public String toString()
  {
    // Warning, this is not utf8->unicode translation...

    if ( val == null )
      return "<null>";

    char arr[] = new char[val.length];

    for( int i = 0 ; i < arr.length ; i++ )
      {
	arr[i] = (char)( 0xff & val[i] );
      }

    return new String(arr);
  }
}

// ***********************************************************************
// History Log:
// $Log: utf8.java,v $
// Revision 1.5  1998/02/27 12:34:17  cinard
// Cleaned up the API for jbcfile components by introducing a user friendly
// representation for bytecode types (BCType class).
// Updated copyright notice.
//
// Revision 1.4  1998/02/12 16:01:56  mallet
// Fixed copyright notice: TOG RI -> TOG, year extended to 1998 for TOG
// and IPA.
//
// Revision 1.3  1998/01/12 13:18:27  cinard
// Updated and fixed javadoc comments.
//
// Revision 1.2  1997/11/26 15:49:11  cinard
// Improved Makefile. Changed package name.
//
// Revision 1.1  1997/11/12 12:14:40  cinard
// Tool classes  enabling to read java bytecode.
//
// ***********************************************************************
