// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ************************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/ORG/opengroup/adl/parsers/CycleException.java,v $
// $Revision: 1.1 $
// $Date: 1998/02/27 15:30:25 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   ADL Parser
// NAME:        CycleException.java
//
// HISTORY:
//      Cyril Inard d'Argence, The Open Group RI - Dec 23, 1997: Created
//
// ************************************************************************

package ORG.opengroup.adl.parsers;

import java.util.Vector;

/**
 * Thrown when cycles are detected. Carries the objects in the cycle.
 */
public class CycleException extends Exception
{
  public CycleException(Vector cycle)
  {
     this.cycle = cycle;
  }

  public Vector getCycle() { return cycle; }

  private Vector cycle;
}

// ***********************************************************************
// History Log:
// $Log: CycleException.java,v $
// Revision 1.1  1998/02/27 15:30:25  cinard
// CycleDetector made more robust (several cycles can be detected now) and
// moved to parser module.
//
// ***********************************************************************
