// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// Copyright (c) 1996-1997 Sun Microsystems Inc.
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ************************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/ORG/opengroup/adl/parsers/MissingSetterMethodException.java,v $
// $Revision: 1.5 $
// $Date: 1998/02/27 12:57:27 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   AST
// NAME:        MissingSetterMethodException.java
//
// HISTORY:
//      Rob Duncan, Sun Microsystems Inc. - Feb 22, 1997: Created
//
// ************************************************************************

package ORG.opengroup.adl.parsers;

/**
 * This class defines the exception that is raised when a property of an
 * object has a getter method but no setter.
 *
 * @see ORG.opengroup.adl.parsers.PropertySet
 */
public class MissingSetterMethodException extends PropertyAccessException {
  /** the object holding the incorrect property */
  private Object object;
  /** the key to access the incorrect property */
  private Object key;

  /**
   * Basic constructor: initializes <code>object</code> and <code>key</code>.
   *
   * @param n the object holding the incorrect property
   * @param k the key to access the incorrect property
   */
  public MissingSetterMethodException(Object n, Object k) {
    object = n;
    key = k;
  }

  /**
   * Returns a descriptive message for the exception.
   *
   * @return a string describing the reason for the exception
   */
  public String getMessage() {
    return "Object " + object + 
      " has a getter method but no setter method for property " + 
      key + ".";
  }
}
