// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// Copyright (c) 1996-1997 Sun Microsystems Inc.
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ************************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/ORG/opengroup/adl/parsers/PropertyAccessException.java,v $
// $Revision: 1.5 $
// $Date: 1998/02/27 12:57:28 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   AST
// NAME:        PropertyAccessException.java
//
// HISTORY:
//      Rob Duncan, Sun Microsystems Inc. - Feb 22, 1997: Created
//
// ************************************************************************

package ORG.opengroup.adl.parsers;

/**
 * This class is the root class for all exceptions raised while trying
 * to set or get a property on an object.
 *
 * @see ORG.opengroup.adl.parsers.PropertySet
 */
public class PropertyAccessException extends Exception {
  /** the detail of the exception */
  private String detail;

  /**
   * Basic constructor: initializes a default detail message.
   */
  public PropertyAccessException()
  {
    detail = "Can't access property.";
  }

  /**
   * Basic constructor specifying a detail message.
   *
   * @param d the string providing the detail message
   */
  public PropertyAccessException(String d) {
    detail = d;
  }

  /**
   * Basic constructor specifying an exception that provides a detail
   * message.
   *
   * @param e the string providing the detail message
   */
  public PropertyAccessException(Exception e)
  {
    detail = e.getMessage();
    fillInStackTrace();
  }

  /**
   * Returns a descriptive message for the exception.
   *
   * @return a string describing the reason for the exception
   */
  public String getMessage()
  {
    return detail;
  }
}
