// Copyright(c) 1997-1998 The Open Group.
// Copyright(c) 1994-1997 Sun Microsystems Inc.
// Copyright(c) 1994-1998 Information-technology Promotion Agency, Japan
//
// Permissions to use, copy, modify and distribute this software are
// governed by the terms and conditions set forth in the file COPYRIGHT,
// located in the ADLT release package.
//
//
// ************************************************************************
//
// $Revision: 1.3 $
// $Date: 1998/04/28 13:35:37 $
// PRODUCT:	Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:	ADL for C parser
// NAME:        ASTDeclarationSpecifiers.java
//
// HISTORY:
//      Cyril Inard d'Argence, The Open Group RI . - Apr 8, 1998: Created
// 	
// ************************************************************************

package ORG.opengroup.adl.parsers.adlc;

import ORG.opengroup.adl.symboltable.*;
import ORG.opengroup.adl.symboltable.c.*;

public class ASTDeclarationSpecifiers extends SimpleNode {
  public ASTDeclarationSpecifiers(int id) {
    super(id);
  }

  public ASTDeclarationSpecifiers(ADLCParser p, int id) {
    super(p, id);
  }

  public static Node jjtCreate(int id) {
      return new ASTDeclarationSpecifiers(id);
  }

  public static Node jjtCreate(ADLCParser p, int id) {
      return new ASTDeclarationSpecifiers(p, id);
  }


  /** Accept the visitor. **/
  public Object jjtAccept(ADLCParserVisitor visitor, Object data) {
    return visitor.visit(this, data);
  }

  /** Get the declaration specifier type. */
  public LType getType() { return _type; }
  
  /** Set the declaration specifier type. */
  public void setType(LType type) 
  {
     _type = type; 
  }

  /** Get the declaration specifier modifier. */
  public int getModifier() { return _modifier; }

  /** Set the declaration specifier modifier. */
  public void setModifier(int modifier) { _modifier = modifier; }

  /** Declaration specifier type. */
  private LType _type;

  /** Declaration specifier modifier. */
  private int _modifier;

}
