// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ************************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/ORG/opengroup/adl/parsers/adlc/BadTypeException.java,v $
// $Revision: 1.1 $
// $Date: 1998/04/28 15:32:49 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   AST
// NAME:        BadTypeException.java
//
// HISTORY:
//     Cyril Inard d'Argence, The Open Group - Dec 10, 1997: Created
//
// ************************************************************************

package ORG.opengroup.adl.parsers.adlc;

public class BadTypeException extends Exception
{

  BadTypeException(SimpleNode errorNode, String message)
  {
     super(message);
     _errorNode = errorNode;
  }

  BadTypeException(int errorIndex, String message)
  {
     super(message);
     _errorIndex = errorIndex;
  }

  public void setErrorNode(TypedNode node)
  {
     _errorNode = node;
  }

  public SimpleNode getErrorNode()
  {
     return _errorNode;
  }
  
  public int getErrorIndex()
  {
     return _errorIndex;
  }

  /** Index of erroneous type (if error was detected in an array of LType). */
  private int _errorIndex = 0;

  /** TypedNode where the error occured. */
  private SimpleNode _errorNode = null;

}

// ************************************************************************
// $Log: BadTypeException.java,v $
// Revision 1.1  1998/04/28 15:32:49  cinard
// Thrown when a type check error is encountered.
//
// ************************************************************************
