// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTADLAssGrp.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG - November,97:Introduced Parsing methods
//
// NB : The node is created when the assertion is an ADL_Expression
// ***********************************************************************

package ORG.opengroup.adl.parsers.adlcpp;
import ORG.opengroup.adl.symboltable.*;
import ORG.opengroup.adl.symboltable.c.*;
import ORG.opengroup.adl.parsers.*;


public class ASTADLAssGrp extends SimpleNode implements Typed {


  public ASTADLAssGrp(int id) {
    super(id);
  }

  public ASTADLAssGrp(ADLCPPParser p, int id) {
    super(p, id);
  }

  public static Node jjtCreate(int id) {
      return new ASTADLAssGrp(id);
  }

  public static Node jjtCreate(ADLCPPParser p, int id) {
      return new ASTADLAssGrp(p, id);
  }


  /* Called by TypeCheckvisitor to store the recovered type as a property
   */ 

  public void setType( LType visitorType) {
  
    try {
      setProperty("type", visitorType);
    } catch (PropertyAccessException e) {
    }
  }

  /** Implements getType of Typed Interface
   * returns the Type of the Assertion Group
   * The Type check Visitor sets the type as a node property : 2 cases
   * - if number children = 0 => return boolType;
   * - Else return type property stored at type check visit time
   */
 public LType getType()  {

   LType restype= (LType) stm.getSymbol("bool");

   try {
     restype=  (LType) getProperty("type");
   } catch (PropertyAccessException e) {
   }
   return restype;
 }

     
 

  

  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {

    return visitor.visit(this, data);
   
  }
}
