// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTADLBhvClassification.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG-November,97:Modified to Introduce Parsing methods
//     
//
// ***********************************************************************

package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.parsers.*;

public class ASTADLBhvClassification extends SimpleNode {
  public ASTADLBhvClassification(int id) {
    super(id);
  }

  public ASTADLBhvClassification(ADLCPPParser p, int id) {
    super(p, id);
  }

  public static Node jjtCreate(int id) {
      return new ASTADLBhvClassification(id);
  }

  public static Node jjtCreate(ADLCPPParser p, int id) {
      return new ASTADLBhvClassification(p, id);
  }

  /* Called to store if the first child was a NORMAL or ABNORMAL definition
   * This property is needed to transform (Ab)Normal Node with their definition
   */
  public void setFirstChildKind( String str) {
    
    try {
      setProperty("Child1kind", str);
    } catch (PropertyAccessException e) {
    }
  }    

  public String getFirstChildKind() {

    try {
      return (String) getProperty("Child1kind");
    } catch (PropertyAccessException e) {
      return "NORMAL";
    }

  }


  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }
}
