// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTIdExpr.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG -November,97: Added Parsing methods
//
//
// ***********************************************************************

package ORG.opengroup.adl.parsers.adlcpp;

import java.util.Vector ;
import ORG.opengroup.adl.parsers.ParseException;
import ORG.opengroup.adl.symboltable.*;
import ORG.opengroup.adl.symboltable.c.*;


public class ASTADLBinding extends SimpleNode {

  /* Boolean field set by the parser telling if the binding looks like :
   * "define Named with ADLExpression" => false 
   * or "define NamedParam with ID = ADLExpression
   */
  public LExpression initializedBinding = null ;
  /** Handles defined binding variables excluding the initialized one*/
  private Vector bindings ;
  
  public ASTADLBinding(int id) {
    super(id);
  }

  public ASTADLBinding(ADLCPPParser p, int id) {
    super(p, id);
  }

  /** Sets the value of the binding variables vector */
  public void saveBindings( Vector bds ) 
  {
    bindings = bds ;
  }

  /** Saves the initailezd binding if any */
  public void setInitialized( LExpression init ) 
  {
    initializedBinding = init ;
  }

  /** Return vector of defined bindings excluding the initialized one */ 
  public Vector getBindings ()
  {
    return bindings ;
  }

  /** Return the initialized binding. Might be null if none is initialized */
  public LExpression getInitialized()
  {
    return initializedBinding;
  }

  public static Node jjtCreate(int id) {
      return new ASTADLBinding(id);
  }

  public static Node jjtCreate(ADLCPPParser p, int id) {
      return new ASTADLBinding(p, id);
  }




  /** Returns type of the initialized binding if any. Else null */
  public LType getBindingType() {

    if ( initializedBinding != null )
      return initializedBinding.getType() ;
    else
      return null ;
  }



  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }
}
