// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTADLClass.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG - November 4th,  1997: Updated
//     
//
// ***********************************************************************

package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.symboltable.*;
import ORG.opengroup.adl.symboltable.c.*;
import ORG.opengroup.adl.parsers.*;

public class ASTADLClass extends SimpleNode {
  public ASTADLClass(int id) {
    super(id);
  }

  public ASTADLClass(ADLCPPParser p, int id) {
    super(p, id);
  }

  public static Node jjtCreate(int id) {
      return new ASTADLClass(id);
  }

  public static Node jjtCreate(ADLCPPParser p, int id) {
      return new ASTADLClass(p, id);
  }




  /* called by the parser to open the Scope of the ADL Class
   * Stores ADL Class Scope as property of the Node.
   * This proprety will be used to update visitor scopes in Type checking
   */
  public void openAdlClassScope( ADLClass myADLclass) {
    stm.setCurrentScope(stm.getUnitScope());
     stm.openScope( myADLclass);
     setScope( stm.getCurrentScope() );
  }


  public void closeAdlClassScope() {
     
     stm.closeScope();
  }


  /** Constructs the ADL class to be tested. Operates checking.
   * returns the constructed Type as a reseult
   */ 
  public ADLClass MakeUpADLClass( String className, ADLClass myAdlclass ) 
  throws ParseException {

    setADLClassName( className );
    // VERify if a C++ Class has been declared with the same name.


    LClass myCPPclass = stm.getClass(className,myAdlclass);
    if(myCPPclass == null) {
      String msgerror= "Error : Undefined C++ Class " + className;
      errorMessage(msgerror);
    }
    
    // set tested class
    myAdlclass.setLClass(myCPPclass);

    // TBD ADLClass myAdlclass = sbf.newADLClass( myCPPclass, null);
    // try {
    //       myAdlclass = (ADLClass) stm.putSymbol(myAdlclass);
    //     } catch( SymbolAlreadyDefinedException e) {
    //       errorMessage(" Error : redefinition of ADLClass");
    // }
    // stores the name of the ADL class

    if( myAdlclass==null)
  errorMessage(" Error can not store ADLClass");

   return myAdlclass;


  }

  /** Stores the ADL class name as a property of the Node. */
  public void setADLClassName(String id)
  {
    try {
      setProperty("ADLclassname", id);
    } catch (PropertyAccessException e) {
    }
  }

 
  /** called by the unparser to return ADL class name  */  
  public String getName()
  {
    try {
      return (String)getProperty("ADLclassname");
    } catch (PropertyAccessException e) {
    return ""; }
  }



  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }

  //______________________ private fields ________________________________

  /** boolean set to true when debug display required */
  private boolean debug = true;



}
