// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTADLDomain.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG -October,97:Modified to Introduce Parsing methods
//     
//
// ***********************************************************************
package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.symboltable.LExpression ;
import ORG.opengroup.adl.parsers.*;

public class ASTADLDomain extends SimpleNode  {
  public ASTADLDomain(int id) {
    super(id);
  }

  public ASTADLDomain(ADLCPPParser p, int id) {
    super(p, id);
  }


  /** Saves ADL Domain named parameter as a node property */
  public void setNamedParam( LExpression var ) {
    try {
      setProperty("param", var);
    } catch (PropertyAccessException e) {
    }
  }
 
  /** Returns Named Parameter variable saved as a node property */
  public LExpression getNamedParam() {
    try {
      return  (LExpression) getProperty("param");
    } catch (PropertyAccessException e) {
      return null ;  
    }
  }
    

  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }
}
