// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTADLIfStmt.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG -November,97: Added Parsing methods
//
//
// ***********************************************************************

package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.symboltable.*;
import ORG.opengroup.adl.symboltable.c.*;
import ORG.opengroup.adl.parsers.*;

public class ASTADLIfStmt extends SimpleNode  implements Typed {
  public ASTADLIfStmt(int id) {
    super(id);
  }

  public ASTADLIfStmt(ADLCPPParser p, int id) {
    super(p, id);
  }

  public static Node jjtCreate(int id) {
      return new ASTADLIfStmt(id);
  }

  public static Node jjtCreate(ADLCPPParser p, int id) {
      return new ASTADLIfStmt(p, id);
  }


  /* Called by TypeCheckvisitor to store the recovered type as a property
   */ 

  public void setType( LType visitorType) {
  
    try {
      setProperty("type", visitorType);
    } catch (PropertyAccessException e) {
    }
  }


  /* Implements getType of Typed Interface
   * Returns the type property if exits. Otherwise null;
   * the null case corresponds to an empty assertion group" if( myCond) { }"   
   */
  public LType getType() {

   LType restype=null;

   try {
     restype=  (LType) getProperty("type");
   } catch (PropertyAccessException e) {
   }
   
   return restype;
 }



  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }
}
