// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTADLImplExpr.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG - November,  1997: Updated
//     
//
// ***********************************************************************

package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.symboltable.LType;
import ORG.opengroup.adl.parsers.*;

import ORG.opengroup.adl.symboltable.c.CPPBuiltinType ;

public class ASTADLImplExpr extends SimpleNode implements Typed {
  public ASTADLImplExpr(int id) {
    super(id);
  }

  public ASTADLImplExpr(ADLCPPParser p, int id) {
    super(p, id);
  }


   /** Implements methog getType of Typed Interface and returns bool Type
    */

   public LType getType() {

     return CPPBuiltinType.boolT;

   }

  public void setOp(String id)
  {
    try {
      setProperty("op", id);
    } catch (PropertyAccessException e) {
    }
  }

  /** Method called to tell the stored operator recovered at parsing
   */
  public String getOp() {

   try {
      return (String) getProperty("op");
   }  catch (PropertyAccessException e) {
      return "";
   }

  }


  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }
}
