// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTADLLabel.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG - November,97:Introduced Parsing methods
//
// NB : The node is created when the assertion is an ADL_Expression
// ***********************************************************************
package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.parsers.*;

public class ASTADLLabel extends SimpleNode {
  public ASTADLLabel(int id) {
    super(id);
  }

  public ASTADLLabel(ADLCPPParser p, int id) {
    super(p, id);
  }

  /** returns the  Assertion label stored as a node property
   */
  public String getName()
  {
    try {
      return (String) getProperty("label") ;
    } catch (PropertyAccessException e) {
    return " "; }
  }
  

  /**  Called by the parser to store ADL assertion label
   */
  public void setName(String id)
  {
    try {
      setProperty("label", id);
    } catch (PropertyAccessException e) {
    }
  }



  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }
}
