// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTADLQuantifiedAssertion.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG -November,97 : Added Parsing methods
//
//
// ***********************************************************************

package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.symboltable.*;
import ORG.opengroup.adl.symboltable.c.*;
import ORG.opengroup.adl.parsers.*;

public class ASTADLQuantifiedAssertion extends SimpleNode implements Typed {
  public ASTADLQuantifiedAssertion(int id) {
    super(id);
  }

  public ASTADLQuantifiedAssertion(ADLCPPParser p, int id) {
    super(p, id);
  }

  public static Node jjtCreate(int id) {
      return new ASTADLQuantifiedAssertion(id);
  }

  public static Node jjtCreate(ADLCPPParser p, int id) {
      return new ASTADLQuantifiedAssertion(p, id);
  }


 /**
   * Return Quantified Assertion type and implements Typed interface.
   * <p> <b> Algorithm : </b> <ul>
   * Return always bool type.
   * </ul>
   * @return the returne type.
   */    
  public LType getType() {
    
    return stm.getType("bool", null) ;
  }


  /**
   * Saves assertion quantifier as a node property.
   * @param quant the assertion quantifier. 
   */

  public void setQuantifier( String quant) {

      try {
      setProperty("quantifier", quant);
    } catch (PropertyAccessException e) {
    }
  }

  /**
   * Returns assertion quantifeir saved as a node property 
   * @result the quantifier.
   */
  public String getQuantifier() {
    try {
      return (String) getProperty("quantifier");
    } catch (PropertyAccessException e) {
      return "forall" ;
    }
  }


  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }
}
