// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTADLClass.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG - November 4th,  1997: Updated
//     
//
// ***********************************************************************

package ORG.opengroup.adl.parsers.adlcpp;

import java.util.Vector;
import ORG.opengroup.adl.parsers.ParseException;
import ORG.opengroup.adl.symboltable.*;
import ORG.opengroup.adl.symboltable.c.*;


public class ASTADLSuperClass extends SimpleNode {
  /** vector storing ADL class super classes */
  private Vector supers;

  public ASTADLSuperClass(int id) {
    super(id);
  }

  public ASTADLSuperClass(ADLCPPParser p, int id) {
    super(p, id);
  }

  public static Node jjtCreate(int id) {
      return new ASTADLSuperClass(id);
  }

  public static Node jjtCreate(ADLCPPParser p, int id) {
      return new ASTADLSuperClass(p, id);
  }


  /** called by the parser to store the super classes vector */
  public void storeSuperClasses ( Vector supers ) {

    this.supers = supers;
  }


  /** @return is the super classes vector */
  public Vector getSuperClasses () {
 
    return this.supers;
  }

  /* checkADLSuperClass is called by the Parser
   * It verifies if supername is a declared LClass in curScope
   * Verifies if it is a superclass of childclass
   */

  public LClass checkADLSuperClass(String superName,ADLClass childClass)
  throws ParseException {

    boolean ok = false;

    LClass theSuperClass=null;

    LClass CPPclass = childClass.getLClass();

    LClass superClass[] = CPPclass.getSuperClasses();
 
    // Look in the table of super classes for the one called superName 
    
    for (int i=0;i< superClass.length ;i++) {
      if ( CPPclass.subclassOf(superClass[i] )) {
	theSuperClass = superClass[i];
	ok = true;
	break;
      }
    }
 

    if( ! ok ) {
      errorMessage("ADL super slass declaration : " 
                  + childClass.getName() 
                  + " has no superclass called " + superName);
    }

    return theSuperClass;

  }

 
  

   

  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }
}
