// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTAbnormalExpr.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG - October,  1997: Added parsing methods
//
//
// ***********************************************************************

package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.symboltable.LType;
import ORG.opengroup.adl.parsers.*;

public class ASTAbnormalExpr extends SimpleNode implements Typed {
  public ASTAbnormalExpr(int id) {
    super(id);
  }

  public ASTAbnormalExpr(ADLCPPParser p, int id) {
    super(p, id);
  }

  public static Node jjtCreate(int id) {
      return new ASTAbnormalExpr(id);
  }

  public static Node jjtCreate(ADLCPPParser p, int id) {
      return new ASTAbnormalExpr(p, id);
  }

 /* Implements getType of Typed.
   * returns the node type stored as a property
   */
 public LType getType() {

   try {
     return (LType) getProperty("type");
   } catch (PropertyAccessException e) {
     return (LType) stm.getSymbol("bool");
   }

 }

  /** Saves type as a node property */
  public void setType( LType curType) {

    try {
      setProperty("type",curType);
    } catch (PropertyAccessException e) {
    }
  }


  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }
}
