// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTAbstractDeclaratorSuffix.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG - December,  1997: Added parsing methods
//     
//
// ***********************************************************************

package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.parsers.ParseException;
import ORG.opengroup.adl.symboltable.*;

public class ASTAbstractDeclaratorSuffix extends SimpleNode {
  public ASTAbstractDeclaratorSuffix(int id) {
    super(id);
  }

  public ASTAbstractDeclaratorSuffix(ADLCPPParser p, int id) {
    super(p, id);
  }

  /** called by the parser to set suffix array size */
   public void setArraySize(int  nb)
  {
    ArraySize = nb;

  }

  /** returns the array size. If null then the node is a function definition*/
  public int getArraySize() {
    return ArraySize;
  }


  /**Called when AbstractDeclarator->"("AbstractDeclarator") AbstarctDeclaratorSuffix
   * returns an LCallableEqualsComparator if matched function parameter suffix
   * return an LArray if matched Array suffix.
   */
  public Object updateDeclarationType(LType  declaratorType) throws ParseException {
    int childNum = jjtGetNumChildren();
    if(  ArraySize > 0 ) {

      for (int i=0; i< ArraySize; i++ ) {

	declaratorType =  sbf.newArray(declaratorType) ;
      }
     
    }
    else if ( childNum ==0 ) {
      return declaratorType ;
    }
    else  if ( jjtGetChild(0) instanceof ASTParameterDeclaration ) {
      LCallableEqualsComparator ec = new LCallableEqualsComparator();
      ec.setReturnType ( declaratorType );
      LParameter param = ( ( ASTParameterDeclaration) jjtGetChild(0)).getFctParameter( );
      ec.addParameterType( param.getType() );

      return ec;
    }
    else if ( jjtGetChild(0) instanceof ASTParameterDeclarationList ) {
      LCallableEqualsComparator ec = new LCallableEqualsComparator();
      ec.setReturnType ( declaratorType );
      LParameter parameters[] = ( ( ASTParameterDeclarationList) jjtGetChild(0)).getFctParameters( );
      for ( int i =0; i < parameters.length; i ++ ) {
	 ec.addParameterType( parameters[i].getType() );
      }
      return ec;
    }
    
    return declaratorType;
  }






  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }

  /* An integer telling the array size .e.g for int [][], ArraySize = 2
   *  updated by the parser if AbstractDeclaratorSuffixes -> ( [ (ConstantExpr) ?] )*
   *. If ArraySize = 0  Declarator suffix is a function parameter list
   */
  private int ArraySize =0;
}
