// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTAccessSpecifier.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG - December,97:Introduced Parsing methods
//
//
// ***********************************************************************




package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.parsers.*;

public class ASTAccessSpecifier extends SimpleNode {
  public ASTAccessSpecifier(int id) {
    super(id);
  }

  public ASTAccessSpecifier(ADLCPPParser p, int id) {
    super(p, id);
  }

/** Sets Acces Specifier name recoeverd at parsing time */
  public void setAccessSpecifierName( String asn ) {

    try {
      setProperty("specifiername",asn);
    } catch ( PropertyAccessException e) {
    }
  }

  /** returns the acces specifier name */
  public String getAccessSpecifierName() {

    try {
      return (String) getProperty ("specifiername");
    } catch ( PropertyAccessException e ) {
      return " ";
    }
  }

  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }
}
