// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTBaseClause.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG - November, 5th,  1997: Updated
//     
//
// ***********************************************************************

package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.parsers.ParseException;
import ORG.opengroup.adl.symboltable.*;
import ORG.opengroup.adl.symboltable.c.*;

public class ASTBaseClause extends SimpleNode {
  public ASTBaseClause(int id) {
    super(id);
  }

  public ASTBaseClause(ADLCPPParser p, int id) {
    super(p, id);
  }

  public static Node jjtCreate(int id) {
      return new ASTBaseClause(id);
  }

  public static Node jjtCreate(ADLCPPParser p, int id) {
      return new ASTBaseClause(p, id);
  }

  public LClass addSuperClasses (LClass  childClass) throws ParseException {
    int nbchild= jjtGetNumChildren();

    // All child nodes are ASTBaseSpecifier.
    for(int i=0;i<nbchild;i++) {
      if(jjtGetChild(i) instanceof ASTBaseSpecifier){ //This is always the case
	LClass superLC = ( (ASTBaseSpecifier)jjtGetChild(i)).getSuperLClass();
	  childClass.addSuperClass(superLC);
	}
    }
    return childClass;
  }



  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }
}
