// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTBinaryLogicalExpr.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG -November,97: Added Parsing methods
//     
//
// ***********************************************************************


package ORG.opengroup.adl.parsers.adlcpp;

import java.util.Vector;
import ORG.opengroup.adl.parsers.*;
import java.io.PrintStream;
import ORG.opengroup.adl.symboltable.*;
import ORG.opengroup.adl.symboltable.c.*;


public class ASTBinaryLogicalExpr extends SimpleNode implements Typed {
  // The operators Vecor
  private Vector PropVect= new Vector();

  /* Temporarely Function. dispalys during the dump, the operator Vector */ 
  protected void dumpNode(PrintStream o, String label, String pad, int level)
  {
  System.out.println(" The recovered Operator Vector : " + PropVect);
  super.dumpNode(o,label,pad,level);
  }
  



  public ASTBinaryLogicalExpr(int id) {
    super(id);
  }

  public ASTBinaryLogicalExpr(ADLCPPParser p, int id) {
    super(p, id);
  }



  /* Implements getType of Typed. 
   * return bool as LType. Node type checking is implemented in the visitor
   */
  public LType getType() {
    LType boolType = ( LType) stm.getSymbol("bool");
    
    return boolType;
  }

  public static Node jjtCreate(int id) {
      return new ASTBinaryLogicalExpr(id);
  }

  public static Node jjtCreate(ADLCPPParser p, int id) {
      return new ASTBinaryLogicalExpr(p, id);
  }

 /** Adds an operator into the Operator Vector. Called by the parser
   */ 
  public void addOp( String op) {
    PropVect.addElement(op);
  }

  public Vector getOperatorsVector() {
    return PropVect;
  }


  public void setOp(String id)
  {
    try {
      setProperty("op", id);
    } catch (PropertyAccessException e) {
    }
  }


  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data)  throws ParseException {

      return visitor.visit(this, data);
 
  }
}
