// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTBuiltinTypeSpec.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG - October,  1997: Added Parsing methods
//     
//
// ***********************************************************************

package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.symboltable.*;
import ORG.opengroup.adl.parsers.*;
import ORG.opengroup.adl.symboltable.c.*;


public class ASTBuiltinTypeSpec extends SimpleNode {
  public ASTBuiltinTypeSpec(int id) {
    super(id);
  }

  public ASTBuiltinTypeSpec(ADLCPPParser p, int id) {
    super(p, id);
  }

  public static Node jjtCreate(int id) {
      return new ASTBuiltinTypeSpec(id);
  }

  public static Node jjtCreate(ADLCPPParser p, int id) {
      return new ASTBuiltinTypeSpec(p, id);
  }


  /** returns builtin type name saved as a node property */ 
  public String getTypeName() {
    try {
      return  (String) getProperty("type");
    } catch (PropertyAccessException e) {
      return "";  
    }
  }


  /** Returns the builtin type whsoe name is saved as a node property */
  public CPPBuiltinType getType() {
    try {
      return (CPPBuiltinType) stm.getSymbol( (String) getProperty("type"));
    } catch (PropertyAccessException e) {
      return null ;  
    }
  }


  /** Saves type as a node property */
  public void setType(String id)
  {
    try {
      setProperty("type", id);
    } catch (PropertyAccessException e) {
    }
  }
 



  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }
}
