// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTConstant.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG -November,97: Added Parsing methods
//     
//
// ***********************************************************************

package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.symboltable.*;
import ORG.opengroup.adl.symboltable.c.*;
import ORG.opengroup.adl.parsers.*;


public class ASTConstant extends SimpleNode implements Typed {
  public ASTConstant(int id) {
    super(id);
  }

  public ASTConstant(ADLCPPParser p, int id) {
    super(p, id);
  }

  public static Node jjtCreate(int id) {
      return new ASTConstant(id);
  }

  public static Node jjtCreate(ADLCPPParser p, int id) {
      return new ASTConstant(p, id);
  }
  /** saves the constant value as anode property */
  public void setCstVal(String id)
  {
    try {
      setProperty("cstVal", id);
    } catch (PropertyAccessException e) {
    }
  }

  public String getConstantValue () {
    try {
      return ( String ) getProperty ( "cstVal") ;
    } catch (PropertyAccessException e) {
      return " ";
    }
  }

  public LType getType() {

   String typeName = getTypeName();
   LType resType= (LType) stm.getSymbol(typeName);

   return resType;
  } 


  public String getTypeName() {
    try {
      return (String) getProperty("typeName");
    } catch ( PropertyAccessException e) {
      return "int";
    }

  }

  public void setTypeName( String str) {
    try {
      setProperty("typeName", str);
    } catch (PropertyAccessException e) {
    }

  }

  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }
}
