// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTMemberDeclaration.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG - October,  1997: Updated
//     
//
// ***********************************************************************


package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.symboltable.*;
import ORG.opengroup.adl.parsers.*;
import ORG.opengroup.adl.symboltable.c.*;

public class ASTDeclarationSpecifiers extends SimpleNode  {
  public ASTDeclarationSpecifiers(int id) {
    super(id);
  }

  public ASTDeclarationSpecifiers(ADLCPPParser p, int id) {
    super(p, id);
  }

  public static Node jjtCreate(int id) {
      return new ASTDeclarationSpecifiers(id);
  }

  public static Node jjtCreate(ADLCPPParser p, int id) {
      return new ASTDeclarationSpecifiers(p, id);
  }


 /* Return the declaration spcifier node based on its children 
  */
  public LType getType() throws ParseException {
    int countchild, nbbuiltin=0;
    String typeName="";
    LType restype=null;
    countchild= jjtGetNumChildren();
    for ( int i=0; i<countchild; i++) {
       if (  jjtGetChild(i) instanceof ASTQualifiedType ) {
	restype= ( (ASTQualifiedType)jjtGetChild(i)).getType();
	return restype;
      }
       else if( jjtGetChild(i) instanceof ASTFullyScopedType ) {

	 restype = ( (ASTFullyScopedType) jjtGetChild(i)).getType();
	 return restype;
       }
      else if( jjtGetChild(i) instanceof ASTClassSpecifier) {

	//The type is the ClassName
	restype=  ( (ASTClassSpecifier)jjtGetChild(i)).getClassTypeName();
	return restype;
      }
       // Enum are integral types
       else if ( jjtGetChild(i) instanceof ASTEnumSpecifier ) {
	 return ( (ASTEnumSpecifier)jjtGetChild(i)).getEnum() ;
       }				
			       
       else if( jjtGetChild(i) instanceof ASTBuiltinTypeSpec) {
	 if(nbbuiltin == 0) { 
	   //when we have a builtin type for the first time.
          typeName = ((ASTBuiltinTypeSpec) jjtGetChild(i)).getTypeName();
	  nbbuiltin ++;
	 }
	 else {
	   typeName = typeName + " " +((ASTBuiltinTypeSpec) jjtGetChild(i)).getTypeName();
	  	  
	}	
       }
	      
    }

    restype =  stm.getType(typeName,stm.getAdlTranslationUnit());
    if(restype == null) { 
      errorMessage("Error: Illegal Concatenation of Builtin Types");
    } else {
      setBuiltinTypeName(restype.getName() );
    }

    return restype;
  }


  /** Stores name of the recovered buitlintype as a node property
   * called only when DeclarationSpecifeirs has BuiltinType children
   */
   public void setBuiltinTypeName(String id)
  {
    try {
      setProperty("builtintypename", id);
    } catch (PropertyAccessException e) {
    }
  }
 
  /** called by the parser when children are BuiltinTypes to get children name
   */
  public String getBuiltinTypeName()
  {
    try {
      return (String)getProperty("builtintypename");
    } catch (PropertyAccessException e) {
    return null;  }
  }



  /** Called by the parser to save the node modifier as private field */
  public void setModifier( int modif)
  {
    modifier = modif;
  }


  /* Called to return the declartion/definition modifier as private field
   */
  public int getModifier()  {

     
    return modifier;
  }


       
  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }

  //___________________________ Private features_____________________________

  /* boolean for debugging message display */
  private boolean debug = false;
  /* the declaration specifier modifier */
  private int modifier = 0x0000; 

}
