// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTDeleteExpr.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG -October,97:Modified to Introduce Parsing methods
//     
//
// ***********************************************************************

package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.parsers.ParseException;
import ORG.opengroup.adl.symboltable.* ;

public class ASTDeleteExpr extends SimpleNode implements Typed {

  /** boolean to tell if delete expression contains "::" */
  public boolean withOverride = false ;
  /** boolean to tell if delete expression contains braces */
  public boolean withBraces = false ;

  public ASTDeleteExpr(int id) {
    super(id);
  }

  public ASTDeleteExpr(ADLCPPParser p, int id) {
    super(p, id);
  }

  /** Return "void" as delete expression type */
  public LType getType() {
    return (LType) stm.getSymbol("void") ;
  }

  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }
}
