// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTDtorDefinition.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG - December,1997: Added Parsing methods
//     
//
// ***********************************************************************
package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.parsers.ParseException;

public class ASTDtorDefinition extends SimpleNode {
  private int dtorModifier ;
  public ASTDtorDefinition(int id) {
    super(id);
  }

  public ASTDtorDefinition(ADLCPPParser p, int id) {
    super(p, id);
  }

 /**
   * Set destrcutor modifier.
   * <p><b>Algorithm:</b><ul>
   * update <a href="#dtorModifier"> dtorModifier</a> field.
   * </ul>
   * @param mdf the modifier to set.
   */
  public void setModifier( int mdf ) {
    dtorModifier = mdf ;
  }

  /**
   * Returns destructor modifier.
   *
   * <p><b>Algorithm:</b><ul>
   * Returns <a href="#dtorModifier"> dtorModifier</a> field.
   * </ul>
   * @return the modifier to get.
   */
  public int getModifier() {
    return dtorModifier ;
  }

  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }
}
