// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTEnumSpecifier.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG -November,97:Introduced Parsing methods
//
//
// **********************************************************************

package ORG.opengroup.adl.parsers.adlcpp;


import ORG.opengroup.adl.symboltable.c.CEnum ;
import ORG.opengroup.adl.parsers.*;

public class ASTEnumSpecifier extends SimpleNode {
  public ASTEnumSpecifier(int id) {
    super(id);
  }


  public ASTEnumSpecifier(ADLCPPParser p, int id) {
    super(p, id);
  }

/** returns the enumeration stored as a node property */
  public CEnum getEnum()
  {
    try {
      return (CEnum)getProperty("enum");
    } catch (PropertyAccessException e) {
    return null; }
  }

  /** returns the enumeration name */
  public String getEnumName() {
    CEnum enum = getEnum() ;
    if ( enum != null ) {
      return enum.getName() ;
    } 
    else 
      return " ";
  }



/** Called by the parser to save enumeration  name as a node property */
  public void setEnum(CEnum enum )
  {
    try {
      setProperty("enum", enum);
    } catch (PropertyAccessException e) {
    }
  }




  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }
}
