// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTEnumerator.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG -November,97:Introduced Parsing methods
//
//
// ***********************************************************************

package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.parsers.*;

public class ASTEnumerator extends SimpleNode {
  public ASTEnumerator(int id) {
    super(id);
  }

  public ASTEnumerator(ADLCPPParser p, int id) {
    super(p, id);
  }


/** returns the enumerator name stored as a node property */
  public String getEnumId()
  {
    try {
      return (String)getProperty("name");
    } catch (PropertyAccessException e) {
    return " "; }
  }


/** Called by the parser to save enumerator ID name as a node property */
  public void setEnumId(String id)
  {
    try {
      setProperty("name", id);
    } catch (PropertyAccessException e) {
    }
  }



  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }
}
