// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTForNode.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG - October,  1997: Added parsing methods
//
//
// ***********************************************************************

package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.parsers.ParseException;

public class ASTForNode extends SimpleNode {

  private String forKind[];
  public ASTForNode(int id) {
    super(id);
  }

  public ASTForNode(ADLCPPParser p, int id) {
    super(p, id);
  }

  public static Node jjtCreate(int id) {
      return new ASTForNode(id);
  }

  public static Node jjtCreate(ADLCPPParser p, int id) {
      return new ASTForNode(p, id);
  }


  /** Called by the parser to store table indicating node composition */
  public void setKind(String[] fortab) {
    forKind = fortab;
    if( debug) {
      System.out.println(" Stored forKind array in ForNode [ "+forKind[0]+","+forKind[1]+","+ forKind[2]+"]");
    } 
  }

  /** tells the kind of the @param i of the node children
   * @param i is between 0 and 2 */
  public String getChildKind( int i) {

    return forKind [ i];
  }


  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }

  //__________________________ priavete flags______________________________________

  /* boolean set to true if debugging display required */
  private boolean debug = false;
}
