// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTFullyScopedType.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG -November,97: Added Parsing methods
//
//
// ***********************************************************************

package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.symboltable.*;
import ORG.opengroup.adl.parsers.*;

public class ASTFullyScopedType extends SimpleNode {
  public ASTFullyScopedType(int id) {
    super(id);
  }

  public ASTFullyScopedType(ADLCPPParser p, int id) {
    super(p, id);
  }

  public static Node jjtCreate(int id) {
      return new ASTFullyScopedType(id);
  }

  public static Node jjtCreate(ADLCPPParser p, int id) {
      return new ASTFullyScopedType(p, id);
  }



  /**returns node type. Called by DeclarationSpec to recover decration type */ 
  public LType getType()  throws ParseException {
    String typename = getTypeName();
    Scope typescope = getScopeOverride().Scope;
    LType returnType = stm.getType( typename, typescope);
    if ( returnType == null ) 
      errorMessage("Error: type not found in the specified scope");
    return returnType;
  }


  /** Returns the fully scoped type name */
  public void setTypeName(String id)
  {
    try {
      setProperty("type", id);
    } catch (PropertyAccessException e) {
    }
  }

  /** called by unparser to return the full type name including scope override
    */
  public String getFullTypeName() {
    String override = getScopeOverride().Name;
    String typename =  getTypeName();

    return override+typename ;
  }

  /** returns the type name without the scope override */
  public String getTypeName() {
    try {
      return (String ) getProperty("type");
    } catch (PropertyAccessException e) {
      return "";
    }
  }


  public ScopedName getScopeOverride() {
    ScopedName result;
    try {
      result = (ScopedName ) getProperty("scopeoverride");
    } catch (PropertyAccessException e) {
      return new ScopedName(" ", null);
    }
    return result;
  }


  public void setScopeOverride(ScopedName sn)
  {
    if ( debug ) {
      System.out.println("debug ASTFullyScopedType.setScopeOverride: saved "+
			 "ScopedName ( "+ sn.Name+", "+ sn.Scope+" )");
    }

    try {
      setProperty("scopeoverride", sn);
    } catch (PropertyAccessException e) {
    }
  }


  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }

}
