// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTFunctionDeclarator.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG - October,  1997: Added Parsing methods
//     
//
// ***********************************************************************

package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.parsers.ParseException;
import ORG.opengroup.adl.symboltable.*;
import ORG.opengroup.adl.symboltable.c.*;

public class ASTFunctionDeclarator extends SimpleNode {
  public ASTFunctionDeclarator(int id) {
    super(id);
  }

  public ASTFunctionDeclarator(ADLCPPParser p, int id) {
    super(p, id);
  }

  public static Node jjtCreate(int id) {
      return new ASTFunctionDeclarator(id);
  }

  public static Node jjtCreate(ADLCPPParser p, int id) {
      return new ASTFunctionDeclarator(p, id);
  }


  /* UpdateFctType chechs if the fisrt child is ASTPtrOperator. If yes, we update the FctType. and call the second child if it is an instance of FunctionDeclarator */

  public LType UpdateFctType( LType curType) {
    String tmpstr;
    LType restype= curType ;

    if( jjtGetChild(0) instanceof ASTPtrOperator) {
      tmpstr = ( (ASTPtrOperator)jjtGetChild(0)).getPtrkind();
      if ( tmpstr.equals( "PointerTo")) {
	restype =  (LType) sbf.newPointer(curType,0x00);
      } else if( tmpstr.equals("ReferenceTo") ) {

	restype = sbf.newReference( curType);
      } else if ( tmpstr.equals("PointerToMember") ) {
	restype =  (LType) sbf.newPointer(curType,0x00);

      }
      

      if ( jjtGetChild(1) instanceof ASTFunctionDeclarator ) {
	return ( (ASTFunctionDeclarator) jjtGetChild(1)).UpdateFctType( restype) ; // Recursive call to handle multiple pointers
      }
      else {
	return restype;
      } 
    }
 
    else {
      return curType; // Remove later!
    }

  }


  /* This function is called by ASTFunctionDeclaration.
  * This node does exist only when ASTPtrOperator exists as a first node
  * In such case, the function calls the fct of second children (Function[Direct]Declarator)
  */    
  public ScopedName getFctName () throws ParseException {
    ScopedName result = null;
    if( jjtGetChild(1) instanceof ASTFunctionDirectDeclarator ) {

      result = ( (ASTFunctionDirectDeclarator)jjtGetChild(1)).getFctName();
    }
    else if ( jjtGetChild(1) instanceof ASTFunctionDeclarator ) {

      result = ( (ASTFunctionDeclarator)jjtGetChild(1)).getFctName();
    }
    else { // Never occurs!
      errorMessage("Error : Unvalid Function Declaration");

    }
    return result;
  }


  /* This function is called by Translator to modifiy fct name.
   * This node does exist only when ASTPtrOperator exists as a first node
   * In such case, the function calls the fct of second children (Function[Direct]Declarator)
   */    
  public void setFctName (String name) throws ParseException {
    if( jjtGetChild(1) instanceof ASTFunctionDirectDeclarator ) {
      ( (ASTFunctionDirectDeclarator)jjtGetChild(1)).setFctName(name);
    }
    else if ( jjtGetChild(1) instanceof ASTFunctionDeclarator ) {
      ( (ASTFunctionDeclarator)jjtGetChild(1)).setFctName(name);
    }
    else { // Never occurs!
      errorMessage("Error : Unvalid Function Declaration");
    }
  }

  
/* Here again if the Node exits. seek parameters in the second child ;Child(1) */
  public  LCallable addFctParameters( LCallable curfct) throws ParseException {
    if ( jjtGetChild(1) instanceof ASTFunctionDirectDeclarator)
      return ( (ASTFunctionDirectDeclarator)jjtGetChild(1)).addFctParameters(curfct);
    else // certainly jjtGetChild(1) is Functiondeclarator
      return ( (ASTFunctionDeclarator)jjtGetChild(1)).addFctParameters(curfct);
  }   
	




  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }
}
