// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTGotoNode.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG -November,97: Added Parsing methods
//
//
// ***********************************************************************

package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.parsers.*;

public class ASTGotoNode extends SimpleNode {
  public ASTGotoNode(int id) {
    super(id);
  }

  public ASTGotoNode(ADLCPPParser p, int id) {
    super(p, id);
  }

  public static Node jjtCreate(int id) {
      return new ASTGotoNode(id);
  }

  public static Node jjtCreate(ADLCPPParser p, int id) {
      return new ASTGotoNode(p, id);
  }



 /** returns the goto destination label stored as a node property
   */
  public String getName()
  {
    try {
      return (String) getProperty("label") ;
    } catch (PropertyAccessException e) {
    return " "; }
  }
  

  /** Called by the parser to store goto destination label
   */
  public void setName(String id)
  {
    try {
      setProperty("label", id);
    } catch (PropertyAccessException e) {
    }
  }


  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }
}
