// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTIncludeFileDeclaration.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG -November,97:Introduced Parsing methods
//
//
// ***********************************************************************

package ORG.opengroup.adl.parsers.adlcpp;

import java.io.PrintStream;
import ORG.opengroup.adl.parsers.*;

public class ASTIncludeFileDeclaration extends SimpleNode {
  public ASTIncludeFileDeclaration(int id) {
    super(id);
  }

  public ASTIncludeFileDeclaration(ADLCPPParser p, int id) {
    super(p, id);
  }

  /** overrides dumpNode method of SimpleNode. displays filename to be included */
  protected void dumpNode(PrintStream o, String label, String pad, int level) {

    super.dumpNode(o,label,pad,level);

    if (debug) {

      System.out.println(" Name of included file  : " + getFileName());

    }
  }



  /** called by parser to store name of the file be included */ 
  public void setFileName(String id)
  {
    try {
      setProperty("filename", id);
    } catch (PropertyAccessException e) {
    }
  }

  public String getFileName()
  {
    try {
      return (String)getProperty("filename");
    } catch (PropertyAccessException e) {
    return null; }
  }


  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }
  //__________________ private fields______________________________________

  /** boolean set to true when debug display required */
  private boolean debug = true;

}
