// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTInitDeclarator.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG - October,  1997: Updated
//     
//
// ***********************************************************************


package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.parsers.ParseException;
import ORG.opengroup.adl.symboltable.*;
import ORG.opengroup.adl.symboltable.c.*;

public class ASTInitDeclarator extends SimpleNode {
  /** Boolean telling the kind of second child <ul>
    * <li> -> Declarator "=" Initializer => notInitializer = false.
    * <li> -> Declarator "(" Expression ")" => notInitializer = true.
    * </ul>
    */
  public boolean notInitialized = false ; 

  public ASTInitDeclarator(int id) {
    super(id);
  }

  public ASTInitDeclarator(ADLCPPParser p, int id) {
    super(p, id);
  }

  public static Node jjtCreate(int id) {
      return new ASTInitDeclarator(id);
  }

  public static Node jjtCreate(ADLCPPParser p, int id) {
      return new ASTInitDeclarator(p, id);
  }

  /* Make up the decalartion of the first child.
   * This child(0) should always be either declartor or direct declarator
   */
  public void MakeUpInitDecl ( LType decltype,int modif) throws  ParseException {

    if( jjtGetChild(0) instanceof ASTDeclarator) {
      ( (ASTDeclarator) jjtGetChild(0)).MakeUpDeclarator(decltype,modif);
    }
    else if( jjtGetChild(0) instanceof ASTDirectDeclarator) {
      ( (ASTDirectDeclarator) jjtGetChild(0)).MakeUpDirectDeclarator(decltype,modif);
    }
     
  }
						 




  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }
}
