// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTInitDeclaratorList.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG - October,  1997: Updated
//     
//
// ***********************************************************************


package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.parsers.ParseException;
import ORG.opengroup.adl.symboltable.LType;


public class ASTInitDeclaratorList extends SimpleNode {
  public ASTInitDeclaratorList(int id) {
    super(id);
  }

  public ASTInitDeclaratorList(ADLCPPParser p, int id) {
    super(p, id);
  }

  public static Node jjtCreate(int id) {
      return new ASTInitDeclaratorList(id);
  }

  public static Node jjtCreate(ADLCPPParser p, int id) {
      return new ASTInitDeclaratorList(p, id);
  }

  /* We make up the declaration for each of the declarators
   * The recovered Type (decltype) is common for all declarators
   */
  public void MakeUpInitDecList ( LType decltype, int modif) throws  ParseException {
    int nbchild = jjtGetNumChildren();

    for( int i=0;i< nbchild;i++) {
      if( jjtGetChild(i) instanceof ASTDeclarator) {
	( (ASTDeclarator) jjtGetChild(i)).MakeUpDeclarator(decltype, modif);
      }
      else if( jjtGetChild(i) instanceof ASTDirectDeclarator) {
	( (ASTDirectDeclarator) jjtGetChild(i)).MakeUpDirectDeclarator(decltype,modif);
      }
      else if( jjtGetChild(i) instanceof ASTInitDeclarator) {
	( (ASTInitDeclarator) jjtGetChild(i)).MakeUpInitDecl(decltype,modif);
      }
    }
  }
						 


  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }
}
