// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTLinkageSpecification.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG - January,  1998: Added parsing methods
//     
//
// ***********************************************************************

package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.symboltable.Scope;
import ORG.opengroup.adl.parsers.*;

public class ASTLinkageSpecification extends SimpleNode {
  public ASTLinkageSpecification(int id) {
    super(id);
  }

  public ASTLinkageSpecification(ADLCPPParser p, int id) {
    super(p, id);
  }

  /** Saves the linkage specification style as a node property */
  public void setStyle ( String s ) {
    
    try {
      setProperty("style",s);
    } catch ( PropertyAccessException e) {
    }
  }



  /** Returns the compound statement scope saved as a node property  */
  public String getStyle() {
    
    try {
      return (String) getProperty ("style");
    } catch ( PropertyAccessException e ) {
      return "C++";
    }
  }
 

  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }
}
