// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTQualifiedId.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG - December,97:Introduced Parsing methods
//
//
// ***********************************************************************




package ORG.opengroup.adl.parsers.adlcpp;

import java.util.Vector;
import ORG.opengroup.adl.parsers.ParseException;
import ORG.opengroup.adl.symboltable.LType;
import ORG.opengroup.adl.symboltable.c.CModifier;


public class ASTMemberDeclaratorList extends SimpleNode {

  /** vector containing the intialization values of member declarators
   * vector size=children number. Contains "<EMPTY>" for non initialized child
   */
  public Vector valuesVector;

  

  public ASTMemberDeclaratorList(int id) {
    super(id);
  }

  public ASTMemberDeclaratorList(ADLCPPParser p, int id) {
    super(p, id);
  }


  /** called by the parser to save member declarators initialization values*/
  public void setValuesVector ( Vector initvect) {

    valuesVector = initvect;
  }


  public Vector getValuesVector() {
    return valuesVector;
  }

  /** checkDirectDeclarator make sure intialized members are static.
   * Calls also MakeUp methods to declare fields within the class scope 
   */
  public void checkMemberDeclaratorList( LType membertype,int modif) throws ParseException {

    CModifier memberModif = new CModifier( modif);
    int childNum = jjtGetNumChildren();
    for (int i =0; i < childNum ; i++ ) {

      String elem = (String)  valuesVector.elementAt(i);
    
      if((!elem.equals("<EMPTY>" )) && (! memberModif.isStatic() ) ) {
	// Make sure the modifier is static
  errorMessage("Error : initialized class member declarators should be static");
      }
	
	// Now declare child: it is either a declarator or a direct decalarator
      if( jjtGetChild(1) instanceof ASTDeclarator) {

	( (ASTDeclarator) jjtGetChild(i)).MakeUpDeclarator(membertype,modif );
      }
      else if( jjtGetChild(1) instanceof ASTDirectDeclarator) {
	
	( (ASTDirectDeclarator) jjtGetChild(i)).MakeUpDirectDeclarator(membertype, modif);	
      }
      
    }
  }
      
  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }
}
