// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTParameterDeclarationList.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG - October,  1997: Added Parsing methods
//     
//
// ***********************************************************************


package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.parsers.ParseException;
import ORG.opengroup.adl.symboltable.*;
import ORG.opengroup.adl.symboltable.c.*;


public class ASTParameterDeclarationList extends SimpleNode {
  public ASTParameterDeclarationList(int id) {
    super(id);
  }

  public ASTParameterDeclarationList(ADLCPPParser p, int id) {
    super(p, id);
  }

  public static Node jjtCreate(int id) {
      return new ASTParameterDeclarationList(id);
  }

  public static Node jjtCreate(ADLCPPParser p, int id) {
      return new ASTParameterDeclarationList(p, id);
  }


  /**
   * Returns an array of function parameters.
   * <p><b>Algorithm:</b><ul>
   * loop on ParameterDeclaration children and gets their fucntion parameters 
   * the result parameter array.
   * </ul>
   * @param array of function parameters.
   *
   * @see ASTParameterDeclaration#getFctParameter
   */

  public LParameter[] getFctParameters( ) throws ParseException {
    int nbchild = jjtGetNumChildren();
    LParameter params[]= new LParameter[nbchild];

    // We declare parameters one after one 
    for ( int i=0; i<nbchild; i++) {
      params[i] = ((ASTParameterDeclaration)jjtGetChild(i)).getFctParameter(); 
    }

    return params; 
  }
      


  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }
}
