// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTPmExpr.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG -November,97: Added Parsing methods
//
//
// ***********************************************************************

package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.symboltable.LType ;
import ORG.opengroup.adl.parsers.*;

import java.util.Vector ;

/**
  * Pointer to meber expression node.
  */

public class ASTPmExpr extends SimpleNode implements Typed {

  /**
   * The operators Vector.
   */
  private Vector operators= new Vector();
  
  public ASTPmExpr(int id) {
    super(id);
  }

  public ASTPmExpr(ADLCPPParser p, int id) {
    super(p, id);
  }

  public static Node jjtCreate(int id) {
      return new ASTPmExpr(id);
  }

  public static Node jjtCreate(ADLCPPParser p, int id) {
      return new ASTPmExpr(p, id);
  }

  /** Adds an Operator string into the Operator Vector.
   */
  public void addOp( String op) {
    operators.addElement(op);
  }

  /** Returns the pointer to member operators vector */
  public Vector getOperatorsVector() {
    return operators;
  }


  /* Called by the type check visitor to store expression type as a property */
  public void setType(LType datasetType)
  {
    try {
      setProperty("type", datasetType);
    } catch (PropertyAccessException e) {
    }
  }

  /* Implements getType of Typed Interface
   * returns expression type stored as a node property
   */

 public LType getType() {

   try {
     return  (LType) getProperty("type");
   } catch (PropertyAccessException e) {
     return null ;
   }

 }




  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }
}
