// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTPrimaryExpr.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG - November,  1997: Updated
//
//
// ***********************************************************************
package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.parsers.ParseException;
import ORG.opengroup.adl.symboltable.LType;

public class ASTPrimaryExpr extends SimpleNode implements Typed {

  private LType primeType;

  /**boolean telling if the primary expression is a call for ADLInline method*/
  public boolean isADLInline = false ;
  /**boolean telling if the primary expression is method of the tested class */
  public boolean isTestedClassMember = false ;

  public ASTPrimaryExpr(int id) {
    super(id);
    isADLInline = false ;
    isTestedClassMember = false ;
  }

  public ASTPrimaryExpr(ADLCPPParser p, int id) {
    super(p, id);
    isADLInline = false ;
    isTestedClassMember = false ;
  }

  public static Node jjtCreate(int id) {
      return new ASTPrimaryExpr(id);
  }

  public static Node jjtCreate(ADLCPPParser p, int id) {
      return new ASTPrimaryExpr(p, id);
  }


  /* Implements method getType of interface Typed
   * Type check visitor first calls setType to store node Type as a property
   */ 
  public LType getType() {
   
   return primeType;
  }



  public void setType( LType visitType) {

   primeType = visitType;

}	


  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }
}
