// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTPtrOperator.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG -November,97: Added Parsing methods
//
//
// ***********************************************************************

package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.parsers.*;

public class ASTPtrOperator extends SimpleNode {
  public ASTPtrOperator(int id) {
    super(id);
  }

  public ASTPtrOperator(ADLCPPParser p, int id) {
    super(p, id);
  }

  public static Node jjtCreate(int id) {
      return new ASTPtrOperator(id);
  }

  public static Node jjtCreate(ADLCPPParser p, int id) {
      return new ASTPtrOperator(p, id);
  }


  public String getPtrstring()
  { 
    String ptrkind;
    try {
      ptrkind = (String)getProperty("ptrkind");
    } catch (PropertyAccessException e) {
      ptrkind = "";
    }
    if (ptrkind.equals("PointerTo"))
      return "* ";
    else if (ptrkind.equals("ReferenceTo"))
      return "& ";
    else if (ptrkind.equals("PointerToMember"))
      return getScopedName().Name + " * ";
    else return "";
  }


  public String getPtrkind()
  { 
    try {
    return  (String)getProperty("ptrkind");
    } catch (PropertyAccessException e) {
    return "";
    }
  }

  public void setPtrkind(String id)
  {
    try {
     if(id.equals("ReferenceTo"))
      setProperty("ptrkind", id);
     else if(id.equals("PointerTo"))
       setProperty("ptrkind",id);
     else if(id.equals("PointerToMember"))
        setProperty("ptrkind",id);
     else
         setProperty("ptrkind",null);

    } catch (PropertyAccessException e) {
    }
  }


  /** Sets the scope Override in case of Pointer to member */
  public void setScopedName( ScopedName sn ) {
    
    try {
      setProperty("scopedname",sn);
    } catch ( PropertyAccessException e) {
    }
  }

  /**returns the pointer to member scoped name.
     Called only when pointer is a  pointer to member */
  public ScopedName getScopedName() {
    
    try {
      return (ScopedName) getProperty ("scopedname");
    } catch ( PropertyAccessException e ) {
      return new ScopedName(" ",null);
    }
  }
 


  /** stores the pointer qualifier as a node property */
  public void setQualifier ( int qualif) {
    // store the integer as an object since properties are objects
    Integer storeObj = new Integer( qualif ) ;

    try {
      setProperty("qualifier",storeObj );
    } catch ( PropertyAccessException e) {
    }

  }


  /** returns an integer presenting the Pointer qualifier (const, volatile )*/ 
  public int getQualifier() {
    int result;
    try {
      result = ((Integer) getProperty("qualifier")).intValue();
    } catch ( PropertyAccessException e ) {
      result = 0x0000;
    }
    return result;
  }
      
      


  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }
}
