// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTQualifiedId.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG -October,97:Introduced Parsing methods
//     
//
// ***********************************************************************

package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.symboltable.*;
import ORG.opengroup.adl.parsers.*;

public class ASTQualifiedId extends SimpleNode {
  static private int counter=0;
  public ASTQualifiedId(int id) {
    super(id);
  }

  public ASTQualifiedId(ADLCPPParser p, int id) {
    super(p, id);
  }

  public static Node jjtCreate(int id) {
      return new ASTQualifiedId(id);
  }

  public static Node jjtCreate(ADLCPPParser p, int id) {
      return new ASTQualifiedId(p, id);
  }

 /**
   * Return the non-fully qualified identifier name saved as a property.
   * Note that in case of a scope override (e.g. "A::x" ) only non-qualified 
   * name is returned ( ie. "x").  
   */

  public String getName()  {
    try {
      return (String ) getProperty("name");
    } catch (PropertyAccessException e) {
    return null; }
  }


  /** Saves the identifier simple name as a property.
   * Note : in case of fully scoped identifier (e.g. "A::x"), use this method
   * to save only the simple identifier name (ie. "x").
   */
  public void setName(String id)
  {
    try {
      setProperty("name", id);
    } catch (PropertyAccessException e) {
    }
  }

  /** Saves the identifier full qualified  name as a property */
  public void setFullName(String id)
  {
    try {
      setProperty("fullname", id);
    } catch (PropertyAccessException e) {
    }
  }


 /** 
   * Return the fully scoped identifier name.
   * <p><b>Algorithm:</b><ul>
   * <li> return the fullname property is saved any. This occurs when the 
   * identifier is a fully scoped identifier.
   * <li> Else(case of identifier without scope override) return name property
   * </ul>
   * @result the fully identifier name.
   */
   public String getFullName()
  {
    try {
      // case of fully scoped id ( eg. "A::x")
      return (String)getProperty("fullname");
    } catch (PropertyAccessException e) {
      // case identifeir is ot fully scoped ( e.g."x")
      try {
	return (String)getProperty("name") ;
      } catch ( PropertyAccessException ee){ return "" ; }
    }
  }


  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data)
 throws ParseException {

    return visitor.visit(this, data);
  }

}
