// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTQualifiedType.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG - October,  1997: Added parsing methods
//     
//
// ***********************************************************************

package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.symboltable.LType;
import ORG.opengroup.adl.parsers.*;


public class ASTQualifiedType extends SimpleNode {
  public ASTQualifiedType(int id) {
    super(id);
  }

  public ASTQualifiedType(ADLCPPParser p, int id) {
    super(p, id);
  }

  public static Node jjtCreate(int id) {
      return new ASTQualifiedType(id);
  }

  public static Node jjtCreate(ADLCPPParser p, int id) {
      return new ASTQualifiedType(p, id);
  }



  public LType getType()  throws ParseException {
    LType resType = null;
    String typename = getTypeName() ;       
    resType =  stm.getType( typename,stm.getAdlTranslationUnit());

    if( resType == null )
      errorMessage("Error : Undefined type "+typename );

    return  resType;
  }


  public LType getQualifiedType() {
    return  qualifiedType;
  }

  public void setQualifiedType(LType type) {
    qualifiedType = type;
  }

  /** called by the unparser to retrieve type name */
  public String getTypeName() {
   try {
      return (String) getProperty("type");
   }  catch (PropertyAccessException e) { // should never occur
      return " ";
   }
  }


  public void setType(String id)
  {

    if( debug) {
      System.out.println("saving the type of "+ id+" as a node property");
    }
    try {
      setProperty("type", id);
    } catch (PropertyAccessException e) {
    }

  }
 


  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }

  //___________________ private fields____________________________________

  /* debugging display flag */
  private boolean debug = false;

  /* type manipulated in preAssertion (transformation) */
  public LType qualifiedType = null;

}
