// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTReturn.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG - November,97:Introduced Parsing methods
//
// NB : This node is created whenever 'return' is found in ADL file
// ***********************************************************************

package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.symboltable.*;
import ORG.opengroup.adl.symboltable.c.*;
import ORG.opengroup.adl.parsers.*;

public class ASTReturn extends SimpleNode implements Typed {
  public ASTReturn(int id) {
    super(id);
  }

  public ASTReturn(ADLCPPParser p, int id) {
    super(p, id);
  }

  public static Node jjtCreate(int id) {
      return new ASTReturn(id);
  }

  public static Node jjtCreate(ADLCPPParser p, int id) {
      return new ASTReturn(p, id);
  }

  /* Function Called by the Parser when constructing Return Node
   * Looks for the current ADL Function ( =current scope)
   * Looks for its return Type and store it as Return node Type.
   * The Type is stored as a node property.
   */
  public void setReturnType( LType t ) {

    try {
      if (t != null )
	setProperty("type", t);
    } catch (PropertyAccessException e) {
    }
  }

  /* Implements getType of Typed Interface. Called during Type checking.
   * Returns the type property stored during parsing
   */

  public LType getType() {
    LType retType = null;
    try{
      retType = (LType) getProperty("type");
    } catch (PropertyAccessException e) {} // should never occur

    return retType;
  }
      
    


  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }
}
