// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTString.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG - October,  1997: Added parsing methods
//
//
// ***********************************************************************

package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.symboltable.LType;
import ORG.opengroup.adl.parsers.*;

public class ASTString extends SimpleNode implements Typed {
  public ASTString(int id) {
    super(id);
  }

  public ASTString(ADLCPPParser p, int id) {
    super(p, id);
  }

  public static Node jjtCreate(int id) {
      return new ASTString(id);
  }

  public static Node jjtCreate(ADLCPPParser p, int id) {
      return new ASTString(p, id);
  }



  /**
   * Impelements getType of Typed Interface. @return is Pointer to char 
   */  
  public LType getType() {
 
    LType charType = (LType) stm.getSymbol("char");
    return sbf.newPointer(charType,0x00);
  }

    



  public void setName(String id)
  {
    try {
      setProperty("name", id);
    } catch (PropertyAccessException e) {
    }
  }


  /** returns the string stored as a node property
   */
  public String getName()
  {
    try {
      return (String) getProperty("name") ;
    } catch (PropertyAccessException e) {
    return " "; }
  }
  




  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }
}
