// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTTDDClassDecl.java
//
// HISTORY:
//      November,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG - November,97 : Introduced Parsing methods
//
//
// ***********************************************************************

package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.symboltable.*;
import ORG.opengroup.adl.symboltable.c.*;
import ORG.opengroup.adl.parsers.*;

public class ASTTDDClassDecl extends SimpleNode {
  public ASTTDDClassDecl(int id) {
    super(id);
  }

  public ASTTDDClassDecl(ADLCPPParser p, int id) {
    super(p, id);
  }

  public static Node jjtCreate(int id) {
      return new ASTTDDClassDecl(id);
  }

  public static Node jjtCreate(ADLCPPParser p, int id) {
      return new ASTTDDClassDecl(p, id);
  }

  /* called by the ADLCPPParser.TDD_ClassDEclaration
   * Creates a TDDClass, opens its scope and returns it
   */

  public TDDClass MakeUpTDDClass( String tddName, TDDClass tddClass ) 
 throws ParseException {
   tddClass.setName(tddName);
   // TBD delete -
   // TDDClass tddClass = sbf.newTDDClass(tddName);
   //     try {
   //       tddClass = (TDDClass) stm.putSymbol(tddClass);
   //     } catch ( SymbolAlreadyDefinedException e) {
   //   errorMessage("Error : TDD Class "+ tddName+" already defined");
   //     }
    if( tddClass == null)
  errorMessage("Error : Can not create TDD Class ");
    stm.setCurrentScope(stm.getUnitScope());
    stm.openScope(tddClass);
    setScope( stm.getCurrentScope());
    return tddClass;
  }
    

  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }

  //____________________ Private features____________________________________

  private boolean debug = true;


}
