// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTTDDDatasetDomain.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG - November, 1997: Added Parsing methods
//
//
// ************************************************************************

package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.symboltable.*;
import ORG.opengroup.adl.symboltable.c.*;
import ORG.opengroup.adl.parsers.*;

public class ASTTDDDatasetDomain extends SimpleNode {
  public ASTTDDDatasetDomain(int id) {
    super(id);
  }

  public ASTTDDDatasetDomain(ADLCPPParser p, int id) {
    super(p, id);
  }

  public static Node jjtCreate(int id) {
      return new ASTTDDDatasetDomain(id);
  }

  public static Node jjtCreate(ADLCPPParser p, int id) {
      return new ASTTDDDatasetDomain(p, id);
  }


  /* called by the parser to store the Named Param type as a node property */
  public void setDomainType(LType varType) {
   try {
      setProperty("domainType", varType);
    } catch (PropertyAccessException e) {
    }
  }


  /* Called by the type check  visitor when node has 2 children 
   * tells type of the ADL_NamedParam node stored as node property
   */
  public LType getDomainType() {
    try {
      return (LType) getProperty("domainType");
    } catch (PropertyAccessException e) { 
      return null;
    }
  }



  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }
}
