// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTTDDDatasetLiteral.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG -November,97: Added Parsing methods
//
//
// ***********************************************************************

package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.symboltable.LType;
import ORG.opengroup.adl.parsers.*;

public class ASTTDDDatasetLiteral extends SimpleNode implements Typed {
  public ASTTDDDatasetLiteral(int id) {
    super(id);
  }

  public ASTTDDDatasetLiteral(ADLCPPParser p, int id) {
    super(p, id);
  }

  public static Node jjtCreate(int id) {
      return new ASTTDDDatasetLiteral(id);
  }

  public static Node jjtCreate(ADLCPPParser p, int id) {
      return new ASTTDDDatasetLiteral(p, id);
  }


  /** 
   * Implements Typed interface. Returns type of the dataset expression.
   * <p><b>Algorithm:</b><ul>
   * Return type if svade as a node property. Otherwise return 1st child type.
   * </ul>
   * @result the dataset expression type.
   */
 public LType getType() {

   try {
     return (LType) getProperty("type");
   } catch (PropertyAccessException e) {
     return ( (Typed) jjtGetChild(0)).getType();
   }
 }

  /** Saves type as a node property */
  public void setType( LType curType) {

    try {
      setProperty("type",curType);
    } catch (PropertyAccessException e) {
    }
  }

  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }
}
