// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTTDDDatasetSingleton.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG - November,97:Introduced Parsing methods
//
//
// ***********************************************************************

package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.symboltable.LType;
import ORG.opengroup.adl.parsers.*;

public class ASTTDDDatasetSingleton extends SimpleNode implements Typed {
  public ASTTDDDatasetSingleton(int id) {
    super(id);
  }

  public ASTTDDDatasetSingleton(ADLCPPParser p, int id) {
    super(p, id);
  }

  public static Node jjtCreate(int id) {
      return new ASTTDDDatasetSingleton(id);
  }

  public static Node jjtCreate(ADLCPPParser p, int id) {
      return new ASTTDDDatasetSingleton(p, id);
  }

  /* Called by the type check visitor to store dataset type as a property */
  public void setType(LType datasetType)
  {
    try {
      setProperty("datasetType", datasetType);
    } catch (PropertyAccessException e) {
    }
  }

  /* Implements getType of Typed Interface
   * returns the Type of the  dataset singleton stored as a node property
   */

 public LType getType() {

   LType restype=null;

   try {
     restype=  (LType) getProperty("datasetType");
   } catch (PropertyAccessException e) {
   }

   return restype;

 }



  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }
}
