// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTTDDFactoryCall.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG - November,1997: Added Parsing methods
//
//
// ************************************************************************

package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.symboltable.LType;
import ORG.opengroup.adl.symboltable.LCallable;
import ORG.opengroup.adl.parsers.*;

public class ASTTDDFactoryCall extends SimpleNode implements Typed{
  public ASTTDDFactoryCall(int id) {
    super(id);
  }

  public ASTTDDFactoryCall(ADLCPPParser p, int id) {
    super(p, id);
  }

  public static Node jjtCreate(int id) {
      return new ASTTDDFactoryCall(id);
  }

  public static Node jjtCreate(ADLCPPParser p, int id) {
      return new ASTTDDFactoryCall(p, id);
  }



  /** Saves factory type as a node property. */
  public void setType ( LType factoryType) {

    try {
      setProperty("factoryType",factoryType);
    } catch (PropertyAccessException e) {
    }
  }


  /**
   * Implements Typed Interface and returns factory type saves as a property.
   * @result the called factory return type.
   */

 public LType getType() {
    try {
      return (LType) getProperty("factoryType");
    } catch (PropertyAccessException e) {
    return null; }

 }


  /**
    * Saves factory signature as a node property.
    */
  public void setSignature ( LCallable sign) {

    try {
      setProperty("factorySignature", sign);
    } catch (PropertyAccessException e) { }
  }


  /**
    * Returns factory signature as a node property.
    */
  public LCallable getSignature () {

    LCallable ret = null;
    try {
      ret = (LCallable)getProperty("factorySignature");
    } catch (PropertyAccessException e) { }
    return ret;
  }


  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }
}
