// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTTDDFieldDeclaration.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG - October,  1997: Updated
//     
//
// ***********************************************************************

package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.parsers.ParseException;
import ORG.opengroup.adl.symboltable.LType ;
import java.util.Vector ;

public class ASTTDDFieldDeclaration extends SimpleNode {

  /** vector containing declarator types */
  private Vector types = new Vector() ;
  public ASTTDDFieldDeclaration(int id) {
    super(id);
  }

  public ASTTDDFieldDeclaration(ADLCPPParser p, int id) {
    super(p, id);
  }

  /** Adds declarator type to declarator vector */
  public void addDeclaratorType( LType type )
  {
    types.addElement( type );
  }

  /** Returns TDD field declarators type vector */
  public Vector getTypes() {
    return types ;
  }

  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }
}
