// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTTDDTestDirective.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG - November,1997: Added Parsing methods
//
//
// ************************************************************************

package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.symboltable.Scope ;
import ORG.opengroup.adl.parsers.*;

public class ASTTDDTestDirective extends SimpleNode {
  public ASTTDDTestDirective(int id) {
    super(id);
  }

  public ASTTDDTestDirective(ADLCPPParser p, int id) {
    super(p, id);
  }

  public static Node jjtCreate(int id) {
      return new ASTTDDTestDirective(id);
  }

  public static Node jjtCreate(ADLCPPParser p, int id) {
      return new ASTTDDTestDirective(p, id);
  }

  /* called by the parser to store the lanel of the node as a property */
  public void setLabelName(String label) {
    try {
      setProperty("labelName", label);
    } catch (PropertyAccessException e) {
    }
  }

  /* called by unparser to the node label
   * if node has no label, return ""
   */
  public String getLabelName() {
    try {
      return  (String) getProperty("labelName");
    } catch (PropertyAccessException e) { 
      return "";
    }
  }


  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }
}
