// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTTranslationUnit.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG - October,  1997: Updated
//     
//
// ***********************************************************************

package ORG.opengroup.adl.parsers.adlcpp;

import java.io.PrintStream;
import ORG.opengroup.adl.parsers.*;

public class ASTTranslationUnit extends SimpleNode {
  public ASTTranslationUnit(int id) {
    super(id);
  }

  public ASTTranslationUnit(ADLCPPParser p, int id) {
    super(p, id);
  }

  /** overrides dumpNode method of SimpleNode. displays filename to be included */
  protected void dumpNode(PrintStream o, String label, String pad, int level) {


    if (debug) {
      System.out.println(" Translation Unit Name : " + getName());
    }
    super.dumpNode(o,label,pad,level);

  }


  public static Node jjtCreate(int id) {
      return new ASTTranslationUnit(id);
  }

  public static Node jjtCreate(ADLCPPParser p, int id) {
      return new ASTTranslationUnit(p, id);
  }

  /**
   *  Called by the parser and the translater to store file class name in it
   */
  public void setName(String id)
  {
    try {
      setProperty("name", id);
    } catch (PropertyAccessException e) {

    }
  }

 


  /**
   *Called by translator to save Translation Unit file extension "cc" or "hh"
   */
  public void setNodeExtension(String id)
  {
    try {
      setProperty("extension", id);
    } catch (PropertyAccessException e) {
    }
  }

  /**
   * Returns translation unit file extension used by unparser for file naming
   */
  public String getNodeExtension()
  {
    try {
      return (String)getProperty("extension");
    } catch (PropertyAccessException e) {
    return "hh"; }
  }



  /**
   * Returns the translation unit name used in the unparser for file naming
   */
  public String getName()
  {
    try {
      return (String) getProperty("name");
    } catch (PropertyAccessException e) {
    return "" ; }
  }


  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }


}
