// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTTypeName.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG -November,97: Added Parsing methods
//
//
// ***********************************************************************

package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.symboltable.*;
import ORG.opengroup.adl.parsers.*;

public class ASTTypeName extends SimpleNode implements Typed {
  public ASTTypeName(int id) {
    super(id);
  }

  public ASTTypeName(ADLCPPParser p, int id) {
    super(p, id);
  }

  /** Saves Cast expression type as a node property  */
  public void setType( LType type) {
 
    try {
      setProperty("type",type);
    } catch( PropertyAccessException e) {
      
    }

  }

  /** implements method getType of Typed interface saved as a node property */
  public LType getType() {
    try {
      return (LType) getProperty("type");
    }  catch( PropertyAccessException e) {
      // return null otherwise
      return null ;
    }
  }


  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }
}
