// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   adlcppparser
// NAME:        ASTDirectDeclarator.java
//
// HISTORY:
//      October,97 : Generated by JJTree
//      Wassel BERRAYANA, TOG - October,  1997: Updated
//     
//
// ***********************************************************************

package ORG.opengroup.adl.parsers.adlcpp;

import ORG.opengroup.adl.symboltable.*;
import ORG.opengroup.adl.parsers.*;

public class ASTUnaryExpr extends SimpleNode implements Typed {
  public ASTUnaryExpr(int id) {
    super(id);
  }

  public ASTUnaryExpr(ADLCPPParser p, int id) {
    super(p, id);
  }

  public static Node jjtCreate(int id) {
      return new ASTUnaryExpr(id);
  }

  public static Node jjtCreate(ADLCPPParser p, int id) {
      return new ASTUnaryExpr(p, id);
  }

 public void setOp(String id)
  {
    try {
      setProperty("op", id);
    } catch (PropertyAccessException e) {
    }
  }


  /** Method called to tell the stored operator recovered at parsing  */
  public String getOp() {
 
   try {
      return (String) getProperty("op");
   }  catch (PropertyAccessException e) {
      return "";
   }

  }

  /**
   * Returns unary expression type as a node property.
   * Impelements interface Typed
   * @result expression return type.
   */
  public LType getType() {
    try {
      return (LType) getProperty("type");
    } catch (PropertyAccessException e) {
      return ((Typed)jjtGetChild(0)).getType();
    }
  }


  /** Saves unary expression as a node property.*/ 
  public void setType( LType type)  {
    try {
      setProperty("type",type);
    } catch (PropertyAccessException e) {
    }
  }




  /** Accept the visitor. **/
  public Object jjtAccept(ADLCPPParserVisitor visitor, Object data) throws ParseException {
    return visitor.visit(this, data);
  }
}
