// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/ORG/opengroup/adl/parsers/adljava/ADLDumpVisitor.java,v $
// $Revision: 1.6 $
// $Date: 1998/04/15 13:55:22 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   ADL Java Parser
// NAME:        ADLDumpVisitor.java
//
// ***********************************************************************

package ORG.opengroup.adl.parsers.adljava;

import ORG.opengroup.adl.parsers.*;

public class ADLDumpVisitor implements ADLJavaParserVisitor
{

  private int indent = 0;

  private String indentString() {
    StringBuffer sb = new StringBuffer();
    for (int i = 0; i < indent; ++i) {
      sb.append(" ");
    }
    return sb.toString();
  }

  public Object visit(SimpleNode node,Object data) {
    System.out.println(indentString() + node +
		       ": acceptor not unimplemented in subclass?");
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }


  public Object visit(ASTADL_CompilationUnit node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTCompilationUnit node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTPackageDeclaration node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTImportDeclaration node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTTDD_UseDeclaration node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTADL_ClassDeclaration node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTADL_InlineDeclaration node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTADL_BehaviorDeclaration node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTADL_Prologue node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTADL_Epilogue node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTADL_BehaviorSpecification node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTADL_NormalBehavior node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTADL_AbNormalBehavior node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTADL_BehaviorClassification node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTADL_AssertionGroup node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTADL_Binding node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTADL_Statement node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTADL_TryStatement node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTADL_IfStatement node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTADL_Assertion node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTADL_Label node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTADL_Tags node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTADL_QuantifiedAssertion node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTADL_Quantifier node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTTDD_ADLnewExpression node, Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }
  public Object visit(ASTTDD_ADLExpression node, Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTADL_ImplExpression node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTADL_ImplOp node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTConditionalExpression node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTConditionalOrExpression node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTConditionalAndExpression node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTInclusiveOrExpression node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTExclusiveOrExpression node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTAndExpression node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTEqualityExpression node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTInstanceOfExpression node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTRelationalExpression node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTShiftExpression node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTAdditiveExpression node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTMultiplicativeExpression node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTUnaryPlusMinus node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTPreIncrementExpression node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTPreDecrementExpression node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTUnaryNotPlusMinus node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTADL_CallStateExpression node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTCastExpression node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTADL_Normal node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTADL_Abnormal node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTADL_Return node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTADL_Unchanged node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTPrimaryExpression node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTThisPrefix node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTSuperPrefix node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTDotSuffix node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTBracketSuffix node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTADL_SuperSemantics node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTParenthExpression node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTIntegerLiteral node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTFloatLiteral node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTCharacterLiteral node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTStringLiteral node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTBooleanLiteral node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTNullLiteral node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTArguments node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTArgumentList node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTAllocationExpression node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTArrayDimensions node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTADL_ThrownExpression node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTADL_DomainList node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTADL_Domain node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTVariableDeclaratorId node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTMethodDeclarator node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTFormalParameters node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTFormalParameter node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTType node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTResultType node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTName node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTNameList node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTTDD_DatasetDeclaration node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTTDD_FactoryDeclaration node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTTDD_TestDirective node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTTDD_DatasetDomain node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTTDD_DatasetLiteral node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTTDD_FactoryCall node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTTDD_DatasetSingleton node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }


  public Object visit(ASTTDD_SingleDeclarator node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTTDD_DatasetMember node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTTDD_DatasetExpr node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTTDD_DatasetConcatenationExpr node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTTDD_ClassDeclaration node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTTDD_ClassBodyDeclaration node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTTDD_FieldDeclaration node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTClassDeclaration node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTClassBodyDeclaration node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTInterfaceDeclaration node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTInterfaceMemberDeclaration node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTFieldDeclaration node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTStaticInitializer node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTConstructorDeclaration node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTMethodDeclaration node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTStatement node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTVariableDeclarator node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTBlock node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTExplicitConstructorInvocation node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTBlockStatement node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTLabeledStatement node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTEmptyStatement node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTSwitchStatement node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTSwitchLabel node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTIfStatement node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTWhileStatement node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTDoStatement node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTForStatement node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTForInit node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTBreakStatement node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTContinueStatement node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTReturnStatement node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTThrowStatement node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTSynchronizedStatement node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTTryStatement node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTExpression node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTVariableInitializer node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTLocalVariableDeclaration node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTAssignment node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTPostfixExpression node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTStatementExpressionList node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

  public Object visit(ASTForUpdate node,Object data) {
    System.out.println(indentString() + node + " nb children: " + node.jjtGetNumChildren());
    ++indent;
    node.childrenAccept(this,data);
    --indent;
    return null;
  }

}

// ***********************************************************************
// History Log:
// $Log: ADLDumpVisitor.java,v $
// Revision 1.6  1998/04/15 13:55:22  bareau
// Added support for NL processing. NLD annotations are tokenized
// and sent to a distinct NLD parser (hence there is no more NLD_*
// productions in the ADL/TDD grammars).
// A handle for the NL engine associated to the current compiler is
// provided.
//
// Revision 1.5  1998/02/27 12:53:51  cinard
// Updated copyright notice.
//
// Revision 1.4  1998/02/25 10:39:13  mallet
// Added visit for ASTCompilationUnit and ASTPackageDeclaration.
//
// Revision 1.3  1998/02/12 16:02:56  mallet
// Fixed copyright notice: TOG RI -> TOG, year extended to 1998 for TOG
// and IPA.
//
// Revision 1.2  1998/01/05 15:55:53  mallet
// Added standard header.
//
// ***********************************************************************
