//
// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
//
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
//
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
// ***********************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/ORG/opengroup/adl/runtime/ADLResultCodes.java,v $
// $Revision: 1.10 $
// $Date: 1998/08/06 14:09:40 $
// PRODUCT:	Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:	ADL Java Runtime Environment: result codes
// NAME:	ADLResultCodes.java
// 	
// HISTORY:
// 	Lionel Mallet, The Open Group RI - Oct 29, 1997: Created
//      See Log at end of file
// 		
// ***********************************************************************

package ORG.opengroup.adl.runtime;


/**
 *  Definition of the result codes to use when reporting to TET.
 */
public interface ADLResultCodes {

  /** code for "test has passed" */
  public static final int ADL_PASS = 0;
  /** code for "test has failed" */
  public static final int ADL_FAIL = 1;
  /** code for "evaluation of the test could not be determined" */
  public static final int ADL_UNRESOLVED = 2;
  /** code for "test is not evaluated in this environment" */
  public static final int ADL_NOTINUSE = 3;
  /** code for "test is not supported" */
  public static final int ADL_UNSUPPORTED = 4;
  /** code for "test was not done" */
  public static final int ADL_UNTESTED = 5;
  /** code for "test was not started" */
  public static final int ADL_UNINITIATED = 6;
  /** code for "test did not yield a result" */
  public static final int ADL_NORESULT = 7;
  /** code for "assertion was not evaluated" */
  public static final int ADL_UNEVALUATED = 1003;
  /** Code for "execution error in ADL generated code" */
  public static final int ADL_ERROR = 1004;
  /** code for "assertions were skipped" */
  public static final int ADL_SKIPPED = 1005;
  /** code for "abnormal and normal both evaluated to true" */
  public static final int ADL_AMBIGUOUS = 1006;
  /** code for "abnormal and normal both evaluated to false" */
  public static final int ADL_UNDEFINED = 1007;
}

// ***********************************************************************
// History Log:
// $Log: ADLResultCodes.java,v $
// Revision 1.10  1998/08/06 14:09:40  mallet
// Moved Java runtime source tree in /afs/gr/users/mallet/Adl/adl2/src/ORG/opengroup/adl/runtime.
//
// Revision 1.9  1998/02/27 10:08:31  mallet
// Updated copyright notice.
//
// Revision 1.8  1998/02/12 16:04:35  mallet
// Fixed copyright notice: TOG RI -> TOG, year extended to 1998 for TOG
// and IPA.
//
// Revision 1.7  1998/02/12 14:03:21  bareau
// Bug fix: missing final "}".
//
// Revision 1.6  1998/02/11 18:42:40  shane
// Reordered codes and changed numbering to match that of ADL1.
// Added ADL_ERROR code for execution error - should never happen, but it was
// available in ADL1.
//
// Revision 1.5  1998/02/11 18:18:34  mallet
// Added ADL_SKIPPED code which is raised by tdd_skip.
//
// Revision 1.4  1998/01/08 14:40:44  mallet
// Updated and fixed javadoc comments.
//
// Revision 1.3  1997/12/23 09:11:47  mallet
// Fixed javadoc comments.
//
// Revision 1.2  1997/11/26 13:59:47  mallet
// Fixed runtime package name: now ORG.opengroup.adl.runtime.
//
// Revision 1.1  1997/10/29 09:52:50  mallet
// Added an interface to provide access to result codes to use when
// reporting to TET. This interface is currently implemented by ADLTest,
// ADLFactorySet and ObjectACO.
//
//
// ***********************************************************************
