// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/ORG/opengroup/adl/symboltable/AmbiguousRequestException.java,v $
// $Revision: 1.5 $
// $Date: 1998/02/27 12:48:22 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   symboltable
// NAME:        AmbiguousRequestException.java
//
// HISTORY:
//      Cyril Inard d'Argence, TOG - Oct 29,  1997: Created
//      See Log at end of file
//
// ***********************************************************************


package ORG.opengroup.adl.symboltable;

/**
 *  Exception that should be thrown when several symbols satisfies a 
 *  getSymbol() request .
 */

public class AmbiguousRequestException extends Exception
{
   /**
    * Constructs the ambiguous request exception. 
    */
   public AmbiguousRequestException() 
   {
      super();
   }

   /**
    * Constructs the ambiguous request exception. 
    * @param s the detailed message.
    */
   public AmbiguousRequestException(String s) 
   {
      super(s);
   }
}

// ***********************************************************************
// History Log:
// $Log: AmbiguousRequestException.java,v $
// Revision 1.5  1998/02/27 12:48:22  cinard
// Introduced a new flag (localSearch) in getSymbol() and likes methods. A local
// search is restricted to the current (or supplied) scope, that is if the
// searched symbol is not found in current or supplied scope, the research
// does not continue in the parent scopes.
// Updated copyright notice.
//
// Revision 1.4  1998/02/12 16:03:02  mallet
// Fixed copyright notice: TOG RI -> TOG, year extended to 1998 for TOG
// and IPA.
//
// Revision 1.3  1998/01/12 13:19:01  cinard
// Updated and fixed javadoc comments.
//
// Revision 1.2  1997/11/26 17:12:54  cinard
// Changed package name.
//
// Revision 1.1  1997/11/03 13:01:33  cinard
// Added some classes and exceptions.
//
// ***********************************************************************
