// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/ORG/opengroup/adl/symboltable/FileScope.java,v $
// $Revision: 1.1 $
// $Date: 1998/05/27 09:44:17 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   symboltable
// NAME:        FileScope.java
//
// HISTORY:
//      Cyril Inard d'Argence, TOG - Nov 06,  1997: Created
//      See Log at end of file
//
// ***********************************************************************

package ORG.opengroup.adl.symboltable;

import java.util.Enumeration;
import java.util.Vector ;

/**
 * Interface for scopes that are directly related to a file.
 * Support for include mechanism (e.g. c and c++ #include).
 */

public interface FileScope extends Scope
{

  /**
   * Get the name of the underlying file.
   */

  public String getFileName();

  /**
   * Add an included file scope.
   */

  public void addIncludedFile(FileScope fileScope);

  /**
   * Indicate parsing is completed for this file, and recursively
   * for all included files.
   */

  public void setParsingCompleted();

  /**
   * Is parsing completed?
   */

  public boolean isParsingCompleted();

}

// ***********************************************************************
// History Log:
// $Log: FileScope.java,v $
// Revision 1.1  1998/05/27 09:44:17  cinard
// Added support for FileScope interface.
//
// ***********************************************************************
