// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/ORG/opengroup/adl/symboltable/LArray.java,v $
// $Revision: 1.13 $
// $Date: 1998/02/27 12:48:22 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   symboltable
// NAME:        LArray.java
//
// HISTORY:
//      Cyril Inard d'Argence, TOG - Oct 09,  1997: Created
//      See Log at end of file
//
// ***********************************************************************

package ORG.opengroup.adl.symboltable;


/**
 *  Interface for target language Array Symbol.
 */

public interface LArray extends LType
{
  /**
   * Get the type of the elements in this array.
   * @return The element's type.
   */

  public LType getElementType();
  
  /**
   * Set type of the array's elements.
   * @param elememtType type of the elements in the array.
   */

  public void setElementType(LType elememtType);

  /**
   * Array level (dimension).
   */

  public int getArrayLevel();

}

// ***********************************************************************
// History Log:
// $Log: LArray.java,v $
// Revision 1.13  1998/02/27 12:48:22  cinard
// Introduced a new flag (localSearch) in getSymbol() and likes methods. A local
// search is restricted to the current (or supplied) scope, that is if the
// searched symbol is not found in current or supplied scope, the research
// does not continue in the parent scopes.
// Updated copyright notice.
//
// Revision 1.12  1998/02/23 15:08:50  cinard
// Modified symbols inheritance tree. Now LType and its subclasses are
// interfaces. New L...Impl classes provide implementation for these
// interfaces. New L...Typedef classes provide implementations for
// typedefs (C and C++).
//
// Typedefs are created using the SymbolTableManager.newTypedef()
// method.
//
// Revision 1.11  1998/02/12 16:03:03  mallet
// Fixed copyright notice: TOG RI -> TOG, year extended to 1998 for TOG
// and IPA.
//
// Revision 1.10  1998/01/27 13:24:47  wassel
// synthesisType implmenting default type synthesis behavior in LType based in calls to assignable method.
// Removed syntheisType from LArray.
// Some fields and methods made public or protected in LReference, LPointer and LPointerToFunction.
//
// Revision 1.9  1998/01/19 18:07:56  bareau
// Added method getArrayLevel().
//
// Revision 1.8  1998/01/12 13:19:01  cinard
// Updated and fixed javadoc comments.
//
// Revision 1.7  1998/01/06 13:19:08  wassel
// Added methods synthesisType for type checking
//
// Revision 1.6  1997/12/08 12:58:40  cinard
// Added a new type check mechanism.
// Fixed some bugs.
//
// Revision 1.5  1997/11/26 17:12:55  cinard
// Changed package name.
//
// Revision 1.4  1997/11/19 15:47:51  cinard
// Method getElementType() is now public.
//
// Revision 1.3  1997/11/12 13:43:10  cinard
// Corrected some bugs.
// Replaced LCallableSearcher class with LCallableAssignComparator and
// LCallableEqualsComparator classes.
// Added LModuleComparator and LTypeComparator classes (useful for
// Java names classification).
//
// Revision 1.2  1997/11/03 12:59:55  cinard
// Improved scope management : duplicates in LClass scope allowed.
// Added PoinerToFunction class.
//
// Revision 1.1  1997/10/27 11:18:02  cinard
// Added language independant symbols to the symboltable package.
//
//
// ***********************************************************************
