// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/ORG/opengroup/adl/symboltable/LModifier.java,v $
// $Revision: 1.7 $
// $Date: 1998/02/27 12:48:31 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   symboltable
// NAME:        LModifier.java
//
// HISTORY:
//      Cyril Inard d'Argence, TOG - Oct 21,  1997: Created
//      See Log at end of file
//
// ***********************************************************************

package ORG.opengroup.adl.symboltable;

/**
 *  Superclass for modifiers.
 */

public class LModifier
{

  /** 
   * Constructs modifier and set bitmask that of modifier.
   * @param modifier bit mask for the bits to set.
   */

  public LModifier(int modifier)
  {
     this.modifier = modifier;
  }

  /**
   * Set bits in modifier.
   * @param bitMask bit mask indicating the bits to set.
   */

  public void set(int bitMask) { modifier |= bitMask; }

  /**
   * Returns a string describing the modifier flag.
   */

  public String toString()
  {
     if (debug) { System.out.println("In LModifier.toString()"); }
     return "";
  }

  /**
   * Returns the Modifier code.
   */

  public int getModifierCode() {  return modifier; }


  // -- Protected fields --

  /** Modifier. */
  protected int modifier = 0x0000;

  /** Debug flag. */
  static public boolean debug = false;

}


// ***********************************************************************
// History Log:
// $Log: LModifier.java,v $
// Revision 1.7  1998/02/27 12:48:31  cinard
// Introduced a new flag (localSearch) in getSymbol() and likes methods. A local
// search is restricted to the current (or supplied) scope, that is if the
// searched symbol is not found in current or supplied scope, the research
// does not continue in the parent scopes.
// Updated copyright notice.
//
// Revision 1.6  1998/02/12 16:03:09  mallet
// Fixed copyright notice: TOG RI -> TOG, year extended to 1998 for TOG
// and IPA.
//
// Revision 1.5  1998/01/12 13:19:07  cinard
// Updated and fixed javadoc comments.
//
// Revision 1.4  1998/01/06 13:25:06  wassel
// Added method getModifierCode
//
// Revision 1.3  1997/11/26 17:13:00  cinard
// Changed package name.
//
// Revision 1.2  1997/11/12 13:43:17  cinard
// Corrected some bugs.
// Replaced LCallableSearcher class with LCallableAssignComparator and
// LCallableEqualsComparator classes.
// Added LModuleComparator and LTypeComparator classes (useful for
// Java names classification).
//
// ***********************************************************************
