// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/ORG/opengroup/adl/symboltable/LPointer.java,v $
// $Revision: 1.15 $
// $Date: 1998/04/28 12:10:16 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   symboltable
// NAME:        Pointer.java
//
// HISTORY:
//      Cyril Inard d'Argence, TOG - Oct 22,  1997: Created
//      See Log at end of file
//
// ***********************************************************************

package ORG.opengroup.adl.symboltable;

/**
 *  Interface for pointers symbols.
 */

public interface LPointer extends LType
{

  /**
   * Returns the pointed type.
   */

  public LType getPointedToType();

  /**
   * Set pointed to type.
   */

  public void setPointedToType(LType pointed);

}

// ***********************************************************************
// History Log:
// $Log: LPointer.java,v $
// Revision 1.15  1998/04/28 12:10:16  cinard
// Added a method setPointedToType().
// Allow null pointed types (setPointedToType() enable to define the
// pointed to type later ina case it was not supplied at construction time).
//
// Revision 1.14  1998/02/27 12:48:33  cinard
// Introduced a new flag (localSearch) in getSymbol() and likes methods. A local
// search is restricted to the current (or supplied) scope, that is if the
// searched symbol is not found in current or supplied scope, the research
// does not continue in the parent scopes.
// Updated copyright notice.
//
// Revision 1.13  1998/02/23 15:08:58  cinard
// Modified symbols inheritance tree. Now LType and its subclasses are
// interfaces. New L...Impl classes provide implementation for these
// interfaces. New L...Typedef classes provide implementations for
// typedefs (C and C++).
//
// Typedefs are created using the SymbolTableManager.newTypedef()
// method.
//
// Revision 1.12  1998/02/12 16:03:11  mallet
// Fixed copyright notice: TOG RI -> TOG, year extended to 1998 for TOG
// and IPA.
//
// Revision 1.11  1998/01/27 13:24:48  wassel
// synthesisType implmenting default type synthesis behavior in LType based in calls to assignable method.
// Removed syntheisType from LArray.
// Some fields and methods made public or protected in LReference, LPointer and LPointerToFunction.
//
// Revision 1.10  1998/01/22 11:42:29  cinard
// Fixed a bug in symbols equality checks.
//
// Revision 1.9  1998/01/12 13:19:10  cinard
// Updated and fixed javadoc comments.
//
// Revision 1.8  1997/12/08 12:58:44  cinard
// Added a new type check mechanism.
// Fixed some bugs.
//
// Revision 1.7  1997/11/28 17:01:35  wassel
// Added Methods getPointedToType in files LPointer.java and LPointerToFunction
// These methods return types to which pointers point.
//
// Revision 1.6  1997/11/26 17:13:02  cinard
// Changed package name.
//
// Revision 1.5  1997/11/13 09:43:30  cinard
// Improved Builtin type management. Notably symboltable.c.CSymbolTableMgr.
// getBuiltinType() handles all forms of builtin types names.
//
// Revision 1.4  1997/11/12 14:21:51  rami
// Corrected bug in equals method for pointers.
//
// Revision 1.3  1997/11/12 13:43:20  cinard
// Corrected some bugs.
// Replaced LCallableSearcher class with LCallableAssignComparator and
// LCallableEqualsComparator classes.
// Added LModuleComparator and LTypeComparator classes (useful for
// Java names classification).
//
// Revision 1.2  1997/11/03 13:00:00  cinard
// Improved scope management : duplicates in LClass scope allowed.
// Added PoinerToFunction class.
//
// Revision 1.1  1997/10/27 11:18:05  cinard
// Added language independant symbols to the symboltable package.
//
//
// ***********************************************************************
