// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/ORG/opengroup/adl/symboltable/LPointerToFunctionMember.java,v $
// $Revision: 1.6 $
// $Date: 1998/02/27 12:48:35 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   symboltable
// NAME:        LPointerToFunctionMember.java
//
// HISTORY:
//      Wassel BERRAYANA, TOG - Dec 22,  1997: Created
//      See Log at end of file
//
// ***********************************************************************

package ORG.opengroup.adl.symboltable;

/**
 *  Interface for pointer to function member.
 */

public interface LPointerToFunctionMember extends LType
{

  /**
   * Get the pointed comparator.
   * @result the pointed comparator.
   */

  public LCallableEqualsComparator getPointedComparator();

  /**
   * Type pointed To by the current LPointerToFunctionMember.
   */

  public LType getPointedToType();

  /**
   * Class whose this LPointerToFunctionMember is pointing to its members.
   */

  public LConstructedType getEnclosingClass();

}

