// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/ORG/opengroup/adl/symboltable/LPointerToFunctionMemberTypedef.java,v $
// $Revision: 1.2 $
// $Date: 1998/02/27 12:48:36 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   symboltable
// NAME:        LPointerToFunctionMemberTypedef.java
//
// HISTORY:
//      Wassel BERRAYANA, TOG - Dec 22,  1997: Created
//      See Log at end of file
//
// ***********************************************************************

package ORG.opengroup.adl.symboltable;

/**
 *  Typedef over LPointerToFunctionMember.
 */

public class      LPointerToFunctionMemberTypedef 
       extends    LTypedef
       implements LPointerToFunctionMember
                                          
{

  /**
   * Constructs a typedef over the supplied type.
   * @param name name of the typedef.
   * @param type type for which the typedef is defined.
   */

  protected LPointerToFunctionMemberTypedef(String                   name,
                                            LPointerToFunctionMember type)
  {
     super(name,type);
  }


  /**
   * Get the pointed comparator.
   * @result the pointed comparator.
   */

  public LCallableEqualsComparator getPointedComparator() 
  {
     return ((LPointerToFunctionMember)getRealType()).getPointedComparator();
  }

  /**
   * Type pointed to by the current LPointerToFunctionMember.
   */

  public LType getPointedToType() 
  {
     return ((LPointerToFunctionMember)getRealType()).getPointedToType();
  }


  /**
   * Class whose this LPointerToFunctionMember is pointing to its members.
   */

  public LConstructedType getEnclosingClass()
  {
     return ((LPointerToFunctionMember)getRealType()).getEnclosingClass();
  }

}

// ***********************************************************************
// History Log:
// $Log: LPointerToFunctionMemberTypedef.java,v $
// Revision 1.2  1998/02/27 12:48:36  cinard
// Introduced a new flag (localSearch) in getSymbol() and likes methods. A local
// search is restricted to the current (or supplied) scope, that is if the
// searched symbol is not found in current or supplied scope, the research
// does not continue in the parent scopes.
// Updated copyright notice.
//
// Revision 1.1  1998/02/23 15:09:01  cinard
// Modified symbols inheritance tree. Now LType and its subclasses are
// interfaces. New L...Impl classes provide implementation for these
// interfaces. New L...Typedef classes provide implementations for
// typedefs (C and C++).
//
// Typedefs are created using the SymbolTableManager.newTypedef()
// method.
//
// ***********************************************************************
