// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/ORG/opengroup/adl/symboltable/LReferenceToFunction.java,v $
// $Revision: 1.8 $
// $Date: 1998/02/27 12:48:38 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   symboltable
// NAME:        LReferenceToFunction.java
//
// HISTORY:
//      Cyril Inard d'Argence, TOG - Oct 22,  1997: Created
//      See Log at end of file
//
// ***********************************************************************

package ORG.opengroup.adl.symboltable;

/**
 *  Interface for reference to function symbols.
 */

interface LReferenceToFunction extends LType
{

  /** 
   * Referenced function.
   */

  public LCallableEqualsComparator getReferencedFunction();
}

// ***********************************************************************
// History Log:
// $Log: LReferenceToFunction.java,v $
// Revision 1.8  1998/02/27 12:48:38  cinard
// Introduced a new flag (localSearch) in getSymbol() and likes methods. A local
// search is restricted to the current (or supplied) scope, that is if the
// searched symbol is not found in current or supplied scope, the research
// does not continue in the parent scopes.
// Updated copyright notice.
//
// Revision 1.7  1998/02/23 15:09:02  cinard
// Modified symbols inheritance tree. Now LType and its subclasses are
// interfaces. New L...Impl classes provide implementation for these
// interfaces. New L...Typedef classes provide implementations for
// typedefs (C and C++).
//
// Typedefs are created using the SymbolTableManager.newTypedef()
// method.
//
// Revision 1.6  1998/02/12 16:03:14  mallet
// Fixed copyright notice: TOG RI -> TOG, year extended to 1998 for TOG
// and IPA.
//
// Revision 1.5  1998/01/12 13:19:11  cinard
// Updated and fixed javadoc comments.
//
// Revision 1.4  1997/12/08 12:58:44  cinard
// Added a new type check mechanism.
// Fixed some bugs.
//
// Revision 1.3  1997/11/26 17:13:03  cinard
// Changed package name.
//
// Revision 1.2  1997/11/12 13:43:21  cinard
// Corrected some bugs.
// Replaced LCallableSearcher class with LCallableAssignComparator and
// LCallableEqualsComparator classes.
// Added LModuleComparator and LTypeComparator classes (useful for
// Java names classification).
//
// Revision 1.1  1997/11/04 16:04:23  cinard
// Made some modification for C and C++ parsers.
//
// ***********************************************************************
