// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/ORG/opengroup/adl/symboltable/LReferenceTypedef.java,v $
// $Revision: 1.3 $
// $Date: 1998/04/28 12:15:12 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   symboltable
// NAME:        ReferenceTypedef.java
//
// HISTORY:
//      Cyril Inard d'Argence, TOG - Feb 18,  1998: Created
//      See Log at end of file
//
// ***********************************************************************

package ORG.opengroup.adl.symboltable;

/**
 *  Typedef for LReference.
 */

public class LReferenceTypedef extends    LTypedef
                               implements LReference
{

  /**
   * Constructs a typedef over the supplied type.
   * @param name name of the typedef.
   * @param type type for which the typedef is defined.
   */

  protected LReferenceTypedef(String name,LReference type)
  {
     super(name,type);
  }

  /**
   * Get the referenced type.
   * @return the referenced type.
   */

  public LType getReferenced()
  {
     return ((LReference)getRealType()).getReferenced();
  }

  /**
   * Set referenced type.
   */

  public void setReferenced(LType referenced)
  {
     ((LReference)getRealType()).setReferenced(referenced);
  }

}

// ***********************************************************************
// History Log:
// $Log: LReferenceTypedef.java,v $
// Revision 1.3  1998/04/28 12:15:12  cinard
// Added a method setReferencedType().
// Allow null pointed types (setReferencedType() enable to define the
// referenced type later in case it was not supplied at construction time).
//
// Revision 1.2  1998/02/27 12:48:39  cinard
// Introduced a new flag (localSearch) in getSymbol() and likes methods. A local
// search is restricted to the current (or supplied) scope, that is if the
// searched symbol is not found in current or supplied scope, the research
// does not continue in the parent scopes.
// Updated copyright notice.
//
// Revision 1.1  1998/02/23 15:09:03  cinard
// Modified symbols inheritance tree. Now LType and its subclasses are
// interfaces. New L...Impl classes provide implementation for these
// interfaces. New L...Typedef classes provide implementations for
// typedefs (C and C++).
//
// Typedefs are created using the SymbolTableManager.newTypedef()
// method.
//
// ***********************************************************************
