// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/ORG/opengroup/adl/symboltable/SymbolAlreadyDefinedException.java,v $
// $Revision: 1.5 $
// $Date: 1998/02/27 12:48:44 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   symboltable
// NAME:        SymbolAlreadyDefinedException.java
//
// HISTORY:
//      Cyril Inard d'Argence, TOG - Oct 29,  1997: Created
//      See Log at end of file
//
// ***********************************************************************


package ORG.opengroup.adl.symboltable;

/**
 *  Exception that should be thrown when trying to put a symbol in the
 *  symbol table and this symbol was already defined.
 */

public class SymbolAlreadyDefinedException extends Exception
{
   /**
    * Constructs the exception. 
    */
   public SymbolAlreadyDefinedException() 
   {
      super();
   }

   /**
    * Constructs the exception. 
    * @param s the detailed message.
    */
   public SymbolAlreadyDefinedException(String s) 
   {
      super(s);
   }
}

// ***********************************************************************
// History Log:
// $Log: SymbolAlreadyDefinedException.java,v $
// Revision 1.5  1998/02/27 12:48:44  cinard
// Introduced a new flag (localSearch) in getSymbol() and likes methods. A local
// search is restricted to the current (or supplied) scope, that is if the
// searched symbol is not found in current or supplied scope, the research
// does not continue in the parent scopes.
// Updated copyright notice.
//
// Revision 1.4  1998/02/12 16:03:20  mallet
// Fixed copyright notice: TOG RI -> TOG, year extended to 1998 for TOG
// and IPA.
//
// Revision 1.3  1998/01/12 13:19:14  cinard
// Updated and fixed javadoc comments.
//
// Revision 1.2  1997/11/26 17:13:05  cinard
// Changed package name.
//
// Revision 1.1  1997/11/04 16:04:25  cinard
// Made some modification for C and C++ parsers.
//
//
// ***********************************************************************
