// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/ORG/opengroup/adl/symboltable/SymbolListener.java,v $
// $Revision: 1.5 $
// $Date: 1998/02/27 12:48:45 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   symboltable
// NAME:        SymbolListener.java
//
// HISTORY:
//      Cyril Inard d'Argence, TOG - Oct 09,  1997: Created
//      See Log at end of file
//
// ***********************************************************************

package ORG.opengroup.adl.symboltable;

/**
 * Interface that shall be implemented by any object that is interested 
 * in a symbol but that could not get it using the getSymbol(...) call 
 * because the symbol was not available at that time.
 * <p>Actually if the symbol is not found during a getSymbol(...) call, the
 * SymbolListener object may be called back later when the symbol is found.
 * This is useful for languages thaat allows to use symbols befor they
 * are defined (e.g. method calls in Java).
 */

public interface SymbolListener
{
   /**
    * This method is called when the requested symbol is found
    * @param s The symbol that was found.
    */
   public void symbolFound(Symbol s);
}

// ***********************************************************************
// History Log:
// $Log: SymbolListener.java,v $
// Revision 1.5  1998/02/27 12:48:45  cinard
// Introduced a new flag (localSearch) in getSymbol() and likes methods. A local
// search is restricted to the current (or supplied) scope, that is if the
// searched symbol is not found in current or supplied scope, the research
// does not continue in the parent scopes.
// Updated copyright notice.
//
// Revision 1.4  1998/02/12 16:03:20  mallet
// Fixed copyright notice: TOG RI -> TOG, year extended to 1998 for TOG
// and IPA.
//
// Revision 1.3  1998/01/12 13:19:14  cinard
// Updated and fixed javadoc comments.
//
// Revision 1.2  1997/11/26 17:13:06  cinard
// Changed package name.
//
// Revision 1.1  1997/10/13 15:01:20  cinard
// Generic classes used to manage symbols.
// Should be used by all ADL parsers.
//
// ***********************************************************************
