// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/ORG/opengroup/adl/symboltable/c/CDestructor.java,v $
// $Revision: 1.7 $
// $Date: 1998/03/18 15:50:00 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   symboltable
// NAME:        CDestructor.java
//
// HISTORY:
//      Cyril Inard d'Argence, TOG - Oct 09,  1997: Created
//      See Log at end of file
//
// ***********************************************************************

package ORG.opengroup.adl.symboltable.c;

import com.objectspace.jgl.UnaryPredicate;
import com.objectspace.jgl.predicates.UnaryAnd;
import ORG.opengroup.adl.symboltable.*;


/**
 * target language constructor symbol.
 */

public class CDestructor extends LCallable
{
  // -- Protected constructor --

  /**
   * Constructs me to be a target language destructor.
   * @param name Name of the destructor.
   */

  public CDestructor(String name,LModifier modifier)
  {
     super(name,modifier,SymbolId.DESTRUCTOR);
  }

  // -- Symbol interface implementation --

  // -- Protected methods --

  /**
   * Get the name of the callable symbol.
   * @param name Always "destructor".
   */

  protected String header()
  {
     return "Destructor ~";
  }
}

// ***********************************************************************
// History Log:
// $Log: CDestructor.java,v $
// Revision 1.7  1998/03/18 15:50:00  cinard
// New strategy for symbol selection (a single SymbolSelector class
// is now used). Symbol classes updated acordingly.
//
// Revision 1.6  1998/02/27 12:42:10  cinard
// Updated copyright notice.
//
// Revision 1.5  1998/02/23 14:49:47  cinard
// Added support for typedefs.
//
// Revision 1.4  1998/02/12 16:03:25  mallet
// Fixed copyright notice: TOG RI -> TOG, year extended to 1998 for TOG
// and IPA.
//
// Revision 1.3  1998/01/19 14:37:07  cinard
// Changed COM.objectspace.jgl to com.objectspace.jgl (update from JGL 3.0.0
// to 3.1.0).
//
// Revision 1.2  1998/01/12 13:19:17  cinard
// Updated and fixed javadoc comments.
//
// Revision 1.1  1998/01/06 13:32:05  wassel
// Added CDestructor symbol
//
// Revision 1.6  1997/12/08 12:58:42  cinard
// Added a new type check mechanism.
// Fixed some bugs.
//
// Revision 1.5  1997/11/26 17:12:58  cinard
// Changed package name.
//
// Revision 1.4  1997/11/12 13:43:15  cinard
// Corrected some bugs.
// Replaced LCallableSearcher class with LCallableAssignComparator and
// LCallableEqualsComparator classes.
// Added LModuleComparator and LTypeComparator classes (useful for
// Java names classification).
//
// Revision 1.3  1997/11/04 16:04:22  cinard
// Made some modification for C and C++ parsers.
//
// Revision 1.2  1997/11/03 12:59:58  cinard
// Improved scope management : duplicates in LClass scope allowed.
// Added PoinerToFunction class.
//
// Revision 1.1  1997/10/27 11:18:04  cinard
// Added language independant symbols to the symboltable package.
//
//
// ***********************************************************************
