// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/ORG/opengroup/adl/symboltable/c/CEnumImpl.java,v $
// $Revision: 1.3 $
// $Date: 1998/03/18 15:50:01 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   symboltable.c
// NAME:        CEnumImpl.java
//
// HISTORY:
//      Wassel Berrayana, TOG - Jananuary,  1998: Created
//      See Log at end of file
//
// ***********************************************************************

package ORG.opengroup.adl.symboltable.c;

import ORG.opengroup.adl.symboltable.*;
import java.util.Hashtable;
import com.objectspace.jgl.UnaryPredicate;


/**
 * Implementation for Enum symbol.
 */

public class CEnumImpl extends    LConstructedTypeImpl
                       implements CEnum
{
  /**
   * Constructs a target language structure.
   * @param name name of the structure.
   */

  public CEnumImpl(String name)
  {
     super(name,new LModifier(0x0000),SymbolId.ENUM);
  }

  /**
   * Can a value of type t be assigned to a variable of this type.
   * @param  t The type for which the assignability is checked.
   * @return True if it can, false otherwise.
   */
  
  public boolean assignable(Symbol t) 
  {
     return this.equals(t);
  }

  // -- Protected features --

  /** Returns a header for the description of the expression. */

  protected String header()
  {
     return   "Enum " + getName(); 
  }
  
  // -- Symbol interface implementation --

  /** Creates a new typedef. */

  public LType newTypedef(String name)
  {
     return new CEnumTypedef(name,this);
  }
	  
}

// ***********************************************************************
// History Log:
// $Log: CEnumImpl.java,v $
// Revision 1.3  1998/03/18 15:50:01  cinard
// New strategy for symbol selection (a single SymbolSelector class
// is now used). Symbol classes updated acordingly.
//
// Revision 1.2  1998/02/27 12:42:11  cinard
// Updated copyright notice.
//
// Revision 1.1  1998/02/23 14:49:48  cinard
// Added support for typedefs.
//
// ***********************************************************************

