// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/ORG/opengroup/adl/symboltable/c/CFunctionTypedef.java,v $
// $Revision: 1.3 $
// $Date: 1998/04/28 12:24:54 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   symboltable.c
// NAME:        CFunctionTypedef.java
//
// HISTORY:
//      Wassel BERRAYANA, TOG - January,  1998: Created
//
// ***********************************************************************

package ORG.opengroup.adl.symboltable.c;

import ORG.opengroup.adl.symboltable.*;

/**
 *  Typedef for function type.
 */

public class CFunctionTypedef extends    LTypedef
                              implements CFunctionType
{

  /**
   * Constructs a typedef over the supplied type.
   * @param name name of the typedef.
   * @param type type for which the typedef is defined.
   */

  protected CFunctionTypedef(String name,CFunctionType type)
  {
     super(name,type);
  }

  /**
   * Returns the return type of function type.
   */

  public LType getFunctionTypeReturnType()
  {
     return ((CFunctionType)getRealType()).getFunctionTypeReturnType();
  }

  /**
   * Set the return type of the function.
   */

  public void setFunctionTypeReturnType(LType type)
  {
     ((CFunctionType)getRealType()).setFunctionTypeReturnType(type);
  }

  /**
   * Returns function type parent class.
   */
  public LConstructedType getEnclosingClass() 
  {
     return ((CFunctionType)getRealType()).getEnclosingClass();
  }

  /**
   * Returns the function type comparator.
   */
  public LCallableEqualsComparator getFunctionTypeComparator()
  {
     return ((CFunctionType)getRealType()).getFunctionTypeComparator();
  }

}

// ***********************************************************************
// History Log:
// $Log: CFunctionTypedef.java,v $
// Revision 1.3  1998/04/28 12:24:54  cinard
// Added setFunctionTypeReturnType() method.
//
// Revision 1.2  1998/02/27 12:42:12  cinard
// Updated copyright notice.
//
// Revision 1.1  1998/02/23 14:49:49  cinard
// Added support for typedefs.
//
// ***********************************************************************
