// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/ORG/opengroup/adl/symboltable/c/CPointerToFunction.java,v $
// $Revision: 1.6 $
// $Date: 1998/04/28 12:28:49 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   symboltable
// NAME:        CPointerToFunction.java
//
// HISTORY:
//      Wassel BERRAYANA, TOG - Jan 27,  1997: Created
//      See Log at end of file
//
// ***********************************************************************

package ORG.opengroup.adl.symboltable.c;

import ORG.opengroup.adl.symboltable.*;

/**
 *  Pointer to function symbol.
 */

public class CPointerToFunction extends LPointerToFunctionImpl
{

  /**
   * Constructs a pointer to a function.
   * @param pointed pointed function prototype (LCallableEqualsComparator).
   */

  public CPointerToFunction(LCallableEqualsComparator pointed,
                            LModifier modifier)
  {
     super(pointed, modifier);
  }
    
  /**
   * Checks if a callable can be assigned to a variable of this type.
   * @param  t The callable for which the assignability is checked.
   * @return True if it can, false otherwise.
   */

  public boolean assignable(Symbol t) 
  {

    return (  t!= null ) && ( t instanceof LPointerToFunction ) &&
      this.pointed.equals(((LPointerToFunction)t).getPointedComparator()) ; 
  }
  
}
