// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/ORG/opengroup/adl/symboltable/c/CReference.java,v $
// $Revision: 1.7 $
// $Date: 1998/02/27 12:42:14 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   symboltable
// NAME:        LReference.java
//
// HISTORY:
//      Wassel BERRAYANA, TOG - January 27,  1998: Created
//      See Log at end of file
//
// ***********************************************************************

package ORG.opengroup.adl.symboltable.c;

import ORG.opengroup.adl.symboltable.*;


/**
 *  CReference symbol.
 */

public class CReference extends LReferenceImpl
{

  /**
   * Constructs a reference type.
   * @param referenced referenced type.
   */

   public CReference(LType referenced)
   {
      super( referenced  );

   }


  /**
   * Can a value of type t be assigned to a variable of this type.
   * Overrides assignable of LReference.
   * @param  t The type for which the assignability is checked.
   * @return True if it can, false otherwise.
   */
   public boolean assignable(Symbol t) 
   {
     if ( t == null ) 
     {
        return false ;
     }
     else if (t instanceof LReference && (this.referenced instanceof LClass)) 
     {
        if (   ((LReference )t).getReferenced() instanceof LClass   
            && ((LClass )((LReference)t).getReferenced()).subclassOf
                                                          (this.referenced))
        {
           return true ;
        }
        else
        {
           return false ;
        }
     }
     else if ( t instanceof LReference) 
     {
        return this.getReferenced().assignable
                                    (((LReference)t).getReferenced());
     }
     else 
     {
       return this.getReferenced().assignable( t) ;
     }
   }
}

