// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/ORG/opengroup/adl/symboltable/c/CSymbolFactory.java,v $
// $Revision: 1.5 $
// $Date: 1998/06/23 13:22:45 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   symboltable.c
// NAME:        CSymbolFactory.java
//
// HISTORY:
//      Cyril Inard d'Argence, TOG - Oct 09,  1997: Created
//      See Log at end of file
//
// ***********************************************************************

package ORG.opengroup.adl.symboltable.c;

import ORG.opengroup.adl.symboltable.*;

import java.util.Vector;

/**
 * Concrete symbol factory for C symbols.
 */

public class CSymbolFactory extends CStarSymbolFactory 
{

  /** Creates pre-defined runtime symbols. */
  public Symbol[] newRuntime()
  {
     Vector runtimeSymbols = new Vector();

     // declare char * to simplify further definitions
     LType pointerToChar = newPointer(CBuiltinType.charT,0x00);

     // int ADL_getNumInstances();
     LFunction  _ADL_getNumInstances = newRuntimeFunction
                                       ("ADL_getNumInstances",0x00);
     _ADL_getNumInstances.setReturnType(CBuiltinType.intT);

     runtimeSymbols.addElement(_ADL_getNumInstances);

     // void ADL_infoline(char* line);
     LFunction _ADL_infoline = newRuntimeFunction("ADL_infoline",0x00);
     _ADL_infoline.setReturnType(CBuiltinType.voidT);
     _ADL_infoline.addParameter(newParameter("line",0x00, pointerToChar));

     runtimeSymbols.addElement(_ADL_infoline);

     // void ADL_printf(char *format, ...);
     // TBD - var args
     LFunction _ADL_printf = newRuntimeFunction("ADL_printf",0x00);
     _ADL_printf.setReturnType(CBuiltinType.voidT);
     _ADL_printf.addParameter(newParameter("format",0x00,pointerToChar));

     runtimeSymbols.addElement(_ADL_printf);

     // char* ADL_getvar(char* name);
     LFunction _ADL_getvar = newRuntimeFunction("ADL_getvar",0x00);
     _ADL_getvar.setReturnType(pointerToChar);
     _ADL_getvar.addParameter(newParameter("name",0x00,pointerToChar));

     runtimeSymbols.addElement(_ADL_getvar);

     // void ADL_setblock();
     LFunction _ADL_setblock = newRuntimeFunction("ADL_setblock",0x00);
     _ADL_setblock.setReturnType(CBuiltinType.voidT);

     runtimeSymbols.addElement(_ADL_setblock);
  
     // void ADL_result(int res);
     LFunction _ADL_result = newRuntimeFunction("ADL_result",0x00);
     _ADL_result.setReturnType(CBuiltinType.voidT);
     _ADL_result.addParameter(newParameter("res",0x00,CBuiltinType.intT));

     runtimeSymbols.addElement(_ADL_result);

     // void ADL_assertionStart(char *assertion);
     LFunction _ADL_assertionStart = newRuntimeFunction("ADL_assertionStart",0x00);
     _ADL_assertionStart.setReturnType(CBuiltinType.voidT);
     _ADL_assertionStart.addParameter
                         (newParameter("assertion",0x00,pointerToChar));

     runtimeSymbols.addElement(_ADL_assertionStart);

     // void ADL_assertionResult(int res);
     LFunction _ADL_assertionResult = newRuntimeFunction("ADL_assertionResult",0x00);
     _ADL_assertionResult.setReturnType(CBuiltinType.voidT);
     _ADL_assertionResult.addParameter
                          (newParameter("res",0x00,CBuiltinType.intT));

     runtimeSymbols.addElement(_ADL_assertionResult);

     // void ADL_factoryResult(int res, char* msg);
     LFunction _ADL_factoryResult = newRuntimeFunction("ADL_factoryResult",0x00);
     _ADL_factoryResult.setReturnType(CBuiltinType.voidT);
     _ADL_factoryResult.addParameter
                        (newParameter("res",0x00,CBuiltinType.intT));
     _ADL_factoryResult.addParameter
                        (newParameter("msg",0x00,pointerToChar));

     runtimeSymbols.addElement(_ADL_factoryResult);

     // int tdd_result(int res, char* msg);
     LFunction tdd_result = newRuntimeFunction("tdd_result",0x00);
     tdd_result.setReturnType(CBuiltinType.intT);
     tdd_result.addParameter
                (newParameter("res",0x00,CBuiltinType.intT));
     tdd_result.addParameter
                (newParameter("msg",0x00,pointerToChar));

     runtimeSymbols.addElement(tdd_result);

     // int tdd_assert(char * assertText, int assertRes);
     LFunction tdd_assert = newRuntimeFunction("tdd_assert",0x00);
     tdd_assert.setReturnType(CBuiltinType.intT);
     tdd_assert.addParameter
                (newParameter("assertText",0x00,pointerToChar));
     tdd_assert.addParameter
                (newParameter("assertRes",0x00,CBuiltinType.intT));

     runtimeSymbols.addElement(tdd_assert);

     // int tdd_skip();
     LFunction tdd_skip = newRuntimeFunction("tdd_skip",0x00);
     tdd_skip.setReturnType(CBuiltinType.intT);

     runtimeSymbols.addElement(tdd_skip);

     // int tdd_end_case(char *msg);
     LFunction tdd_end_case = newRuntimeFunction("tdd_end_case",0x00);
     tdd_end_case.setReturnType(CBuiltinType.intT);
     tdd_end_case.addParameter
                  (newParameter("assertText",0x00,pointerToChar));

     runtimeSymbols.addElement(tdd_end_case);

     // int tdd_end_test();
     LFunction tdd_end_test = newRuntimeFunction("tdd_end_test",0x00);
     tdd_end_test.setReturnType(CBuiltinType.intT);

     runtimeSymbols.addElement(tdd_end_test);

     // short ADL_short_range(short,short)
     _ADL_short_range     = newRuntimeFunction("ADL_short_range",0x00);
     _ADL_short_range.setReturnType(CBuiltinType.shortT);
     _ADL_short_range.addParameter
                      (newParameter("_",0x00,CBuiltinType.shortT));
     _ADL_short_range.addParameter
                      (newParameter("_",0x00,CBuiltinType.shortT));

     runtimeSymbols.addElement(_ADL_short_range);

     // int ADL_int_range(int, int)
     _ADL_int_range     = newRuntimeFunction("ADL_int_range",0x00);
     _ADL_int_range.setReturnType(CBuiltinType.intT);
     _ADL_int_range.addParameter
                    (newParameter("_",0x00,CBuiltinType.intT));
     _ADL_int_range.addParameter
                    (newParameter("_",0x00,CBuiltinType.intT));

     runtimeSymbols.addElement(_ADL_int_range);

     // long ADL_long_range(long, long)
     _ADL_long_range = newRuntimeFunction("ADL_long_range",0x00);
     _ADL_long_range.setReturnType(CBuiltinType.longT);
     _ADL_long_range.addParameter
                     (newParameter("_",0x00,CBuiltinType.longT));
     _ADL_long_range.addParameter
                     (newParameter("_",0x00,CBuiltinType.longT));

     runtimeSymbols.addElement(_ADL_long_range);

     // TDD constants

     runtimeSymbols.addElement
                    (newAttribute("ADL_PASS",0x00,CBuiltinType.intT));
     runtimeSymbols.addElement
                    (newAttribute("ADL_FAIL",0x00,CBuiltinType.intT));
     runtimeSymbols.addElement
                    (newAttribute("ADL_UNRESOLVED",0x00,CBuiltinType.intT));
     runtimeSymbols.addElement
                    (newAttribute("ADL_NOTINUSE",0x00,CBuiltinType.intT));
     runtimeSymbols.addElement
                    (newAttribute("ADL_UNSUPPORTED",0x00,CBuiltinType.intT));
     runtimeSymbols.addElement
                    (newAttribute("ADL_UNTESTED",0x00,CBuiltinType.intT));
     runtimeSymbols.addElement
                    (newAttribute("ADL_UNINITIATED",0x00,CBuiltinType.intT));
     runtimeSymbols.addElement
                    (newAttribute("ADL_NORESULT",0x00,CBuiltinType.intT));
     runtimeSymbols.addElement
                    (newAttribute("ADL_UNEVALUATED",0x00,CBuiltinType.intT));
     runtimeSymbols.addElement
                    (newAttribute("ADL_ERROR",0x00,CBuiltinType.intT));
     runtimeSymbols.addElement
                    (newAttribute("ADL_SKIPPED",0x00,CBuiltinType.intT));
     runtimeSymbols.addElement
                    (newAttribute("ADL_AMBIGUOUS",0x00,CBuiltinType.intT));
     runtimeSymbols.addElement
                    (newAttribute("ADL_UNDEFINED",0x00,CBuiltinType.intT));

     Symbol[] tmp = new Symbol[runtimeSymbols.size()];
     runtimeSymbols.copyInto(tmp);
     return tmp;
  }

  /** Get symbol for ADL_short_range function. */
  public LFunction getADLShortRange() 
  { 
    return _ADL_short_range;
  }

  /** Get symbol for ADL_int_range function. */
  public LFunction getADLIntRange() 
  { 
    return _ADL_int_range;
  }
  
  /** Get symbol for ADL_long_range function. */
  public LFunction getADLLongRange() 
  { 
    return _ADL_long_range;
  }

  /** Short range function. */
  LFunction _ADL_short_range = null;

  /** Integer range function. */
  LFunction _ADL_int_range = null;

  /** Long range function. */
  LFunction _ADL_long_range = null;
}

// ***********************************************************************
// History Log:
// $Log: CSymbolFactory.java,v $
// Revision 1.5  1998/06/23 13:22:45  cinard
// Added getter for runtime functions ADL_short_range(), ADL_int_range() and
// ADL_long_range().
//
// Revision 1.4  1998/06/16 12:25:12  cinard
// Added newRuntimeFunction() method in factory.
// Updated newRuntime() so that former methpod is used.
//
// Revision 1.3  1998/04/28 12:26:42  cinard
// C++ symbols are now obtained using the CPPSymbolFactory.
// CSymbolFactory is dedicated to C symbols.
//
// Revision 1.2  1998/03/25 14:48:35  cinard
// Updated newADLClass() method (now super class name is required).
//
// Revision 1.1  1998/03/18 15:51:28  cinard
// Symbol factory in now separated from symbol table.
//
// ***********************************************************************
