// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/ORG/opengroup/adl/symboltable/c/CTranslationUnitInfo.java,v $ 
// $Revision: 1.2 $
// $Date: 1998/07/28 12:27:52 $ 
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   symboltable
// NAME:        ADLTranslationUnitInfo.java
//
// HISTORY:
//      Cyril Inard d'Argence, TOG - Mar 16,  1998: Created
//      See Log at end of file
//
// ***********************************************************************

package ORG.opengroup.adl.symboltable.c;

import  ORG.opengroup.adl.symboltable.*;
import  java.util.Vector;

/**
 * Information used when compiling an ADL Translation Unit.
 */

public class  CTranslationUnitInfo extends ADLCompilationUnitInfo
{

  /**
   * Constructs ADL Translation unit context information.
   * This information shall be used to manipulate symbols
   * of a given translation unit.
   * @param adlTranslationUnit current adl translation unit.
   * @param usedADLClasses  list of used ADL classes.
   * @param usedTDDClasses  list of used TDD classes.
   */

  public CTranslationUnitInfo(FileScope adlTranslationUnit, 
			      Vector usedADLClasses,
			      Vector usedTDDClasses)
  {
     super(usedADLClasses, usedTDDClasses);
     _adlTranslationUnit = adlTranslationUnit;
  }
  
  /**
   * Get current adl translation unit.
   */
  
  public FileScope getAdlTranslationUnit()
  {
     return _adlTranslationUnit;
  }

  /**
   * Get a description.
   */

  public String toString()
  {
     return "[" + _adlTranslationUnit.getFileName() + "]" + super.toString();
  }

  // -- Private --

  /** Current adl translation. */
  private final FileScope _adlTranslationUnit;

}

// ***********************************************************************
// History Log:
// $Log: CTranslationUnitInfo.java,v $
// Revision 1.2  1998/07/28 12:27:52  mallet
// Added list of used ADL classes in constructor parameters.
//
// Revision 1.1  1998/05/27 13:01:45  cinard
// Context information for C and C++ symbol table manager.
//
// ***********************************************************************
