// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// $Source
// $Revision: 1.5 $
// $Date: 1998/02/27 12:38:42 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   symboltable.j
// NAME:        ClassNotAccessibleException.java
//
// HISTORY:
//      Cyril Inard d'Argence, TOG - Oct 17,  1997: Created
//      See Log at end of file
//
// ***********************************************************************

package ORG.opengroup.adl.symboltable.j;

/**
 * Exception thrown when a class not accessible from classpath.
 */

public class  ClassNotAccessibleException extends Exception
{
    /** 
     * Construct the exception.
     * @param s additional description of the problem.
     */
    public ClassNotAccessibleException(String s)
    {
       super(s);
    }
}

// ***********************************************************************
// History Log:
// $Log: ClassNotAccessibleException.java,v $
// Revision 1.5  1998/02/27 12:38:42  cinard
// Updated copyright notice.
//
// Revision 1.4  1998/02/12 16:03:30  mallet
// Fixed copyright notice: TOG RI -> TOG, year extended to 1998 for TOG
// and IPA.
//
// Revision 1.3  1998/01/12 13:19:19  cinard
// Updated and fixed javadoc comments.
//
// Revision 1.2  1997/11/26 17:13:11  cinard
// Changed package name.
//
// Revision 1.1  1997/11/19 15:41:10  cinard
// Exception used by the JSymbolLoader class.
//
// ***********************************************************************
