// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/ORG/opengroup/adl/symboltable/j/JTypes.java,v $
// $Revision: 1.8 $
// $Date: 1998/03/18 16:12:34 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   symboltable.j
// NAME:        JTypes.java
//
// HISTORY:
//      Cyril Inard d'Argence, TOG - Oct 29,  1997: Created
//      See Log at end of file
//
// ***********************************************************************


package ORG.opengroup.adl.symboltable.j;

import  ORG.opengroup.adl.symboltable.*;

/**
 * Java useful types.
 */

public class JTypes
{
  // -- Public fields --

  public static final JBuiltinType voidT    = JBuiltinType.voidT;
  public static final JBuiltinType booleanT = JBuiltinType.booleanT;
  public static final JBuiltinType byteT    = JBuiltinType.byteT;
  public static final JBuiltinType charT    = JBuiltinType.charT;
  public static final JBuiltinType shortT   = JBuiltinType.shortT;
  public static final JBuiltinType intT     = JBuiltinType.intT;
  public static final JBuiltinType longT    = JBuiltinType.longT;
  public static final JBuiltinType floatT   = JBuiltinType.floatT;
  public static final JBuiltinType doubleT  = JBuiltinType.doubleT;

  public static       LClass        _Object;
  public static       LClass        _Cloneable;
  public static       LClass        _Throwable; 
  public static       LClass        _RuntimeException; 
  public static       LClass        _String; 
  public static       LClass        _Enumeration; 
  public static       LClass        _null; 
}

// ***********************************************************************
// History Log:
// $Log: JTypes.java,v $
// Revision 1.8  1998/03/18 16:12:34  cinard
// Added _Enumeration field.
//
// Revision 1.7  1998/02/27 12:38:45  cinard
// Updated copyright notice.
//
// Revision 1.6  1998/02/12 16:03:35  mallet
// Fixed copyright notice: TOG RI -> TOG, year extended to 1998 for TOG
// and IPA.
//
// Revision 1.5  1998/01/12 13:19:23  cinard
// Updated and fixed javadoc comments.
//
// Revision 1.4  1998/01/07 19:15:44  cinard
// Added _RuntimeException attribute to JTypes.
//
// Revision 1.3  1997/12/22 16:14:32  cinard
// Added support for ADL/TDD predefined runtime methods and constants.
//
// Revision 1.2  1997/12/19 21:15:20  cinard
// Added support for exctracting exception (methods throw clauses) from
// the bytecode.
//
// Revision 1.1  1997/12/08 12:54:00  cinard
// Added type check mechanism.
// Fixed some byte code import bugs.
//
// ***********************************************************************
