// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
// 
// ***********************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/ORG/opengroup/adl/translators/c/CGeneric.java,v $
// $Revision: 1.3 $
// $Date: 1998/07/28 16:06:56 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   translators.c
// NAME:        CGeneric
//
// HISTORY:
//      Cyrille Bareau, TOG-RI - Feb 19, 1998: Created
//      See Log at end of file
//
// ***********************************************************************

package ORG.opengroup.adl.translators.c;

import ORG.opengroup.adl.parsers.adlc.*;
import java.util.Stack;
import java.util.EmptyStackException;


public class CGeneric extends ADLCGenericVisitor {

  public Object visit(SimpleNode node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTTranslationUnit node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTADL_TranslationUnit node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTIncludeFileList node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTIncludeFileDeclaration node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTADL_AnnotatedDeclaration node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTADL_InlineDeclaration node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTADL_BehaviorDeclaration node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTADL_Prolog node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTADL_Epilog node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTADL_BehaviorSpecification node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTADL_BehaviorClassification node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTADL_NormalBehavior node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTADL_AbnormalBehavior node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTADL_AssertionGroup node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTADL_Binding node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTADL_NamedParamList node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTADL_NamedParam node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTADL_Statement node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTADL_IfStatement node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTADL_Assertion node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTADL_Labels node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTADL_Tags node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTADL_QuantifiedAssertion node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTADL_Quantifier node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTADL_DomainList node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTADL_Domain node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTADL_DomainExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTADL_ImplExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTADL_ImplOp node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTADL_CallStateExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTADL_Normal node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTADL_Abnormal node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTADL_Unchanged node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTADL_ArgumentList node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTName node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTExternalDeclaration node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTFunctionDefinition node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTDeclaration node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTDeclarationSpecifiers node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTTypeQualifier node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTStorageStructSpecifier node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTBuiltinTypeSpecifier node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTInitDeclaratorList node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTInitDeclarator node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTStructSpecifier node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTMemberDeclaration node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTMemberDeclaratorList node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTEnumSpecifier node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTEnumeratorList node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTEnumerator node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTPtrOperator node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTCvQualifierSeq node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTDeclarator node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTDirectDeclarator node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTDeclaratorSuffixes node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTFunctionDeclarator node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTFunctionDirectDeclarator node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTParameterList node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTParameterDeclarationList node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTParameterDeclaration node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTInitializer node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTTypeName node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTAbstractDeclarator node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTAbstractDeclaratorSuffix node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTStatement node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTLabeledStatement node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTCaseLabelStatement node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTDefaultLabelStatement node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTCompoundStatement node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTIfStatement node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTSwitchStatement node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTWhileStatement node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTDoWhileStatement node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTForStatement node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTGotoStatement node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTContinueStatement node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTBreakStatement node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTReturnStatement node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTAssignmentExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTConditionalExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTConstantExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTLogicalOrExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTLogicalAndExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTInclusiveOrExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTExclusiveOrExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTAndExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTEqualityExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTRelationalExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTShiftExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTAdditiveExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTMultiplicativeExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTCastExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTPreIncrementExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTPreDecrementExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTUnaryOperatorExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTSizeOfExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTPostfixExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTArraySuffix node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTArgumentList node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTDotAccessSuffix node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTRefAccessSuffix node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTPostDeIncrement node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTString node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTADL_Return node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTParentheizedExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTUnaryPlusMinusConstant node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTConstant node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTTDD_AnnotatedDeclaration node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTTDD_ImportDeclaration node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTTDD_UseDeclaration node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTTDD_Declaration node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTTDD_FieldDeclaration node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTTDD_DatasetDeclaration node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTTDD_FactoryDefinition node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTTDD_TestDirective node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTTDD_DatasetDomain node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTTDD_DatasetLiteral node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTTDD_DatasetMember node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTTDD_DatasetExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTTDD_DatasetConcatenationExpr node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTTDD_DatasetSingleton node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTTDD_FactoryCall node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

  public Object visit(ASTTDD_ADLExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }

}
