// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
// 
// ***********************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/ORG/opengroup/adl/translators/c/NamedParamBuilder.java,v $
// $Revision: 1.1 $
// $Date: 1998/06/23 13:39:47 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   translators.c
// NAME:        NamedParamBuilder
//
// HISTORY:
//      Cyrille Bareau, The Open Group RI - Jun 15, 1998: Created
//      See Log at end of file
//
// ***********************************************************************

package ORG.opengroup.adl.translators.c;

import ORG.opengroup.adl.parsers.adlc.*;

/**
  * Creates a C declaration tree for an ADL Named Parameter
  * @author Cyrille Bareau
  */

public class NamedParamBuilder {

  /** Root of the generated tree */
  private ASTDeclaration root;


  /**
    * Creates a declaration
    * @param type The type of the parameter (ASTDeclarationSpecifiers)
    * @param param The name of the parameter (ASTDeclarator)
    */
  public NamedParamBuilder (ASTDeclarationSpecifiers type, ASTDeclarator param) {

    root = new
      ASTDeclaration(ADLCParserTreeConstants.JJTDECLARATION);

    ADLCGenericVisitor.parentChild(root, type, 0);
    ADLCGenericVisitor.parentChild(root, param, 1);
  }


  /**
    * Creates a declaration
    * @param type The type of the parameter (ASTDeclarationSpecifiers)
    * @param param The name of the parameter (ASTDirectDeclarator)
    */
  public NamedParamBuilder (ASTDeclarationSpecifiers type, ASTDirectDeclarator param) {

    root = new
      ASTDeclaration(ADLCParserTreeConstants.JJTDECLARATION);

    ADLCGenericVisitor.parentChild(root, type, 0);
    ADLCGenericVisitor.parentChild(root, param, 1);
  }


  /**
    * @return the root of the generated tree
    */
  public ASTDeclaration generatedAST() {
    return root;
  }
}

// ***********************************************************************
// History Log:
// $Log: NamedParamBuilder.java,v $
// Revision 1.1  1998/06/23 13:39:47  bareau
// First version of the ADL/C translator (ADL part only).
//
// Revision 1.1  1998/06/23 13:27:13  bareau
// First version of the ADL/C translator (ADL part only).
//
//
// ***********************************************************************
