// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
// 
// ***********************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/ORG/opengroup/adl/translators/cpp/ArgumentListBuilder.java,v $
// $Revision: 1.4 $
// $Date: 1998/02/27 13:07:28 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   translators.cpp
// NAME:        ArgumentListBuilder
//
// HISTORY:
//      Rami KHEMAKHEM, The Open Group RI - Dec 12, 1997: Created
//      See Log at end of file
//
// ***********************************************************************

package ORG.opengroup.adl.translators.cpp;

import ORG.opengroup.adl.parsers.adlcpp.*;

/**
  * Creates a tree for a C++ list of arguments
  * @author Rami KHEMAKHEM
  */

public class ArgumentListBuilder {

  /** Root of the generated tree */
  private ASTArgumentList root;

  /** number of childrens */
  private int index;


  /**
    * Creates an empty list of arguments
    */
  public ArgumentListBuilder () {

    root = new
      ASTArgumentList(ADLCPPParserTreeConstants.JJTARGUMENTLIST);
  }


  /**
    * Creates a list of 1 argument
    * @param arg The initial argument
    */
  public ArgumentListBuilder (Node arg) {

    this();
    ADLCPPGenericVisitor.parentChild(root, arg, 0);
    index = 1;
  }


  /**
    * Adds an argument to the argument list
    * @param arg The new argument
    * @return this (so that it is possible to chain-adding
    * new arguments)
    */
  public ArgumentListBuilder addArgument (Node arg) {

    ADLCPPGenericVisitor.parentChild(root, arg, index);
    index += 1;
    return this;
  }


  /**
    * @return the root of the generated tree
    */
  public ASTArgumentList generatedAST() {
    return root;
  }
}

// ***********************************************************************
// History Log:
// $Log: ArgumentListBuilder.java,v $
// Revision 1.4  1998/02/27 13:07:28  bareau
// Updated copyright notice.
//
// Revision 1.3  1998/02/12 16:03:40  mallet
// Fixed copyright notice: TOG RI -> TOG, year extended to 1998 for TOG
// and IPA.
//
// Revision 1.2  1998/02/04 14:02:01  rami
// Update the use of parentChild moved to the generic visitor.
//
// Revision 1.1  1998/01/21 15:30:13  rami
// <node>Builder.java generates an AST<node> node for transformation.
// First release for tests.
//
// ***********************************************************************
