// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
// 
// ***********************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/ORG/opengroup/adl/translators/cpp/CPPGeneric.java,v $
// $Revision: 1.5 $
// $Date: 1998/06/30 13:12:48 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   translators.cpp
// NAME:        CPPGeneric
//
// HISTORY:
//      Cyrille Bareau, TOG-RI - Feb 19, 1998: Created
//      See Log at end of file
//
// ***********************************************************************

package ORG.opengroup.adl.translators.cpp;

import ORG.opengroup.adl.parsers.ParseException;
import ORG.opengroup.adl.parsers.adlcpp.*;
import java.util.Stack;
import java.util.EmptyStackException;


public class CPPGeneric extends ADLCPPGenericVisitor {

  public Object visit(SimpleNode node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTTranslationUnit node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTIncludeFileList node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTIncludeFileDeclaration node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTFunctionDefinition node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTLinkageSpecification node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTDeclaration node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTDeclarationSpecifiers node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTQualifiedId node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTQualifiedType node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTFullyScopedType node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTBuiltinTypeSpec node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTInitDeclaratorList node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTInitDeclarator node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTClassSpecifier node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTClassMemberList node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTBaseClause node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTBaseSpecifier node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTAccessSpecifier node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTMemberDeclaration node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTMemberDeclaratorList node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTEnumSpecifier node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTEnumeratorList node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTEnumerator node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTPtrOperator node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTDeclarator node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTDirectDeclarator node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTDeclaratorSuffixes node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTFunctionDeclarator node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTFunctionDirectDeclarator node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTDtorDefinition node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTCtorDefinition node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTCtorDeclarator node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTCtorInitializer node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTSuperclassInit node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTDtorDeclarator node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTParameterDeclarationList node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTParameterDeclaration node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTInitializer node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTTypeNameList node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTTypeName node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTAbstractDeclarator node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTAbstractDeclaratorSuffix node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTStatement node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTLabelNode node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTCaseExpr node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTCompoundStatement node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTElseNode node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTIfNode node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTSwitchNode node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTWhileNode node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTDoWhileNode node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTForNode node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTGotoNode node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTContinueNode node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTBreakNode node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTReturnStmt node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTTryNode node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTCatchNode node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTExceptionDeclaration node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTThrowStmt node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTAssignmentExpr node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTCondExpr node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTConstantExpr node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTBinaryLogicalExpr node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTBinaryArithExpr node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTPmExpr node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTCastExpr node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTUnaryExpr node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTADLCallStateExpr node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTNewExpr node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTNewTypeId node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTNewDeclarator node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTDirectNewDeclarator node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTDeleteExpr node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTPostfixExpr node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTPostDeIncrement node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTArraySuffix node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTArgumentList node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTDotAccessSuffix node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTRefAccessSuffix node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTIdExpr node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTPrimaryExpr node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTThis node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTReturn node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTString node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTParenthExpr node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTExpr node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTConstant node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTExceptionSpec node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTADLNamedParamList node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTADLClass node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTADLBhvDecl node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTADLBhvSpec node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTADLBhvClassification node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTADLAssGrp node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTADLInhSemantics node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTADLBinding node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTADLInlineDecl node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTADLSuperClass node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTADLIfStmt node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTADLTryStmt node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTADLLabel node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTADLTags node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTADLAssertion node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTADLImplExpr node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTNormalExpr node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTAbnormalExpr node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTUnchangedExpr node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTADLThrownExpr node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTADLQuantifiedAssertion node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTADLDomainList node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTADLDomain node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTADLProlog node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTADLEpilog node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTTDDUseDeclaration node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTTDDClassDecl node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTTDDFieldDeclaration node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTTDDADLnewExpr node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTTDDADLExpr node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTTDDDatasetDecl node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTTDDFactoryDef node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTTDDTestDirective node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTTDDDatasetDomain node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTTDDDatasetLiteral node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTTDDDatasetMember node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTTDDDatasetExpr node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTTDDDatasetSingleton node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


  public Object visit(ASTTDDFactoryCall node, Object data) throws ParseException {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      parentChild(node, (Node)node.jjtGetChild(i).jjtAccept(this, data), i);
    }
    return node;
  }


}
