// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
// 
// ***********************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/ORG/opengroup/adl/translators/cpp/CompoundStatementBuilder.java,v $
// $Revision: 1.5 $
// $Date: 1998/02/27 16:20:19 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:  .translators.cpp
// NAME:        CompoundStatementBuilder
//
// HISTORY:
//      Rami KHEMAKHEM, The Open Group RI - Dec 29, 1997: Created
//      See Log at end of file
//
// ***********************************************************************

package ORG.opengroup.adl.translators.cpp;

import ORG.opengroup.adl.parsers.adlcpp.*;

/**
  * Creates a tree for a C++ Compound statement
  * @author Rami KHEMAKHEM
  */

public class CompoundStatementBuilder {

  /** Root of the generated tree */
  private ASTCompoundStatement root;


  /**
    * Creates a C++ compound statement that is a statement
    * @param expr The expression node (AST)
    */
  public CompoundStatementBuilder (Node expr) {

    root = new
      ASTCompoundStatement(ADLCPPParserTreeConstants.JJTCOMPOUNDSTATEMENT);

    ADLCPPGenericVisitor.parentChild(root, new StatementBuilder(expr).generatedAST(), 0);
  }


  /**
    * Creates a C++ compound statement that is a declaration
    * @param expr The declaration node (AST)
    */
  public CompoundStatementBuilder (ASTDeclaration expr) {

    root = new
      ASTCompoundStatement(ADLCPPParserTreeConstants.JJTCOMPOUNDSTATEMENT);

    ADLCPPGenericVisitor.parentChild(root, expr, 0);

  }


  /**
    * @return the root of the generated tree
    */
  public ASTCompoundStatement generatedAST() {
    return root;
  }
}

// ***********************************************************************
// History Log:
// $Log: CompoundStatementBuilder.java,v $
// Revision 1.5  1998/02/27 16:20:19  rami
// Removed unused code.
//
// Revision 1.4  1998/02/27 13:07:31  bareau
// Updated copyright notice.
//
// Revision 1.3  1998/02/12 16:03:43  mallet
// Fixed copyright notice: TOG RI -> TOG, year extended to 1998 for TOG
// and IPA.
//
// Revision 1.2  1998/02/04 14:02:02  rami
// Update the use of parentChild moved to the generic visitor.
//
// Revision 1.1  1998/01/21 15:30:14  rami
// <node>Builder.java generates an AST<node> node for transformation.
// First release for tests.
//
// ***********************************************************************
