// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
// 
// ***********************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/ORG/opengroup/adl/translators/cpp/NamedParamBuilder.java,v $
// $Revision: 1.5 $
// $Date: 1998/02/27 13:07:34 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   translators.cpp
// NAME:        NamedParamBuilder
//
// HISTORY:
//      Rami KHEMAKHEM, The Open Group RI - Dec 10, 1997: Created
//      See Log at end of file
//
// ***********************************************************************

package ORG.opengroup.adl.translators.cpp;

import ORG.opengroup.adl.parsers.adlcpp.*;

/**
  * Creates a C++ declaration tree for an ADL Named Parameter
  * @author Rami KHEMAKHEM
  */

public class NamedParamBuilder {

  /** Root of the generated tree */
  private ASTDeclaration root;


  /**
    * Creates a declaration
    * @param type The type of the parameter (ASTDeclarationSpecifiers)
    * @param param The name of the parameter (ASTDeclarator)
    */
  public NamedParamBuilder (ASTDeclarationSpecifiers type, ASTDeclarator param) {

    root = new
      ASTDeclaration(ADLCPPParserTreeConstants.JJTDECLARATION);

    ADLCPPGenericVisitor.parentChild(root, type, 0);
    ADLCPPGenericVisitor.parentChild(root, param, 1);
  }


  /**
    * Creates a declaration
    * @param type The type of the parameter (ASTDeclarationSpecifiers)
    * @param param The name of the parameter (ASTDirectDeclarator)
    */
  public NamedParamBuilder (ASTDeclarationSpecifiers type, ASTDirectDeclarator param) {

    root = new
      ASTDeclaration(ADLCPPParserTreeConstants.JJTDECLARATION);

    ADLCPPGenericVisitor.parentChild(root, type, 0);
    ADLCPPGenericVisitor.parentChild(root, param, 1);
  }


  /**
    * @return the root of the generated tree
    */
  public ASTDeclaration generatedAST() {
    return root;
  }
}

// ***********************************************************************
// History Log:
// $Log: NamedParamBuilder.java,v $
// Revision 1.5  1998/02/27 13:07:34  bareau
// Updated copyright notice.
//
// Revision 1.4  1998/02/12 16:03:47  mallet
// Fixed copyright notice: TOG RI -> TOG, year extended to 1998 for TOG
// and IPA.
//
// Revision 1.3  1998/02/04 14:02:04  rami
// Update the use of parentChild moved to the generic visitor.
//
// Revision 1.2  1998/01/28 14:51:52  rami
// Fixed package name parsers.adlcpp in import declaration.
//
// Revision 1.1  1998/01/21 15:30:16  rami
// <node>Builder.java generates an AST<node> node for transformation.
// First release for tests.
//
// ***********************************************************************
