// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
// 
// ***********************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/ORG/opengroup/adl/translators/j/ForStatementBuilder.java,v $
// $Revision: 1.4 $
// $Date: 1998/02/27 13:07:56 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:  .translators.j
// NAME:        ForStatementBuilder
//
// HISTORY:
//      Cyrille Bareau, The Open Group RI - Dec 16, 1997: Created
//      See Log at end of file
//
// ***********************************************************************

package ORG.opengroup.adl.translators.j;

import ORG.opengroup.adl.parsers.adljava.*;

/**
  * Creates a tree for a Java "for" statement
  * @author Cyrille Bareau
  */

public class ForStatementBuilder {

  /** Root of the generated tree */
  private ASTForStatement root;


  /**
    * Creates a Java assignment statement
    * @param lhs The name of the variable to assign
    * @param op The assignment operator
    * @param rhs The right-hand side expression
    */
  public ForStatementBuilder (ASTLocalVariableDeclaration forInit,
                            Node expr,
                            ASTPostfixExpression forUpdate,
                            Node forStmt) {

    root = new
      ASTForStatement(ADLJavaParserTreeConstants.JJTFORSTATEMENT);
    ASTForInit child1 = new
      ASTForInit(ADLJavaParserTreeConstants.JJTFORINIT);
    ASTExpression child2 = new
      ASTExpression(ADLJavaParserTreeConstants.JJTEXPRESSION);
    ASTForUpdate child3 = new
      ASTForUpdate(ADLJavaParserTreeConstants.JJTFORUPDATE);

    JGenericVisitor.parentChild(root, child1, 0);
    JGenericVisitor.parentChild(root, child2, 1);
    JGenericVisitor.parentChild(root, child3, 2);
    JGenericVisitor.parentChild(root, forStmt, 3);
    JGenericVisitor.parentChild(child1, forInit, 0);
    JGenericVisitor.parentChild(child2, expr, 0);
    JGenericVisitor.parentChild(child3, forUpdate, 0);
  }


  /**
    * @return the root of the generated tree
    */
  public ASTForStatement generatedAST() {
    return root;
  }
}

// ***********************************************************************
// History Log:
// $Log: ForStatementBuilder.java,v $
// Revision 1.4  1998/02/27 13:07:56  bareau
// Updated copyright notice.
//
// Revision 1.3  1998/02/12 16:03:54  mallet
// Fixed copyright notice: TOG RI -> TOG, year extended to 1998 for TOG
// and IPA.
//
// Revision 1.2  1998/01/08 16:32:46  bareau
// Version OK for bank/stock examples.
// Need more comments.
//
// Revision 1.1  1997/12/19 15:17:59  bareau
// Reorganisation of the translator package, with subpackages
// (only the "j" subdirectory for now).
// Added Makefiles.
//
// ***********************************************************************
