// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
// 
// ***********************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/ORG/opengroup/adl/translators/j/JGeneric.java,v $
// $Revision: 1.6 $
// $Date: 1998/04/15 13:57:42 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   translators.j
// NAME:        JGenericVisitor
//
// HISTORY:
//      Cyrille Bareau, TOG-RI - Nov 26, 1997: Created
//      See Log at end of file
//
// ***********************************************************************

package ORG.opengroup.adl.translators.j;

import ORG.opengroup.adl.parsers.adljava.*;
import java.util.Stack;
import java.util.EmptyStackException;

/**
  * Generic visitor. All the visit methods simply re-transmit the visitor
  * to their children.
  * @author Cyrille Bareau
  * @see JADLTransformVisitor
  * @see JDatasetExprVisitor
  * @see JTDDTransformVisitor
  */

public class JGeneric extends JGenericVisitor {

  public Object visit(SimpleNode node, Object data) {
    
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }


  public Object visit(ASTADL_CompilationUnit node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTCompilationUnit node,Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTPackageDeclaration node,Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTImportDeclaration node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTTDD_UseDeclaration node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTADL_ClassDeclaration node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTADL_InlineDeclaration node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTADL_BehaviorDeclaration node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTADL_Prologue node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTADL_Epilogue node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTADL_BehaviorSpecification node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTADL_BehaviorClassification node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTADL_NormalBehavior node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTADL_AbNormalBehavior node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTADL_AssertionGroup node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTADL_Binding node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTADL_Statement node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTADL_TryStatement node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTADL_IfStatement node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTADL_Assertion node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTADL_Label node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTADL_Tags node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTADL_QuantifiedAssertion node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTADL_ImplExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTADL_ImplOp node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTConditionalExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTConditionalOrExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTConditionalAndExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTInclusiveOrExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTExclusiveOrExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTAndExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTEqualityExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTInstanceOfExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTShiftExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTAdditiveExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTMultiplicativeExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTUnaryPlusMinus node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTPreIncrementExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTPreDecrementExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTUnaryNotPlusMinus node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTADL_CallStateExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTCastExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTADL_Normal node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTADL_Abnormal node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTADL_Return node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTPrimaryExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTTDD_ADLExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTTDD_ADLnewExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTADL_Quantifier node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTRelationalExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTADL_Unchanged node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTADL_SuperSemantics node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTThisPrefix node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTSuperPrefix node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTBracketSuffix node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTDotSuffix node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTParenthExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTStringLiteral node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTIntegerLiteral node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTFloatLiteral node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTCharacterLiteral node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTBooleanLiteral node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTNullLiteral node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTArguments node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTArgumentList node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTAllocationExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTArrayDimensions node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTADL_ThrownExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTADL_DomainList node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTADL_Domain node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTVariableDeclaratorId node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTMethodDeclarator node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTFormalParameters node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTFormalParameter node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTType node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTResultType node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTName node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTNameList node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTTDD_ClassDeclaration node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTTDD_ClassBodyDeclaration node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTTDD_FieldDeclaration node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTTDD_DatasetDeclaration node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTTDD_FactoryDeclaration node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTTDD_TestDirective node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTTDD_DatasetDomain node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTTDD_DatasetLiteral node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTTDD_SingleDeclarator node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTTDD_DatasetMember node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTTDD_DatasetExpr node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTTDD_DatasetConcatenationExpr node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTTDD_DatasetSingleton node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTTDD_FactoryCall node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTClassDeclaration node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTClassBodyDeclaration node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTInterfaceDeclaration node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTInterfaceMemberDeclaration node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTFieldDeclaration node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTStaticInitializer node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTConstructorDeclaration node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTMethodDeclaration node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTStatement node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTVariableDeclarator node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTBlock node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTExplicitConstructorInvocation node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTBlockStatement node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTLabeledStatement node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTEmptyStatement node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTSwitchStatement node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTSwitchLabel node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTIfStatement node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTWhileStatement node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTDoStatement node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTForStatement node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTForInit node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTBreakStatement node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTContinueStatement node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTReturnStatement node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTThrowStatement node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTSynchronizedStatement node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTTryStatement node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTVariableInitializer node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTLocalVariableDeclaration node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTAssignment node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTPostfixExpression node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTStatementExpressionList node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

  public Object visit(ASTForUpdate node, Object data) {
    for (int i = 0; i < node.jjtGetNumChildren(); i++) {
      node.jjtGetChild(i).jjtAccept(this, null);
    }
    return null;
  }

}

// ***********************************************************************
// History Log:
// $Log: JGeneric.java,v $
// Revision 1.6  1998/04/15 13:57:42  bareau
// Update according to the new NL mechanism: there are no NLD_* nodes.
//
// Revision 1.5  1998/02/27 13:07:59  bareau
// Updated copyright notice.
//
// Revision 1.4  1998/02/24 18:33:37  bareau
// Changed the root node of generated trees as ASTCompilationUnit,
// with package "adltest".
//
// Revision 1.3  1998/02/12 16:03:59  mallet
// Fixed copyright notice: TOG RI -> TOG, year extended to 1998 for TOG
// and IPA.
//
// Revision 1.2  1998/01/08 16:32:49  bareau
// Version OK for bank/stock examples.
// Need more comments.
//
// Revision 1.1  1997/12/19 15:18:02  bareau
// Reorganisation of the translator package, with subpackages
// (only the "j" subdirectory for now).
// Added Makefiles.
//
// ***********************************************************************
