// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
// 
// ***********************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/ORG/opengroup/adl/translators/j/NameAux.java,v $
// $Revision: 1.5 $
// $Date: 1998/03/19 17:27:43 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   translators.j
// NAME:        NameAux
//
// HISTORY:
//      Cyrille Bareau, The Open Group RI - Dec 23, 1997: Created
//      See Log at end of file
//
// ***********************************************************************

package ORG.opengroup.adl.translators.j;

import ORG.opengroup.adl.parsers.adljava.*;

/**
 * Auxiliary class that gathers static methods to deal with file names,
 * notably with imported features ("use" clause).
 * @author Cyrille Bareau
 */

public class NameAux {

  /** The name of the processed tdd class */
  private static String compilUnitName;


  /**
    * Initializes the compilUnitName field.
    */
  public static void setFileName(String name) {

    compilUnitName = name;
  }


//   /**
//     * Builds the qualified name of the file that implements the feature
//     * (dataset or factory) described by the parameters.
//     * <BR>Examples:<UL>
//     * <LI>Case of an imported dataset:
//     * makeQualifiedName("S_", "pack.tdd1.DS3") returns "pack.S_tdd1_DS3"
//     * <LI>Case of a local dataset (tddclass "MyTdd"):
//     * makeQualifiedName("S_", "DS1") returns "S_MyTdd_DS1"
//     * </UL>
//     * @param prefix "F_" for a factory, "S_" for a dataset.
//     * @param name the feature name, qualified if imported.
//     * @return the built file name
//     */
//   public static String makeQualifiedName(String prefix, String name) {

//     int lastdot = name.lastIndexOf('.');
//     if (lastdot == -1) { // no import
//       return prefix + compilUnitName + "_" + name;
//     }

//     String fileName = name.substring(0, lastdot),
//       featureName = name.substring(lastdot+1);
//     int lastdot2 = fileName.lastIndexOf('.');

//     if (lastdot2 == -1) { // no package name
//       return prefix + fileName + "_" + featureName;
//     }

//     String packageName = name.substring(0, lastdot2);
//     fileName = name.substring(lastdot2+1, lastdot);
//     return packageName + "." + prefix + fileName + "_" + featureName;
//   }


  public static String makeQualifiedName(String prefix,
                                         String TDDClassName,
                                         String featureName) {

    return prefix + TDDClassName + "_" + featureName;
  }

}

// ***********************************************************************
// History Log:
// $Log: NameAux.java,v $
// Revision 1.5  1998/03/19 17:27:43  bareau
// Integration of the "use" clause (just a different call to
// NameAux.makeQuailfiedName).
//
// Revision 1.4  1998/02/27 13:08:01  bareau
// Updated copyright notice.
//
// Revision 1.3  1998/02/12 16:04:01  mallet
// Fixed copyright notice: TOG RI -> TOG, year extended to 1998 for TOG
// and IPA.
//
// Revision 1.2  1998/01/21 16:23:56  bareau
// Javadoc comments + a few bug fixes.
//
// Revision 1.1  1998/01/08 16:30:35  bareau
// Auxiliary class to deal with file names.
//
// ***********************************************************************
