// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
//
// ***********************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/ORG/opengroup/adl/unparsers/StringTool.java,v $
// $Revision: 1.3 $
// $Date: 1998/02/27 13:02:53 $
// PRODUCT:     Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:   ADL Compiler
// NAME:        StringTool.java
//
// HISTORY:
//      Cyril Inard d'Argence, The Open Group RI - Jan 28, 1998: Created
//      See Log at end of file
//
// ***********************************************************************

package ORG.opengroup.adl.unparsers;

import java.util.Vector;
import java.util.Enumeration;
import java.util.StringTokenizer;

/** 
 * StringTool supplies methods to manipulates strings.
 */
public final class StringTool
{

  /**
   * Join the separate strings obtained by applying toString() to each
   * element in enumaration e and appending suffix to each of them into
   * a single string with fields separated by the value of separator.
   * @param objectss enumeration of objects whose string representation is 
   *                 to be used.
   * @param suffix   suffix to add to each separate string.
   * @param separator string to use as a separator
   * @return the resulting string.
   */

  public final static String join(Enumeration objects,
                                  String suffix,
                                  String separator)
  {
     StringBuffer ret = new StringBuffer();
     if ( objects.hasMoreElements() )
     {
        ret.append(objects.nextElement() + suffix);
     }
     while ( objects.hasMoreElements() )
     {
        ret.append(separator + objects.nextElement() + suffix);
     }
     return ret.toString();
  }

}

// ***********************************************************************
// History Log:
// $Log: StringTool.java,v $
// Revision 1.3  1998/02/27 13:02:53  cinard
// Updated copyright notice.
//
// Revision 1.2  1998/02/12 16:04:05  mallet
// Fixed copyright notice: TOG RI -> TOG, year extended to 1998 for TOG
// and IPA.
//
// Revision 1.1  1998/02/10 14:33:14  cinard
// StringTool supplies methods to manipulates strings.
//
// ***********************************************************************
