//*****************************************************************************
// File Generated by ADLT Version 2.0
//
//        Name: bankACO.cpp
//       ident: $Id: bankACO.cpp,v 1.3 1998/05/28 15:41:15 mallet Exp $
//     $Source: /vobstore/cvsstore/adl/adl2/src/examples/cpp/bank_example/adl_test/bankACO.cpp,v $
//   $Revision: 1.3 $
//       $Date: 1998/05/28 15:41:15 $
//    ADL file: bank.adl
//
//
//*****************************************************************************

#include "bankACO.hh"
#include "ADLResultCodes.h"
#include "ADLString.hh"

bank *bankACO::new_bank() {
  bank *returned_bank = NULL;

  bool doReport = finalJournalReporting && debugMode;
  
  bool abnormal        = false;
  bool normal          = true;
  bool tddRes          = false;
  skipAssertions |= testContext->skipAssertions;

  if (doReport) { // when nested through inheritance, don't report
    testContext->setblock();
    testContext->infoline("*** Checking bank::bank ***");
  }

  bool wasThrownException = false;
  void *thrownException = NULL;
  if (!skipAssertions) {
    try {
      returned_bank = new bank();
    }
    catch (...) {
      testContext->infoline("Unknown Exception Caught when calling bank::bank");
      testContext->result(ADL_UNRESOLVED);
      
      // now set skipAssertions to not evaluate remaining code
      // and inform potential subclass callers to not evaluate
      // their assertions as well.
      skipAssertions = true;
      
      // set skipAssertions in testContext as well for remaining
      // test instructions to be skipped.
      testContext->skipAssertions = true;
    }
  }

  testContext->assertionStart("get_max_accounts() == maxAccountsDefault");
  if (!skipAssertions) {
    long tmp_1 = returned_bank->get_max_accounts();
    long tmp_2 = maxAccountsDefault;
    
    tddRes = (tmp_1 == tmp_2);

    if (debugMode) {
      // report on each sub-expression
      testContext->infoline(adlstr.reset() << "get_max_accounts()\t-> " << tmp_1);
      testContext->infoline(adlstr.reset() << "maxAccountsDefault\t-> " <<tmp_2);
      testContext->infoline(adlstr.reset() << "get_max_accounts() == maxAccountsDefault\t-> " << tddRes);
    }
    testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
  } else {
    testContext->assertionResult(ADL_UNEVALUATED);
  }

  testContext->assertionStart("get_active_accounts() == 0");
  if (!skipAssertions) {
    long tmp_1 = returned_bank->get_active_accounts();
    
    tddRes = (tmp_1 == 0);

    if (debugMode) {
      // report on each sub-expression
      testContext->infoline(adlstr.reset() << "get_active_accounts()\t-> " << tmp_1);
      testContext->infoline(adlstr.reset() << "get_active_accounts() == 0\t-> " << tddRes);
    }
    testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
  } else {
    testContext->assertionResult(ADL_UNEVALUATED);
  }

  if (wasThrownException) throw;

  return returned_bank;
}

bank *bankACO::new_bank(int bankSize) {
  bank *returned_bank = NULL;

  bool doReport = finalJournalReporting && debugMode;
  
  bool abnormal        = false;
  bool normal          = true;
  bool tddRes          = false;
  skipAssertions |= testContext->skipAssertions;

  if (doReport) { // when nested through inheritance, don't report
    testContext->setblock();
    testContext->infoline("*** Checking bank::bank ***");
    testContext->infoline(adlstr.reset() << "\tint bankSize = " << bankSize);
  }

  bool wasThrownException = false;
  void *thrownException = NULL;
  if (!skipAssertions) {
    try {
      returned_bank = new bank(bankSize);
    }
    catch (...) {
      testContext->infoline("Unknown Exception Caught when calling bank::bank");
      testContext->result(ADL_UNRESOLVED);
      
      // now set skipAssertions to not evaluate remaining code
      // and inform potential subclass callers to not evaluate
      // their assertions as well.
      skipAssertions = true;
      
      // set skipAssertions in testContext as well for remaining
      // test instructions to be skipped.
      testContext->skipAssertions = true;
    }
  }

  if (bankSize <= 0) {
    testContext->assertionStart("get_max_accounts() == maxAccountsDefault");
    if (!skipAssertions) {
      long tmp_1 = returned_bank->get_max_accounts();
      long tmp_2 = maxAccountsDefault;
      
      tddRes = (tmp_1 == tmp_2);
      
      if (debugMode) {
	// report on each sub-expression
	testContext->infoline(adlstr.reset() << "get_max_accounts()\t-> " << tmp_1);
	testContext->infoline(adlstr.reset() << "maxAccountsDefault\t-> " <<tmp_2);
	testContext->infoline(adlstr.reset() << "get_max_accounts() == maxAccountsDefault\t-> " << tddRes);
      }
      testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
    } else {
      testContext->assertionResult(ADL_UNEVALUATED);
    }
  }
  else {
    testContext->assertionStart("get_max_accounts() == bankSize");
    if (!skipAssertions) {
      long tmp_1 = returned_bank->get_max_accounts();
      long tmp_2 = bankSize;
      
      tddRes = (tmp_1 == tmp_2);
      
      if (debugMode) {
	// report on each sub-expression
	testContext->infoline(adlstr.reset() << "get_max_accounts()\t-> " << tmp_1);
	testContext->infoline(adlstr.reset() << "bankSize\t-> " <<tmp_2);
	testContext->infoline(adlstr.reset() << "get_max_accounts() == bankSize\t-> " << tddRes);
      }
      testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
    } else {
      testContext->assertionResult(ADL_UNEVALUATED);
    }
  }

  testContext->assertionStart("get_active_accounts() == 0");
  if (!skipAssertions) {
    long tmp_1 = returned_bank->get_active_accounts();
    
    tddRes = (tmp_1 == 0);

    if (debugMode) {
      // report on each sub-expression
      testContext->infoline(adlstr.reset() << "get_active_accounts()\t-> " << tmp_1);
      testContext->infoline(adlstr.reset() << "get_active_accounts() == 0\t-> " << tddRes);
    }
    testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
  } else {
    testContext->assertionResult(ADL_UNEVALUATED);
  }

  if (wasThrownException) throw;

  return returned_bank;
}

bankAccount *bankACO::find_account(long acctNumber)
  throw (accountNotFoundExc) {

  // following cast is safe, we know that the realObject is an
  // instanceof bank.
  bank *bankObject = (bank *)realObject;
    
  // locally saved value of finalJournalReporting
  bool doReport = finalJournalReporting && debugMode;
    
  bool abnormal        = false;
  bool normal          = true;
  bool tddRes          = false;
  skipAssertions |= testContext->skipAssertions || (realObject == NULL);

  if (doReport) { // when nested through inheritance, don't report
    testContext->setblock();
    testContext->infoline("*** Checking bank::find_account ***");
    testContext->infoline(adlstr.reset() << "\tlong acctNumber = " << acctNumber);
  }

  bool wasThrownException = false;
  void *thrownException = NULL;
  bool wasThrown_accountNotFoundExc = false;
  accountNotFoundExc *thrown_accountNotFoundExc = NULL;
	
  // execute function under test
  bankAccount *returned_bankAccount = NULL;
    
  if (!skipAssertions) {
    try {
      returned_bankAccount = bankObject->find_account(acctNumber);
    }
    catch (accountNotFoundExc& find_accountExc) {
      wasThrownException = true;
      thrownException = &find_accountExc;
      wasThrown_accountNotFoundExc = true;
      thrown_accountNotFoundExc = &find_accountExc;
    }
    catch (...) {
      testContext->infoline("Unknown Exception Caught when calling bank::find_account");
      testContext->result(ADL_UNRESOLVED);
      
      // now set skipAssertions to not evaluate remaining code
      // and inform potential subclass callers to not evaluate
      // their assertions as well.
      skipAssertions = true;
	
      // set skipAssertions in testContext as well for remaining
      // test instructions to be skipped.
      testContext->skipAssertions = true;
    }

      // if we had support for RTTI, that's the way we would go
//       abnormal = ((typeid(accountNotFoundExc) == typeid(*thrownException))
// 		  || (typeid(accountNotFoundExc).before(typeid(*thrownException))));
      // abnormal = (dynamic_cast<accountNotFoundExc *>(thrownException) != NULL);
    abnormal = wasThrown_accountNotFoundExc;
    normal = !abnormal;
  }

  if (normal) {
    testContext->assertionStart("return != NULL && return->get_account_number() == acctNumber");
    if (!skipAssertions) {
      bool tmp_1 = (returned_bankAccount != NULL);
      long tmp_2 = (tmp_1 ? returned_bankAccount->get_account_number() : 0);
      bool tmp_3 = (tmp_2 == acctNumber);
      
      tddRes = ( tmp_1 && tmp_3);
      
      if (debugMode) {
	// report on each sub-expression
	testContext->infoline(adlstr.reset() << "return\t-> " << returned_bankAccount);
	testContext->infoline(adlstr.reset() << "return != NULL\t-> " << tmp_1);
	testContext->infoline(adlstr.reset() << "return->get_account_number()\t-> " << tmp_2);
	testContext->infoline(adlstr.reset() << "acctNumber-> " << acctNumber);
	testContext->infoline(adlstr.reset() << "return->get_account_number() == acctNumber\t-> " << tmp_3);
	testContext->infoline(adlstr.reset() << "return != NULL && return->get_account_number() == acctNumber\t-> " << tddRes);
      }
      testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
    } else {
      testContext->assertionResult(ADL_UNEVALUATED);
    }
  }

  if (wasThrownException) throw;

  return returned_bankAccount;
}


bankAccount *bankACO::open_account(long amount, long &acctNum)
  throw (negativeAmountExc, bankFullExc) {
  
  // following cast is safe, we know that the realObject is an
  // instanceof bank.
  bank *bankObject = (bank *)realObject;

  // locally saved value of finalJournalReporting
  bool doReport = finalJournalReporting && debugMode;
    
  bool abnormal        = false;
  bool normal          = true;
  bool tddRes          = false;
  skipAssertions |= testContext->skipAssertions || (realObject == NULL);

  // Saved state checked in assertions
  bool sav_bank_is_full = false;
  int sav_get_active_accounts = 0;
  if (!skipAssertions) {
    sav_bank_is_full = bank_is_full(*bankObject);
    // lm - 7/10/97
    // the following saved state comes from both assertion 5 and 7
    sav_get_active_accounts = bankObject->get_active_accounts();
  }
    
  if (doReport) { // when nested through inheritance, don't report
    testContext->setblock();
    testContext->infoline("*** Checking bank::open_account ***");
    testContext->infoline(adlstr.reset() << "\tlong amount = " << amount);
  }
    
  bool wasThrownException = false;
  void *thrownException = NULL;
  bool wasThrown_negativeAmountExc = false;
  negativeAmountExc *thrown_negativeAmountExc = NULL;
  bool wasThrown_bankFullExc = false;
  bankFullExc *thrown_bankFullExc = NULL;

  // execute function under test
  bankAccount *returned_bankAccount = NULL;
	
  if (!skipAssertions) {
    try {
      returned_bankAccount = bankObject->open_account(amount, acctNum);
    }
    catch (negativeAmountExc& open_accountExc) {
      wasThrownException = true;
      thrownException = &open_accountExc;
      wasThrown_negativeAmountExc = true;
      thrown_negativeAmountExc = &open_accountExc;
    }
    catch (bankFullExc& open_accountExc) {
      wasThrownException = true;
      thrownException = &open_accountExc;
      wasThrown_bankFullExc = true;
      thrown_bankFullExc = &open_accountExc;
    }
    catch (...) {
      testContext->infoline("Unknown Exception Caught when calling bank::open_account");
      testContext->result(ADL_UNRESOLVED);
      
      // now set skipAssertions to not evaluate remaining code
      // and inform potential subclass callers to not evaluate
      // their assertions as well.
      skipAssertions = true;
	
      // set skipAssertions in testContext as well for remaining
      // test instructions to be skipped.
      testContext->skipAssertions = true;
    }
	 
    // evaluation of the abnormal clause
    abnormal = (wasThrown_negativeAmountExc || wasThrown_bankFullExc);

    // evaluation of the normal clause
    normal = !abnormal;
  }

  // *** ASSERTION 1 ***
  testContext->assertionStart("@amount < 0 <:> thrown(negativeAmountExc)");
  if (!skipAssertions) {
    bool tmp_1 = (amount < 0);
    bool tmp_2 = wasThrown_negativeAmountExc;
      
    tddRes = ((!tmp_1 || abnormal) && 
	      (!(abnormal && tmp_2) || tmp_1));
      
    if (debugMode) {
      // report on each sub-expression
      testContext->infoline(adlstr.reset() << "@amount\t-> " << amount);
      testContext->infoline(adlstr.reset() << "@amount < 0\t-> " << tmp_1);
      testContext->infoline(adlstr.reset() << "thrown(negativeAmountExc)\t-> " << tmp_2);
      testContext->infoline(adlstr.reset() << "@amount < 0 <:> thrown(negativeAmountExc)\t-> " << tddRes);
    }
    testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
  } else {
    testContext->assertionResult(ADL_UNEVALUATED);
  }

  // *** ASSERTION 2 ***
  testContext->assertionStart("@bank_is_full (this) <:> thrown(bankFullExc)");
  if (!skipAssertions) {
    bool tmp_1 = sav_bank_is_full;
    bool tmp_2 = wasThrown_bankFullExc;
      
    tddRes = ((!tmp_1 || abnormal) &&
	      (!(abnormal && tmp_2) || tmp_1));
      
    if (debugMode) {
      // report on each sub-expression
      testContext->infoline(adlstr.reset() << "@bank_is_full (this)\t-> " << tmp_1);
      testContext->infoline(adlstr.reset() << "thrown(bankFullExc)\t-> " << tmp_2);
      testContext->infoline(adlstr.reset() << "@bank_is_full (this) <:> thrown(bankFullExc)\t-> " << tddRes);
    }
    testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
  } else {
    testContext->assertionResult(ADL_UNEVALUATED);
  }

  if (normal) {
    // *** ASSERTION 3 ***
    testContext->assertionStart("return->get_balance() == amount");
    if (!skipAssertions) {
      long tmp_1 = returned_bankAccount->get_balance();

      tddRes = (tmp_1 == amount);
	
      if (debugMode) {
	// report on each sub-expression
	testContext->infoline(adlstr.reset() << "return->get_balance()\t-> " << tmp_1);
	testContext->infoline(adlstr.reset() << "amount\t-> " << amount);
	testContext->infoline(adlstr.reset() << "return->get_balance() == amount\t-> " << tddRes);
      }
      testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
    } else {
      testContext->assertionResult(ADL_UNEVALUATED);
    }
	  
    // *** ASSERTION 4 ***
    testContext->assertionStart("return->get_account_number() == acctNum");
    if (!skipAssertions) {
      long tmp_1 = returned_bankAccount->get_account_number();
	
      tddRes = (tmp_1 == acctNum);

      if (debugMode) {
	// report on each sub-expression
	testContext->infoline(adlstr.reset() << "return->get_account_number()\t-> " << tmp_1);
	testContext->infoline(adlstr.reset() << "acctNum\t-> " << acctNum);
	testContext->infoline(adlstr.reset() << "return->get_account_number() == acctNum\t-> " << tddRes);
      }
      testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
    } else {
      testContext->assertionResult(ADL_UNEVALUATED);
    }

    // *** ASSERTION 5 ***
    testContext->assertionStart("get_active_accounts() == @get_active_accounts() + 1");
    if (!skipAssertions) {
      int tmp_1 = bankObject->get_active_accounts();
      int tmp_2 = sav_get_active_accounts;
      int tmp_3 = tmp_2 + 1;
	
      tddRes = (tmp_1 == tmp_3);
	
      if (debugMode) {
	// report on each sub-expression
	testContext->infoline(adlstr.reset() << "get_active_accounts()\t-> " << tmp_1);
	testContext->infoline(adlstr.reset() << "@get_active_accounts()\t-> " << tmp_2);
	testContext->infoline(adlstr.reset() << "@get_active_accounts() + 1\t-> " << tmp_3);
	testContext->infoline(adlstr.reset() << "get_active_accounts() == @get_active_accounts() + 1\t-> " << tddRes);
      }
      testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
    } else {
      testContext->assertionResult(ADL_UNEVALUATED);
    }

    // *** ASSERTION 6 ***
    testContext->assertionStart("is_account_active (this,acctNum) == true");
    if (!skipAssertions) {
      bool tmp_1 = is_account_active(*bankObject, acctNum);
	
      tddRes = (tmp_1 == true);
	
      if (debugMode) {
	// report on each sub-expression
	testContext->infoline(adlstr.reset() << "is_account_active (this,acctNum)\t-> " << tmp_1);
	testContext->infoline(adlstr.reset() << "is_account_active (this,acctNum) == true\t-> " << tddRes);
      }
      testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
    } else {
      testContext->assertionResult(ADL_UNEVALUATED);
    }
  }
    
  if (abnormal) {
    // *** ASSERTION 7 ***
    testContext->assertionStart("unchanged(get_active_accounts())");
    if (!skipAssertions) {
      int tmp_1 = sav_get_active_accounts;
      int tmp_2 = bankObject->get_active_accounts();

      tddRes = (tmp_1 == tmp_2);
	
      if (debugMode) {
	// report on each sub-expression
	testContext->infoline(adlstr.reset() << "@get_active_accounts()\t-> " << tmp_1);
	testContext->infoline(adlstr.reset() << "get_active_accounts()\t-> " << tmp_2);
	testContext->infoline(adlstr.reset() << "unchanged(get_active_accounts())\t-> " << tddRes);
      }
      testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
    } else {
      testContext->assertionResult(ADL_UNEVALUATED);
    }
  }	
	
  // propagate thrown exception
  if (wasThrownException) throw;

  return returned_bankAccount;
}

void bankACO::close_account (long acctNumber)
    throw (accountNotFoundExc, accountNotZeroExc, invalidAccountExc) {

  // following cast is safe, we know that the realObject is an
  // instanceof bank.
  bank *bankObject = (bank *)realObject;
  
  // locally saved value of finalJournalReporting
  bool doReport = finalJournalReporting && debugMode;
  
  bool abnormal        = false;
  bool normal          = true;
  bool tddRes          = false;
  skipAssertions |= testContext->skipAssertions || (realObject == NULL);
  
  // Saved state checked in assertions
  bool sav_tmp_109 = false;
  bool sav_tmp_113 = false;
  bool sav_tmp_117 = false;
  int sav_get_active_accounts = 0;
  if (!skipAssertions) {
    sav_tmp_109 = ((acctNumber < 1) || (acctNumber >=  bankObject->get_max_accounts()));
    sav_tmp_113 = is_account_active(*bankObject, acctNumber);
    sav_tmp_117 = is_account_zero(*bankObject, acctNumber) ;
    sav_get_active_accounts = bankObject->get_active_accounts();
  }
  
  
  if (doReport) { // when nested through inheritance, don't report
    testContext->setblock();
    testContext->infoline("*** Checking bank::close_account ***");
    testContext->infoline(adlstr.reset() << "\tlong acctNumber = " << acctNumber);
  }
  
  bool wasThrownException = false;
  void *thrownException = NULL;
  bool wasThrown_accountNotFoundExc = false;
  accountNotFoundExc *thrown_accountNotFoundExc = NULL;
  bool wasThrown_accountNotZeroExc = false;
  accountNotZeroExc *thrown_accountNotZeroExc = NULL;
  bool wasThrown_invalidAccountExc = false;
  invalidAccountExc *thrown_invalidAccountExc = NULL;

  // execute function under test
  
  if (!skipAssertions) {
    try {
      bankObject->close_account(acctNumber);
    }
    catch (accountNotFoundExc& close_accountExc) {
      wasThrownException = true;
      thrownException = &close_accountExc;
      wasThrown_accountNotFoundExc = true;
      thrown_accountNotFoundExc = &close_accountExc;
    }
    catch (accountNotZeroExc& close_accountExc) {
	wasThrownException = true;
	thrownException = &close_accountExc;
	wasThrown_accountNotZeroExc = true;
	thrown_accountNotZeroExc = &close_accountExc;
    }
    catch (invalidAccountExc& close_accountExc) {
      wasThrownException = true;
      thrownException = &close_accountExc;
      wasThrown_invalidAccountExc = true;
      thrown_invalidAccountExc = &close_accountExc;
    }
    catch (...) {
      testContext->infoline("Unknown Exception Caught when calling bank::close_account");
      testContext->result(ADL_UNRESOLVED);
      
      // now set skipAssertions to not evaluate remaining code
      // and inform potential subclass callers to not evaluate
      // their assertions as well.
      skipAssertions = true;
      
      // set skipAssertions in testContext as well for remaining
      // test instructions to be skipped.
      testContext->skipAssertions = true;
    }
	 
    // evaluation of the abnormal clause
    abnormal = (wasThrown_accountNotFoundExc || wasThrown_accountNotZeroExc || wasThrown_invalidAccountExc);
    
    // evaluation of the normal clause
    normal = !abnormal;
  }
	
  // *** ASSERTION 1 ***
  testContext->assertionStart("@(acctNumber < 1 || acctNumber >=  get_max_accounts()) <:> thrown(invalidAccountExc)");
  if (!skipAssertions) {
    bool tmp_1 = sav_tmp_109;
    bool tmp_2 = wasThrown_invalidAccountExc;

    tddRes = ((!tmp_1 || abnormal) &&
	      (!(abnormal && tmp_2) || tmp_1));
    
    if (debugMode) {
      // report on each sub-expression
      // we cannot breakdown a call-state expression (at least for now)
      testContext->infoline(adlstr.reset() << "@(acctNumber < 1 || acctNumber >=  get_max_accounts())\t-> " << tmp_1);
      testContext->infoline(adlstr.reset() << "thrown(invalidAccountExc)\t-> " << tmp_2);
      testContext->infoline(adlstr.reset() << "@(acctNumber < 1 || acctNumber >=  get_max_accounts()) <:> thrown(invalidAccountExc)\t-> " << tddRes);
    }
    testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
  } else {
    testContext->assertionResult(ADL_UNEVALUATED);
  }

  // *** ASSERTION 2 ***
  testContext->assertionStart("@is_account_active (this,acctNumber) == false <:> thrown(accountNotFoundExc)");
  if (!skipAssertions) {
    bool tmp_1 = sav_tmp_113;
    bool tmp_2 = (tmp_1 == false);
    bool tmp_3 = wasThrown_accountNotFoundExc;
    
    tddRes = ((!tmp_2 || abnormal) &&
	      (!(abnormal && tmp_3) || tmp_2));
    
    if (debugMode) {
      // report on each sub-expression
      testContext->infoline(adlstr.reset() << "@is_account_active (this,acctNumber)\t-> " << tmp_1);
      testContext->infoline(adlstr.reset() << "@is_account_active (this,acctNumber) == false\t-> " << tmp_2);
      testContext->infoline(adlstr.reset() << "thrown(accountNotFoundExc)\t-> " << tmp_3);
      testContext->infoline(adlstr.reset() << "@is_account_active (this,acctNumber) == false <:> thrown(accountNotFoundExc)\t-> " << tddRes);
    }
    testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
  } else {
    testContext->assertionResult(ADL_UNEVALUATED);
  }

  // *** ASSERTION 3 ***
  testContext->assertionStart("@is_account_zero (this, acctNumber)  == false <:> thrown(accountNotZeroExc)");
  if (!skipAssertions) {
    bool tmp_1 = sav_tmp_117;
    bool tmp_2 = (tmp_1 == false);
    bool tmp_3 = wasThrown_accountNotZeroExc;
    
    tddRes = ((!tmp_2 || abnormal) &&
	      (!(abnormal && tmp_3) || tmp_2));
    
    if (debugMode) {
      // report on each sub-expression
      testContext->infoline(adlstr.reset() << "@is_account_zero (this, acctNumber)\t-> " << tmp_1);
      testContext->infoline(adlstr.reset() << "@is_account_zero (this, acctNumber) == false\t-> " << tmp_2);
      testContext->infoline(adlstr.reset() << "@is_account_zero (this, acctNumber) == false <:> thrown(accountNotZeroExc)\t-> " << tddRes);
    }
    testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
  } else {
    testContext->assertionResult(ADL_UNEVALUATED);
  }
      
  if (abnormal) {
    // *** ASSERTION 4 ***
    testContext->assertionStart("unchanged(get_active_accounts())");
    if (!skipAssertions) {
      int tmp_1 = sav_get_active_accounts;
      int tmp_2 = bankObject->get_active_accounts();

      tddRes = (tmp_1 == tmp_2);
      
      if (debugMode) {
	// report on each sub-expression
	testContext->infoline(adlstr.reset() << "@get_active_accounts()\t-> " << tmp_1);
	testContext->infoline(adlstr.reset() << "get_active_accounts()\t-> " << tmp_2);
	testContext->infoline(adlstr.reset() << "unchanged(get_active_accounts())\t-> " << tddRes);
      }
      testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
    } else {
      testContext->assertionResult(ADL_UNEVALUATED);
    }
  }

  if (normal) {
    // *** ASSERTION 5 ***
    testContext->assertionStart("get_active_accounts() == @get_active_accounts() - 1");
    if (!skipAssertions) {
      int tmp_1 = bankObject->get_active_accounts();
      int tmp_2 = sav_get_active_accounts;
      int tmp_3 = tmp_2 - 1;
      
      tddRes = (tmp_1 == tmp_3);
      
      if (debugMode) {
	// report on each sub-expression
	testContext->infoline(adlstr.reset() << "get_active_accounts()\t-> " << tmp_1);
	testContext->infoline(adlstr.reset() << "@get_active_accounts()\t-> " << tmp_2);
	testContext->infoline(adlstr.reset() << "@get_active_accounts() - 1\t-> " << tmp_3);
	testContext->infoline(adlstr.reset() << "get_active_accounts() == @get_active_accounts() - 1\t-> " << tddRes);
      }
      testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
    } else {
      testContext->assertionResult(ADL_UNEVALUATED);
    }

    // *** ASSERTION 6 ***
    testContext->assertionStart("is_account_active(this,acctNumber) == false");
    if (!skipAssertions) {
      bool tmp_1 = is_account_active(*bankObject, acctNumber);
	    
      tddRes = (tmp_1 == false);
      
      if (debugMode) {
	// report on each sub-expression
	testContext->infoline(adlstr.reset() << "acctNumber\t-> " << acctNumber);
	testContext->infoline(adlstr.reset() << "is_account_active (this,acctNumber)\t-> " << tmp_1);
	testContext->infoline(adlstr.reset() << "is_account_active (this,acctNumber) == false\t-> " << tddRes);
      }
      testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
    } else {
      testContext->assertionResult(ADL_UNEVALUATED);
    }
  }

  // propagate thrown exception
  if (wasThrownException) throw;
}

void bankACO::close_account (bankAccount *ba)
    throw (accountNotZeroExc, invalidAccountExc) {

  // following cast is safe, we know that the realObject is an
  // instanceof bank.
  bank *bankObject = (bank *)realObject;
  
  // locally saved value of finalJournalReporting
  bool doReport = finalJournalReporting && debugMode;
  
  bool abnormal        = false;
  bool normal          = true;
  bool tddRes          = false;
  skipAssertions |= testContext->skipAssertions || (realObject == NULL);
  
  // Saved state checked in assertions
  long sav_tmp_138 = 0;
  bool sav_tmp_158 = false;
  bool sav_tmp_162 = false;
  bool sav_tmp_166 = false;
  int sav_get_active_accounts = 0;
  if (!skipAssertions) {
    sav_tmp_138 = (ba != NULL) ? ba->get_account_number() : -1L;
    sav_tmp_158 = (ba == NULL || (sav_tmp_138 < 1) || (sav_tmp_138 >=  bankObject->get_max_accounts()));
    sav_tmp_162 = is_account_active(*bankObject, sav_tmp_138);
    sav_tmp_166 = is_account_zero(*bankObject, sav_tmp_138) ;
    sav_get_active_accounts = bankObject->get_active_accounts();
  }
  
  
  if (doReport) { // when nested through inheritance, don't report
    testContext->setblock();
    testContext->infoline("*** Checking bank::close_account ***");
    testContext->infoline(adlstr.reset() << "\tbankAccount *ba = " << ba);
  }
  
  bool wasThrownException = false;
  void *thrownException = NULL;
  bool wasThrown_accountNotZeroExc = false;
  accountNotZeroExc *thrown_accountNotZeroExc = NULL;
  bool wasThrown_invalidAccountExc = false;
  invalidAccountExc *thrown_invalidAccountExc = NULL;

  // execute function under test
  
  if (!skipAssertions) {
    try {
      bankObject->close_account(ba);
    }
    catch (accountNotZeroExc& close_accountExc) {
	wasThrownException = true;
	thrownException = &close_accountExc;
	wasThrown_accountNotZeroExc = true;
	thrown_accountNotZeroExc = &close_accountExc;
    }
    catch (invalidAccountExc& close_accountExc) {
      wasThrownException = true;
      thrownException = &close_accountExc;
      wasThrown_invalidAccountExc = true;
      thrown_invalidAccountExc = &close_accountExc;
    }
    catch (...) {
      testContext->infoline("Unknown Exception Caught when calling bank::close_account");
      testContext->result(ADL_UNRESOLVED);
      
      // now set skipAssertions to not evaluate remaining code
      // and inform potential subclass callers to not evaluate
      // their assertions as well.
      skipAssertions = true;
      
      // set skipAssertions in testContext as well for remaining
      // test instructions to be skipped.
      testContext->skipAssertions = true;
    }
	 
    // evaluation of the abnormal clause
    abnormal = (wasThrown_accountNotZeroExc || wasThrown_invalidAccountExc);
    
    // evaluation of the normal clause
    normal = !abnormal;
  }
	
  // *** ASSERTION 1 ***
  testContext->assertionStart("@(ba == NULL || acct_num(ba) < 1 || acct_num(ba) > get_max_accounts()) <:> thrown(invalidAccountExc)");
  if (!skipAssertions) {
    bool tmp_1 = sav_tmp_158;
    bool tmp_2 = wasThrown_invalidAccountExc;

    tddRes = ((!tmp_1 || abnormal) &&
	      (!(abnormal && tmp_2) || tmp_1));
    
    if (debugMode) {
      // report on each sub-expression
      // we cannot breakdown a call-state expression (at least for now)
      testContext->infoline(adlstr.reset() << "@(ba == NULL || acct_num(ba) < 1 || acct_num(ba) > get_max_accounts())\t-> " << tmp_1);
      testContext->infoline(adlstr.reset() << "thrown(invalidAccountExc)\t-> " << tmp_2);
      testContext->infoline(adlstr.reset() << "@(ba == NULL || acct_num(ba) < 1 || acct_num(ba) > get_max_accounts()) <:> thrown(invalidAccountExc)\t-> " << tddRes);
    }
    testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
  } else {
    testContext->assertionResult(ADL_UNEVALUATED);
  }

  // *** ASSERTION 2 ***
  testContext->assertionStart("@is_account_active (this,acct_num(ba)) == false <:> thrown(invalidAccountExc)");
  if (!skipAssertions) {
    bool tmp_1 = sav_tmp_162;
    bool tmp_2 = (tmp_1 == false);
    bool tmp_3 = wasThrown_invalidAccountExc;
    
    tddRes = ((!tmp_2 || abnormal) &&
	      (!(abnormal && tmp_3) || tmp_2));
    
    if (debugMode) {
      // report on each sub-expression
      testContext->infoline(adlstr.reset() << "acct_num(ba)\t-> " << sav_tmp_138);
      testContext->infoline(adlstr.reset() << "@is_account_active (this,acct_num(ba))\t-> " << tmp_1);
      testContext->infoline(adlstr.reset() << "@is_account_active (this,acct_num(ba)) == false\t-> " << tmp_2);
      testContext->infoline(adlstr.reset() << "thrown(invalidAccountExc)\t-> " << tmp_3);
      testContext->infoline(adlstr.reset() << "@is_account_active (this,acct_num(ba)) == false <:> thrown(invalidAccountExc)\t-> " << tddRes);
    }
    testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
  } else {
    testContext->assertionResult(ADL_UNEVALUATED);
  }

  // *** ASSERTION 3 ***
  testContext->assertionStart("@is_account_zero (this,acct_num(ba))  == false <:> thrown(accountNotZeroExc)");
  if (!skipAssertions) {
    bool tmp_1 = sav_tmp_166;
    bool tmp_2 = (tmp_1 == false);
    bool tmp_3 = wasThrown_accountNotZeroExc;
    
    tddRes = ((!tmp_2 || abnormal) &&
	      (!(abnormal && tmp_3) || tmp_2));
    
    if (debugMode) {
      // report on each sub-expression
      testContext->infoline(adlstr.reset() << "acct_num(ba)\t-> " << sav_tmp_138);
      testContext->infoline(adlstr.reset() << "@is_account_zero (this,acct_num(ba))\t-> " << tmp_1);
      testContext->infoline(adlstr.reset() << "@is_account_zero (this,acct_num(ba)) == false\t-> " << tmp_2);
      testContext->infoline(adlstr.reset() << "@is_account_zero (this,acct_num(ba)) == false <:> thrown(accountNotZeroExc)\t-> " << tddRes);
    }
    testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
  } else {
    testContext->assertionResult(ADL_UNEVALUATED);
  }
      
  if (abnormal) {
    // *** ASSERTION 4 ***
    testContext->assertionStart("unchanged(get_active_accounts())");
    if (!skipAssertions) {
      int tmp_1 = sav_get_active_accounts;
      int tmp_2 = bankObject->get_active_accounts();

      tddRes = (tmp_1 == tmp_2);
      
      if (debugMode) {
	// report on each sub-expression
	testContext->infoline(adlstr.reset() << "@get_active_accounts()\t-> " << tmp_1);
	testContext->infoline(adlstr.reset() << "get_active_accounts()\t-> " << tmp_2);
	testContext->infoline(adlstr.reset() << "unchanged(get_active_accounts())\t-> " << tddRes);
      }
      testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
    } else {
      testContext->assertionResult(ADL_UNEVALUATED);
    }
  }

  if (normal) {
    // *** ASSERTION 5 ***
    testContext->assertionStart("get_active_accounts() == @get_active_accounts() - 1");
    if (!skipAssertions) {
      int tmp_1 = bankObject->get_active_accounts();
      int tmp_2 = sav_get_active_accounts;
      int tmp_3 = tmp_2 - 1;
      
      tddRes = (tmp_1 == tmp_3);
      
      if (debugMode) {
	// report on each sub-expression
	testContext->infoline(adlstr.reset() << "get_active_accounts()\t-> " << tmp_1);
	testContext->infoline(adlstr.reset() << "@get_active_accounts()\t-> " << tmp_2);
	testContext->infoline(adlstr.reset() << "@get_active_accounts() - 1\t-> " << tmp_3);
	testContext->infoline(adlstr.reset() << "get_active_accounts() == @get_active_accounts() - 1\t-> " << tddRes);
      }
      testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
    } else {
      testContext->assertionResult(ADL_UNEVALUATED);
    }

    // *** ASSERTION 6 ***
    testContext->assertionStart("is_account_active(this,acct_num(ba)) == false");
    if (!skipAssertions) {
      bool tmp_1 = is_account_active(*bankObject, sav_tmp_138);
	    
      tddRes = (tmp_1 == false);
      
      if (debugMode) {
	// report on each sub-expression
	testContext->infoline(adlstr.reset() << "acct_num(ba)\t-> " << sav_tmp_138);
	testContext->infoline(adlstr.reset() << "is_account_active (this,acct_num(ba))\t-> " << tmp_1);
	testContext->infoline(adlstr.reset() << "is_account_active (this,acct_num(ba)) == false\t-> " << tddRes);
      }
      testContext->assertionResult((tddRes ? ADL_PASS : ADL_FAIL));
    } else {
      testContext->assertionResult(ADL_UNEVALUATED);
    }
  }

  // propagate thrown exception
  if (wasThrownException) throw;
}
