// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// Copyright (c) 1994-1997 Sun Microsystems Inc.
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
// 
// ************************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/examples/cpp/bank_example/bankAux.cpp,v $
// $Revision: 1.2 $
// $Date: 1998/02/27 13:05:36 $
// PRODUCT:	Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:	bank example (C++)
// NAME:	bankAux.cpp
// 	
// HISTORY:
// 	Matt Evans, Sun Microsystems Inc. - Sep 27, 1996: Created
// 		
// ************************************************************************
#include "bankAux.hh"
#include <stream.h>

boolean bank_is_full(bank &b) {

  return (b.get_active_accounts() >= b.get_max_accounts());

}

boolean is_account_active(bank &b, long acctNumber) {

  bankAccount *ba = NULL;

 /* for now  no try blocks with gcc. It gets an internal
    compile error on linux */

  try {
    ba = b.find_account (acctNumber);
  }
  catch (accountNotFoundExc& be) {
    return false;
  }

  if (ba)
    return true;
  else
    return false;

}

boolean is_account_zero(bank &b, long acctNumber) {

  bankAccount *ba = NULL;



 /* for now  no try blocks, gcc gets an internal
    compile error on linux */

  try {
    ba = b.find_account (acctNumber);
  }
  catch (accountNotFoundExc& be) {
    return true;
  }

  if (ba)
    return (ba->get_balance() == 0);

  return false;
}
