//
// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
//  
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
//  
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file
// COPYRIGHT, located in the top directory of this software.
//
//
// ************************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/examples/idl/bank_example/bankAccountImpl.java,v $
// $Revision: 1.3 $
// $Date: 1998/02/27 15:46:30 $
// PRODUCT:	Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:	bank example
// NAME:	      bankAccountImpl.java
// 	
// HISTORY:
// 	Cyril Inard d'Argence, The Open Group - Jan 13, 1998: Created
// 		
// ************************************************************************

package bank_example;

import bank_example.bank_app.*;

/**	
 *  class bankAccountImpl
 *
 */

public class bankAccountImpl extends bank_example.bank_app._bankAccountImplBase {

  private int acct_number;
  private int balance;


  public bankAccountImpl(int acct, int bal)
  {
     acct_number = acct;
     balance     = bal;
  }

  public bankAccountImpl(int acct)
  {
     acct_number = acct;
     balance = 0;
  }

  public int acct_number()
  {
     return acct_number;
  }

  public int balance()
  {
     return balance;
  }

  public int deposit(int amount)
  throws bank_example.bank_app.negativeAmountExc
  {
     if (amount < 0) {
        throw (new negativeAmountExc());
     }
     balance += amount;
     return balance;
  }

  public int withdraw(int amount)
     throws bank_example.bank_app.insufficientFundsExc, bank_example.bank_app.negativeAmountExc
  {
     if (amount < 0) {
        throw (new negativeAmountExc());
     }
     if (balance - amount < 0) {
        throw (new insufficientFundsExc());
     }
     balance -= amount;
     return balance;
  }
}

// ***********************************************************************
// History Log:
// $Log: bankAccountImpl.java,v $
// Revision 1.3  1998/02/27 15:46:30  cinard
// Updated copyright notice.
//
// Revision 1.2  1998/02/12 16:04:15  mallet
// Fixed copyright notice: TOG RI -> TOG, year extended to 1998 for TOG
// and IPA.
//
// Revision 1.1  1998/02/10 17:30:47  cinard
// Implementations for IDL interfaces.
//
// ***********************************************************************

