// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// Copyright (c) 1994-1996 Sun Microsystems Inc.
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
// 
// ************************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/examples/java/bank_example/bankAccount.java,v $
// $Revision: 1.3 $
// $Date: 1998/02/27 10:49:27 $
// PRODUCT:	Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:	bank example
// NAME:	bank.java
// 	
// HISTORY:
// 	Matt Evans, Sun Microsystems Inc. - Sep 27, 1996: Created
// 		
// ************************************************************************

package bank_example;

/**	
 *  class bankAccount
 *
 *  @version 	        $Id: bankAccount.java,v 1.3 1998/02/27 10:49:27 bareau Exp $
 *  @date ctreated      Oct 4, 1996
 *  @author	        Matt Evans
 *
 */

public class bankAccount {

  protected long acct_number;
  protected long balance;

  public bankAccount(long acct, long bal)
    {
      acct_number = acct;
      balance     = bal;
    }

  public bankAccount(long acct)
    {
      acct_number = acct;
      balance = 0;
    }

  public long get_account_number()
    {
      return acct_number;
    }

  public long get_balance()
    {
      return balance;
    }

  public long deposit(long amt)
    throws
      negativeAmountExc

    {
      if (amt < 0) {
	throw (new negativeAmountExc());
      }
      balance += amt;
      return balance;
    }

  public long withdraw(long amt)
   throws
    negativeAmountExc,
    insufficientFundsExc

    {
      if (amt < 0) {
	throw (new negativeAmountExc());
      }
      if (balance - amt < 0) {
	throw (new insufficientFundsExc());
      }
      balance -= amt;
      return balance;
    }
}
