// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
// 
// ************************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/examples/java/stock_example/Product.java,v $
// $Revision: 1.2 $
// $Date: 1998/02/27 10:49:04 $
// PRODUCT:	Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:	stock example
// NAME:	Product.java
// 	
// HISTORY:
// 	Cyrille Bareau, The Open Group RI - Nov 1997: Created
// 		
// ************************************************************************

package stock_example;

public class Product {

  private String myName;
  private int stock;

  public Product(String name, int nb) {
    myName = new String(name);
    stock = nb;
  }

  public Product(String name) {
    myName = new String(name);
    stock = 0;
  }

  public int getPrice() throws UnknownProductExc {
    return ProductsBank.get(myName);
  }

  public String getName() {
    return myName;
  }

  int getStock() {
    return stock;
  }

  void add(int nb) {
    stock += nb;
  }

  void remove(int nb) throws InsufficientStockExc {
    if (stock < nb)
      throw (new InsufficientStockExc());
    else stock -= nb;
  }
}
