// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
// Copyright (c) 1994-1997 Sun Microsystems Inc.
// 
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
// 
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
// 
// ************************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/examples/java/unit/timeUnit.java,v $
// $Revision: 1.5 $
// $Date: 1998/03/10 17:27:18 $
// PRODUCT:	Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:	Unit example (JAVA)
// NAME:	timeUnit.java
// 	
// HISTORY:
// 	Matt Evans, Sun Microsystems Inc. - Sep 27, 1996: Created
// 		
// ************************************************************************
/**	
 *  public class timeUnit
 *
 *  @version 	        @(#)timeUnit.java	1.1 11/19/96
 *  @date created       Nov 4, 1996
 *  @author	        Matt Evans
 *
 */


public abstract class timeUnit extends Unit {

   protected  long  interval;

  public timeUnit (long u, String n) {
	super (u, n);
  }

  public timeUnit (long u, long i, String n) {
	super (u,n);
	interval = i;
   }	

  public timeUnit (timeUnit t) {
	super (t.get_base_units(),t.get_name());
	interval = t.get_interval();
   }

  public timeUnit (String n) {
	super (0,n);
	interval = 0;
   }

   public long get_whole_units() {
	return base_units % interval;
   }

   public double get_real_units() {
     return (double) base_units / interval;

   }
   public long get_interval() {
     return interval;
   }

   public String get_string_value() {
     return (get_real_units() + " " + name);
   }

   public abstract timeUnit convert_to (timeUnit u);


}
