//
// Copyright (c) 1996-1998 Information-technology Promotion Agency, Japan
// Copyright (c) 1996-1998 Mitsubishi Research Institute, Inc.
// Copyright (c) 1996-1998 The Open Group
//
// All rights reserved.
// This technology is a result of the Advanced Software  Enrichment 
// Project of Information-technology Promotion Agency, Japan (IPA).
//
// Permissions  to  use,  copy, modify and distribute this software
// are governed by the terms and conditions set forth in  the  file 
// COPYRIGHT, located in the top directory of this software.
//
// ***********************************************************************
//
// $Source: /vobstore/cvsstore/adl/adl2/src/runtime/cpp/ADLObjectACO.cpp,v $
// $Revision: 1.1 $
// $Date: 1998/06/17 10:13:14 $
// PRODUCT:	Assertion Definition Language Translation System
//              (ADLTS) Version 2.0
// COMPONENT:	C++ Runtime Environment - ACO root class
// NAME:	ADLObjectACO.cpp
// 	
// HISTORY:
//      Lionel Mallet, The Open Group RI  - Oct  26, 1997: Created
//      See Log at end of file
// 		
// ***********************************************************************

#include "ADLObjectACO.hh"

ADLObjectACO::ADLObjectACO(void *object, ADLTest *tc) : realObject(object),
  testContext(tc), finalJournalReporting(true), skipAssertions(false) {
    debugMode = tc->debugMode;
}
// ***********************************************************************
// History Log:
// $Log: ADLObjectACO.cpp,v $
// Revision 1.1  1998/06/17 10:13:14  mallet
// Renamed ObjectACO to ADLObjectACO.
//
// Revision 1.6  1998/05/28 15:42:12  mallet
// Moved initialization of debugMode indicator through getvar into
// ADLTest class.
//
// Revision 1.5  1998/05/12 17:03:19  shane
// Added handling for debugMode where appropriate to match C and Java runtimes.
// Added debugMode to ADLTest class as a public bool.
//
// Revision 1.4  1998/03/03 22:31:29  shane
// Added handling for WIN32-isms.
// Now compiles cleanly on Win32 - don't know if it runs.
//
// Revision 1.3  1998/02/27 10:01:08  mallet
// Updated copyright notice.
//
// Revision 1.2  1998/02/12 16:04:31  mallet
// Fixed copyright notice: TOG RI -> TOG, year extended to 1998 for TOG
// and IPA.
//
// Revision 1.1  1997/11/14 10:13:32  mallet
// Initial version of runtime classes for TDD datasets and ACOs.
//
//
// ***********************************************************************
